#include <stdio.h> //FILE fopen fprintf fclose
#include <string.h> //strcmp



//............................................................................
struct {char *heading; char *string; int ch;} WinMenu[] =
{
  { "Game"  , "Save\\tS"          , 'S'  },
  { "Game"  , "Quit\\tQ"          , 'Q'  },
  { "Game"  , "Version\\tv"       , 'v'  },
  { "Game"  , "Help\\t\?"         , '\?' },

  { "Move"  , "Ascend\\t<"        , '<'  },
  { "Move"  , "Descend\\t>"       , '>'  },
  { "Move"  , "Up-Left\\ty"       , 'y'  },
  { "Move"  , "Up\\tk"            , 'k'  },
  { "Move"  , "Up-Right\\tu"      , 'u'  },
  { "Move"  , "Left\\th"          , 'h'  },
  { "Move"  , "Right\\tl"         , 'l'  },
  { "Move"  , "Down-Left\\tb"     , 'b'  },
  { "Move"  , "Down\\tj"          , 'j'  },
  { "Move"  , "Down-Right\\tn"    , 'n'  },
  { "Move"  , "Move Onto\\tm"     , 'm'  },

  { "Object", "Throw\\tt"         , 't'  },
  { "Object", "Drop\\td"          , 'd'  },
  { "Object", "Pick Up\\t,"       , ','  },
  { "Object", "Inventory\\ti"     , 'i'  },
  { "Object", "Call\\tc"          , 'c'  },

  { "Weapon", "Wield\\tw"         , 'w'  },
  { "Weapon", "Fight\\tf"         , 'f'  },

  { "Armor" , "Take Off\\tT"      , 'T'  },
  { "Armor" , "Wear\\tW"          , 'W'  },

  { "Ring"  , "Remove\\tR"        , 'R'  },
  { "Ring"  , "Put On\\tP"        , 'P'  },
  { "Ring"  , "Left Hand\\tl"     , 'l'  },
  { "Ring"  , "Right Hand\\tr"    , 'r'  },

  { "Action", "Rest\\t."          , '.'  },
  { "Action", "Search\\ts"        , 's'  },
  { "Action", "Identify Trap\\t^" , '^'  },
  { "Action", "Eat Food\\te"      , 'e'  },
  { "Action", "Quaff Potion\\tq"  , 'q'  },
  { "Action", "Read Scroll\\tr"   , 'r'  },
  { "Action", "Zap Wand\\tz"      , 'z'  },

  { "Key"   , "Cancel\\tEsc"      , 27   },
  { "Key"   , "Yes\\ty"           , 'y'  },
  { "Key"   , "No\\tn"            , 'n'  },
  { "Key"   , "Space"             , ' '  },
  { "Key"   , "Enter"             , 13   }
};



int WinMenuSize = (sizeof WinMenu)/(sizeof WinMenu[0]);
//............................................................................



//****************************************************************************
void PrintMenu(FILE *out, char *name, int base_id, int popup_flag)
{
  int i;

  fprintf(out, "%s MENU\n", name);
  fprintf(out, "BEGIN\n");

  if (popup_flag)
  {
    fprintf(out, "POPUP \"Dummy Popup\"\n");
    fprintf(out, "BEGIN\n");
  }

  for (i=0; i<WinMenuSize; i++)
  {
    if (i==0 || strcmp(WinMenu[i].heading, WinMenu[i-1].heading))
    {
      fprintf(out, "  POPUP \"%s\"\n", WinMenu[i].heading);
      fprintf(out, "    BEGIN\n");
    }

    fprintf(out, "      MENUITEM \"%s\" , %i\n", WinMenu[i].string, base_id+WinMenu[i].ch);

    if (i==WinMenuSize-1 || strcmp(WinMenu[i].heading, WinMenu[i+1].heading))
    {
      fprintf(out, "    END\n");
    }
  }

  if (popup_flag)
  {
    fprintf(out, "END\n");
  }

  fprintf(out, "END\n");
}
//****************************************************************************



//############################################################################
int main(void)
{
  FILE *out;

  out = fopen("res.rc", "wb"); if (out==0) return 0;



  fprintf(out, "MyIcon ICON icon.ico\n");
  fprintf(out, "\n\n\n");

  PrintMenu(out, "MyMenu", 2001, 0);
  fprintf(out, "\n\n\n");

  PrintMenu(out, "MyPopupMenu", 2001, 1);
  fprintf(out, "\n\n\n");

  fprintf(out, "MyAccel ACCELERATORS\n");
  fprintf(out, "BEGIN\n");
  fprintf(out, "  121 , 1001 , VIRTKEY\n");
  fprintf(out, "END\n");



  fclose(out);

  return 1;
}
//############################################################################
