// ------------------------------------
// |            TileRogue             |
// | Copyright 2008 by Donnie Russell |
// |                                  |
// |           Version 1.21           |
// ------------------------------------



#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <wingdi.h>
#include <mmreg.h>
#include <dsound.h>

#include <ivorbiscodec.h> //libtremor
#include <ivorbisfile.h> //libtremor

#include "def.h"



#define MYCLASSNAME  "TileRogue"
#define MYTITLE      "TileRogue"

#define CLICK_INTERVAL  200  //milliseconds (default is 300)

#define IS_MENU_OFF  (EnableFullScreen || ShellOn)



//...........................................................................
int IMG_UpsideDownFlag = 1;



int ShellOn = 0;



HINSTANCE hInstance = 0;
HWND hWnd = 0;
HDC hDC = 0;
HBITMAP hBmp = 0;
HDC hMemDC = 0;
HBITMAP hOldBmp = 0;



int shift_on = 0, ctrl_on = 0, virtualkey = 0, altvirtualkey = 0, typedch = 0;
int MouseX = 0, MouseY = 0, MouseB = 0;

int wndproc_enabled = 0;

int LeftMouseButtonClicks = 0;
unsigned long LeftMouseButtonCount = 0;



HCURSOR CursorHandle[9] = {0, 0, 0, 0, 0, 0, 0, 0, 0};

char CursorShape1[32*32+1] =
"................................"
"................................"
"................................"
"................................"
"................................"
"...............1................"
"..............101..............."
".............10001.............."
"............1000001............."
"...........100000001............"
"..........10000000001..........."
".........1111100011111.........."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............10001.............."
".............11111.............."
"................................"
"................................"
"................................"
"................................"
"................................";

char CursorShape2[32*32+1] =
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
".......1111111111..............."
".......100000001................"
".......10000001................."
".......1000001.................."
".......10000001................."
".......100010001................"
".......1001.10001..............."
".......101...10001.............."
".......11.....10001............."
".......1.......10001............"
"................10001..........."
".................10001.........."
"..................10001........."
"...................10001........"
"....................10001......."
".....................10001......"
"......................101......."
".......................1........"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................";

char CursorShape3[32*32+1] =
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
".............1111111............"
"...........11000000011.........."
"..........1000000000001........."
"..........1000000000001........."
".........100001111000001........"
".........100001...10011........."
".........10000111..11..........."
".........10000000111............"
"..........100000000011.........."
"...........100000000001........."
"............110000000001........"
"...........11.11100000001......."
".........11001...11100001......."
"........1000001....100001......."
".........1000001111000001......."
".........100000000000001........"
"..........1000000000001........."
"...........11000000011.........."
".............1111111............"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................"
"................................";



#define MAX_CHANNELS  16 //maximum number of sounds that can play simultaneously

#define NUM_RESOURCES  19

struct {char *r; char *f;} ResourceToFilename[NUM_RESOURCES] =
{
  {"EatSound",         "sounds/eat.ogg"      },
  {"RogueHitSound",    "sounds/hit.ogg"      },
  {"RogueMissSound",   "sounds/miss.ogg"     },
  {"MonsterDieSound",  "sounds/kill.ogg"     },
  {"MonsterHitSound",  "sounds/hit2.ogg"     },
  {"MonsterMissSound", "sounds/miss2.ogg"    },
  {"ExperienceSound",  "sounds/level.ogg"    },
  {"StairsSound",      "sounds/stairs.ogg"   },
  {"GoldSound",        "sounds/gold.ogg"     },
  {"ZapSound",         "sounds/zap.ogg"      },
  {"TeleportSound",    "sounds/teleport.ogg" },
  {"TrapSound",        "sounds/trap.ogg"     },
  {"RogueDieSound",    "sounds/harp.ogg"     },
  {"WinSound",         "sounds/win.ogg"      },
  {"BellSound",        "sounds/bell.ogg"     },
  {"ArmorSound",       "sounds/armor.ogg"    },
  {"ConfusionSound",   "sounds/confusion.ogg"},
  {"FireSound",        "sounds/fire.ogg"     },
  {"IceSound",         "sounds/ice.ogg"      }
};



extern int UpdateX1, UpdateX2, UpdateY1, UpdateY2;

extern int EnableFullScreen;
extern int SoundEnabled;

extern IMG ClientIMG;

extern int WarningOnClose;
//...........................................................................



//****************************************************************************
int ConfirmClose(void)
{
  if (WarningOnClose)
  {
    int result = MessageBox(hWnd,
                            WarningOnClose==1?"Are you sure you want to exit\nbefore saving your game\nwith the 'S' command?":
                                              "Are you sure you want to exit\nbefore your score is recorded?",
                            "Confirm exit",
                            MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2|MB_APPLMODAL);

    if (result==IDNO) return 0;
  }
  return 1;
}

//----------------------------------------------------------------------------

//GetTickCount(): number of milliseconds since system start, up to 49.7 days
int GetInputElapsed(unsigned long *count, int flag)
{
  if (flag==0) {*count = GetTickCount(); return 0;}

  return GetTickCount()-(*count);
}



//flag: 1 pressed 0 released
void LeftMouseButton(int flag)
{
  if (flag)
  {
    MouseB |=  1;
    SetCapture(hWnd);

    if (LeftMouseButtonCount!=0)
    {
      if (GetInputElapsed(&LeftMouseButtonCount, 1)<=CLICK_INTERVAL)
      {
        LeftMouseButtonClicks++;
        if (LeftMouseButtonClicks==1) MouseB |= 2;
        else if (LeftMouseButtonClicks==2) MouseB |= 4;
        else LeftMouseButtonClicks = 0;
      }
      else LeftMouseButtonClicks = 0;
    }

    GetInputElapsed(&LeftMouseButtonCount, 0);
  }
  else
  {
    MouseB &= ~1;
    ReleaseCapture();
  }
}



//flag: 1 pressed 0 released
void RightMouseButton(int flag)
{
  if (flag)
  {
    MouseB |=  8;
    SetCapture(hWnd);
  }
  else
  {
    MouseB &= ~8;
    ReleaseCapture();
  }
}

//---------------------------------------------------------------------------

void LeftMouseButtonReaction(void)
{
  int ch, i;
  char array[9+1] = "ykuhslbjn";

  ch = 0;
  if (MouseX>=0 && MouseX<CLIENTW && MouseY>=0 && MouseY<CLIENTH)
  {
    i = 3*((MouseY*3)/CLIENTH)+((MouseX*3)/CLIENTW);
    if (i>=0 && i<9) ch = array[i];
  }

  if (MouseB&1) if (ch) typedch = ch;
  if (MouseB&2) if (ch) {if (ch=='s') typedch = ch; else typedch = ch-'a'+1;}
  if (MouseB&4) ;

  MouseB &= ~(2|4);
}

//---------------------------------------------------------------------------

//hx, hy: hotspot
HCURSOR MakeCursorFromShape(char *shape, int flipx, int flipy, int swapxy, int hx, int hy)
{
  int x, y, ch;
  unsigned char and_plane[4*32], xor_plane[4*32], *p, *q, a, b;
  HCURSOR hc;

  p = and_plane; q = xor_plane; a = b = 0;
  for (y=0; y<32; y++) for (x=0; x<32; x++)
  {
    ch = shape[(swapxy?1:32)*(flipy?31-y:y)+(swapxy?32:1)*(flipx?31-x:x)];
    switch (ch)
    {
      case '0': a = (a<<1)|0; b = (b<<1)|0; break;
      case '1': a = (a<<1)|0; b = (b<<1)|1; break;
      case '.': a = (a<<1)|1; b = (b<<1)|0; break;
      case 'r': a = (a<<1)|1; b = (b<<1)|1; break;
    }
    if ((x&7)==7) {*p++ = a; *q++ = b; a = b = 0;}
  }

  hc = CreateCursor(hInstance, hx, hy, 32, 32, (void *)and_plane, (void *)xor_plane);
  return hc;
}



void InitCursor(void)
{
  CursorHandle[0] = MakeCursorFromShape(CursorShape2, 0, 0, 0,  7, 7);
  CursorHandle[1] = MakeCursorFromShape(CursorShape1, 0, 0, 0,  15, 5);
  CursorHandle[2] = MakeCursorFromShape(CursorShape2, 1, 0, 0,  31-7, 7);
  CursorHandle[3] = MakeCursorFromShape(CursorShape1, 0, 0, 1,  5, 15);
  CursorHandle[4] = MakeCursorFromShape(CursorShape3, 0, 0, 0,  15, 15);
  CursorHandle[5] = MakeCursorFromShape(CursorShape1, 1, 0, 1,  31-5, 15);
  CursorHandle[6] = MakeCursorFromShape(CursorShape2, 0, 1, 0,  7, 31-7);
  CursorHandle[7] = MakeCursorFromShape(CursorShape1, 0, 1, 0,  15, 31-5);
  CursorHandle[8] = MakeCursorFromShape(CursorShape2, 1, 1, 0,  31-7, 31-7);
}



void ShutdownCursor(void)
{
  int i;

  for (i=0; i<9; i++) if (CursorHandle[i])
  {
    DestroyCursor(CursorHandle[i]);
    CursorHandle[i] = 0;
  }
}



void UpdateCursor(void)
{
  HCURSOR hc;
  int i;

  hc = 0;
  if (MouseX>=0 && MouseX<CLIENTW && MouseY>=0 && MouseY<CLIENTH)
  {
    i = 3*((MouseY*3)/CLIENTH)+((MouseX*3)/CLIENTW);
    if (i>=0 && i<9) hc = CursorHandle[i];
  }
  if (hc==0) hc = LoadCursor(0, IDC_ARROW);

  if (hc) SetCursor(hc);
}

//---------------------------------------------------------------------------

char *get_player_inv_for_context_menu(int init, int *ch);



int ContextMenuPos;



int ContextMenu_AddString(HMENU hm, char *string, int id, int enabled)
{
  MENUITEMINFO mii;

  mii.cbSize = sizeof(MENUITEMINFO);
  mii.fMask = MIIM_TYPE|MIIM_STATE|MIIM_ID;
  mii.fType = MFT_STRING;
  mii.dwTypeData = string;
  mii.fState = enabled?MFS_ENABLED:MFS_DISABLED;
  mii.wID = id;
  mii.cch = 0;

  if (InsertMenuItem(hm, ContextMenuPos++, 1, &mii)==0) return 0;
  return 1;
}



int ContextMenu_AddSeparator(HMENU hm)
{
  MENUITEMINFO mii;

  mii.cbSize = sizeof(MENUITEMINFO);
  mii.fMask = MIIM_TYPE;
  mii.fType = MFT_SEPARATOR;
  mii.dwTypeData = 0;
  mii.cch = 0;

  if (InsertMenuItem(hm, ContextMenuPos++, 1, &mii)==0) return 0;
  return 1;
}



//context menu is activated with right mouse button
//return: 0 failed
int DisplayContextMenu(int x, int y)
{
  int result = 0;
  HMENU hm, hm_sub;

  hm = LoadMenu(hInstance, "MyPopupMenu"); if (hm==0) return 0;
  hm_sub = GetSubMenu(hm, 0);



  //append player's inventory to menu loaded above
  {
    char *p;
    int ch;

    ContextMenuPos = 1000; //must be greater than pos of last menu item loaded above

    if (ContextMenu_AddSeparator(hm_sub)==0) goto done;

    p = get_player_inv_for_context_menu(1, &ch);
    if (p)
    {
      while (p)
      {
        if (ContextMenu_AddString(hm_sub, p, 2001+ch, 1)==0) goto done;
        p = get_player_inv_for_context_menu(0, &ch);
      }
    }
    else
    {
      if (ContextMenu_AddString(hm_sub, "No objects", 2001+' ', 0)==0) goto done;
    }
  }



  {
    POINT point;

    point.x = x; point.y = y; ClientToScreen(hWnd, &point);
    TrackPopupMenu(hm_sub, TPM_CENTERALIGN|TPM_LEFTBUTTON, point.x, point.y, 0, hWnd, 0);
  }
  result = 1;



done:
  DestroyMenu(hm);

  return result;
}

//---------------------------------------------------------------------------

int ChangeScreenMode(int w, int h, int bpp)
{
  DEVMODE dm;
  int i, max_freq;

  ZeroMemory(&dm, sizeof(DEVMODE));
  dm.dmSize = sizeof(DEVMODE);

  i = 0; max_freq = 0;
  while (EnumDisplaySettings(NULL, i++, &dm)!=0)
    if (dm.dmPelsWidth==w && dm.dmPelsHeight==h && dm.dmBitsPerPel==bpp && dm.dmDisplayFrequency>max_freq)
      max_freq = dm.dmDisplayFrequency;

  if (max_freq)
  {
    i = 0;
    while (EnumDisplaySettings(NULL, i++, &dm)!=0)
      if (dm.dmPelsWidth==w && dm.dmPelsHeight==h && dm.dmBitsPerPel==bpp && dm.dmDisplayFrequency==max_freq) goto change;
  }

  ZeroMemory(&dm, sizeof(DEVMODE));
  dm.dmSize = sizeof(DEVMODE);

  dm.dmPelsWidth = w;
  dm.dmPelsHeight = h;
  dm.dmBitsPerPel = bpp;
  dm.dmFields = DM_PELSWIDTH|DM_PELSHEIGHT|DM_BITSPERPEL;

change:
  if (ChangeDisplaySettings(&dm, CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL) return 0;
  return 1;
}



void RestoreScreenMode(void)
{
  ChangeDisplaySettings(0, CDS_FULLSCREEN);
}

//----------------------------------------------------------------------------

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (wndproc_enabled) switch (uMsg)
  {
    case WM_CLOSE:
      PostQuitMessage(0);
    return 0;



    case WM_ACTIVATEAPP:
      if (EnableFullScreen==0) break;
      if (wParam) {ChangeScreenMode(CLIENTW, CLIENTH, 16); ShowWindow(hWnd, SW_RESTORE );}
      else        {RestoreScreenMode();                    ShowWindow(hWnd, SW_MINIMIZE);}
    return 0;



    case WM_PAINT:
      if (GetUpdateRect(hWnd, 0, 0))
      {
        RECT r;

        GetUpdateRect(hWnd, &r, 0);

        SetUpdateRegion(r.left, r.right-1, r.top, r.bottom-1);
        UpdateClient();
      }
    break; //so DefWindowProc() can validate update region



    case WM_COMMAND:
    {
      int i = LOWORD(wParam);

      switch (HIWORD(wParam))
      {
        case 0: if (i>=2001 && i<2001+256) {typedch    = i-2001; return 0;} break; //window or context menu
        case 1: if (i==1001              ) {virtualkey = VK_F10; return 0;} break; //accelerator
      }
    }
    break;



    case WM_KEYDOWN:
      if (wParam==VK_SHIFT  ) shift_on = 1;
      if (wParam==VK_CONTROL) ctrl_on  = 1;
      virtualkey = wParam;
    return 0;

    case WM_KEYUP:
      if (wParam==VK_SHIFT  ) shift_on = 0;
      if (wParam==VK_CONTROL) ctrl_on  = 0;
    return 0;

    case WM_CHAR:
      typedch = (TCHAR)wParam;
    return 0;

    case WM_SYSKEYDOWN:
      if (lParam&(1<<29)) altvirtualkey = wParam;
    return 0;

    case WM_SYSKEYUP:
      if (lParam&(1<<29)) ;
    return 0;

    case WM_MOUSEMOVE:
      MouseX = LOWORD(lParam); MouseY = HIWORD(lParam); UpdateCursor();
    return 0;

    case WM_NCMOUSEMOVE:
      MouseX = -1; MouseY = -1; UpdateCursor();
    return 0;

    case WM_LBUTTONDOWN:
      LeftMouseButton(1);
      LeftMouseButtonReaction();
    return 0;

    case WM_LBUTTONUP:
      LeftMouseButton(0);
    return 0;

    case WM_RBUTTONDOWN:
      if (DisplayContextMenu(LOWORD(lParam), HIWORD(lParam))) {MouseX = -1; MouseY = -1; return 0;}
    break;

    case WM_RBUTTONUP:
    break;
  }
  return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

//---------------------------------------------------------------------------

void ShutdownClass(void)
{
  if (hInstance) {UnregisterClass(MYCLASSNAME, hInstance); hInstance = 0;}
}



int InitClass(void)
{
  WNDCLASS wc;

  hInstance = GetModuleHandle(0);

  wc.style = CS_HREDRAW|CS_VREDRAW|CS_OWNDC;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(hInstance, "MyIcon"); //LoadIcon(0, IDI_APPLICATION)
  wc.hCursor = 0;                           //LoadCursor(0, IDC_ARROW)
  wc.hbrBackground = 0;
  wc.lpszMenuName = 0;
  wc.lpszClassName = MYCLASSNAME;
  if (!RegisterClass(&wc)) {hInstance = 0; MessageBox(0, "Failed To Register Window Class", "ERROR", MB_OK|MB_ICONEXCLAMATION); return 0;}
  return 1;
}



void WindowOff(void)
{
  if (EnableFullScreen) RestoreScreenMode();

  if (hWnd)
  {
    if (hDC)
    {
      if (hBmp)
      {
        if (hMemDC)
        {
          SelectObject(hMemDC, hOldBmp);
          DeleteDC(hMemDC); hMemDC = 0;
        }

        ClientIMG.p = 0;
        DeleteObject(hBmp); hBmp = 0;
      }

      ReleaseDC(hWnd, hDC); hDC = 0;
    }

    DestroyWindow(hWnd); hWnd = 0;
  }
}



int WindowOn(void)
{
  DWORD dwStyle = WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX;
  DWORD dwExStyle = WS_EX_CLIENTEDGE;

  if (EnableFullScreen)
  {
    if (!ChangeScreenMode(CLIENTW, CLIENTH, 16)) EnableFullScreen = 0;
    else {dwStyle = WS_POPUP; dwExStyle |= WS_EX_TOPMOST;}
  }



  //create window
  hWnd = CreateWindowEx(dwExStyle, MYCLASSNAME, ShellOn?"Command Prompt":MYTITLE, dwStyle, 0, 0, 0, 0, 0, IS_MENU_OFF?0:LoadMenu(hInstance, "MyMenu"), hInstance, 0);
  if (!hWnd) {WindowOff(); ShutdownClass(); MessageBox(0, "Failed To Create Window", "ERROR", MB_OK|MB_ICONEXCLAMATION); return 0;}



  //create device context
  hDC = GetDC(hWnd);
  if (!hDC) {WindowOff(); ShutdownClass(); MessageBox(0, "Failed To Create Device Context", "ERROR", MB_OK|MB_ICONEXCLAMATION); return 0;}



  //create client bitmap
  {
    BITMAPINFO *bi;
    void *p;

    bi = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*1024);

    if (bi==0) {WindowOff(); ShutdownClass(); MessageBox(0, "Failed To Create Client Bitmap", "ERROR", MB_OK|MB_ICONEXCLAMATION); return 0;}

    bi->bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
    bi->bmiHeader.biWidth         = CLIENTW;
    bi->bmiHeader.biHeight        = CLIENTH;
    bi->bmiHeader.biPlanes        = 1;
    bi->bmiHeader.biBitCount      = 16;
    bi->bmiHeader.biCompression   = BI_RGB;
    bi->bmiHeader.biSizeImage     = 0;
    bi->bmiHeader.biXPelsPerMeter = 0;
    bi->bmiHeader.biYPelsPerMeter = 0;
    bi->bmiHeader.biClrUsed       = 0;
    bi->bmiHeader.biClrImportant  = 0;

    hBmp = CreateDIBSection(hDC, bi, DIB_RGB_COLORS, &p, 0, 0);

    free(bi);

    if (!hBmp) {WindowOff(); ShutdownClass(); MessageBox(0, "Failed To Create Client Bitmap", "ERROR", MB_OK|MB_ICONEXCLAMATION); return 0;}

    ClientIMG.w = CLIENTW;
    ClientIMG.h = CLIENTH;
    ClientIMG.p = (unsigned short *)p;
  }



  //create memory device context and select client bitmap into it
  hMemDC = CreateCompatibleDC(hDC); if (!hMemDC) {WindowOff(); ShutdownClass(); MessageBox(0, "Failed To Create Memory Device Context", "ERROR", MB_OK|MB_ICONEXCLAMATION); return 0;}
  hOldBmp = SelectObject(hMemDC, hBmp);



  //position and show window
  {
    RECT r;
    int ax, ay, bx, by;

    r.left = 0; r.right = CLIENTW; r.top = 0; r.bottom = CLIENTH;
    AdjustWindowRectEx(&r, dwStyle, IS_MENU_OFF?0:1, dwExStyle); ax = r.right-r.left; ay = r.bottom-r.top;
    if (EnableFullScreen) {bx = CLIENTW; by = CLIENTH;} else {SystemParametersInfo(SPI_GETWORKAREA, 0, &r, 0); bx = r.right-r.left; by = r.bottom-r.top;}
    MoveWindow(hWnd, (bx-ax)>>1, (by-ay)>>1, ax, ay, 1);
    ShowWindow(hWnd, SW_SHOW);
  }



  return 1;
}

//---------------------------------------------------------------------------

void RemakeWindow(int toggle_fullscreen)
{
  IMG aIMG = {0, 0, 0};

  if (AllocIMG(&aIMG, CLIENTW, CLIENTH)==0) return;
  Blit(&ClientIMG, 0, 0, &aIMG, 0, 0, CLIENTW, CLIENTH);

  WindowOff();
  if (toggle_fullscreen) EnableFullScreen = 1-EnableFullScreen;
  if (!WindowOn()) {FreeIMG(&aIMG); exit(1);}

  Blit(&aIMG, 0, 0, &ClientIMG, 0, 0, CLIENTW, CLIENTH);
  FreeIMG(&aIMG);
}
//****************************************************************************



//****************************************************************************
//multi-channel audio playback of .ogg files, intended primarily for sound effects
//sounds are completely loaded into memory instead of being streamed



//maximum number of bytes that can be uncompressed from an .ogg file
#define MAX_SOUND_SIZE  (1048576*4) //4 mebibytes



IDirectSound *pDS = 0;



#define TEMP_SOUND_BUFFER_SIZE  4096

char TempSoundBuffer[TEMP_SOUND_BUFFER_SIZE];



IDirectSoundBuffer *DSLoadSoundBuffer(char *filename)
{
  FILE *f;
  OggVorbis_File vf;
  vorbis_info *vi;
  int bitstream, result, size;
  WAVEFORMATEX wfm;
  DSBUFFERDESC desc;
  IDirectSoundBuffer *pDSB;
  char *buffer, *p;



  f = fopen(filename, "rb"); if (f==0) return 0;
  if (ov_open(f, &vf, NULL, 0)<0) {fclose(f); return 0;}



  vi = ov_info(&vf, -1); if (vi==NULL) {ov_clear(&vf); return 0;}



  size = 0;
  while (1)
  {
    result = ov_read(&vf, TempSoundBuffer, TEMP_SOUND_BUFFER_SIZE, &bitstream); if (result<=0) break;
    size += result; if (size>MAX_SOUND_SIZE) {ov_clear(&vf); return 0;}
  }
  if (size==0) {ov_clear(&vf); return 0;}

  if (ov_raw_seek(&vf, 0)!=0) {ov_clear(&vf); return 0;}



  memset(&wfm, 0, sizeof(wfm));

  wfm.cbSize          = sizeof(wfm);
  wfm.nChannels       = (WORD)vi->channels;
  wfm.wBitsPerSample  = 16; //ogg vorbis is always 16-bit
  wfm.nSamplesPerSec  = vi->rate;
  wfm.nAvgBytesPerSec = wfm.nSamplesPerSec*wfm.nChannels*2;
  wfm.nBlockAlign     = wfm.nChannels*2;
  wfm.wFormatTag      = 1;

  desc.dwSize        = sizeof(desc);
  desc.dwFlags       = DSBCAPS_STATIC|DSBCAPS_GETCURRENTPOSITION2;
  desc.lpwfxFormat   = &wfm;
  desc.dwReserved    = 0;
  desc.dwBufferBytes = size;

  if (IDirectSound_CreateSoundBuffer(pDS, &desc, &pDSB, NULL)!=DS_OK) {ov_clear(&vf); return 0;}



  if (IDirectSoundBuffer_Lock(pDSB, 0, size, (LPVOID)&buffer, (LPDWORD)&size, NULL, NULL, DSBLOCK_ENTIREBUFFER)) {IDirectSoundBuffer_Release(pDSB); ov_clear(&vf); return 0;}

  p = buffer;
  while (1)
  {
    result = ov_read(&vf, p, TEMP_SOUND_BUFFER_SIZE, &bitstream);
    if (result<=0) break;
    p += result;
  }

  IDirectSoundBuffer_Unlock(pDSB, buffer, size, NULL, 0);



  ov_clear(&vf);



  return pDSB;
}



//rate: frequency in hertz 11025 22050 44100
//bits: size of each sample in bits 8 16
//channels: 1 mono 2 stereo(samples interleaved)
int InitDirectSound(int rate, int bits, int channels)
{
  HWND hWnd;
  IDirectSoundBuffer *pDSB;
  DSBUFFERDESC dsBD;
  WAVEFORMATEX wfex;

  if (pDS) return 1;
  if (DirectSoundCreate(0, &pDS, 0)!=DS_OK) {pDS = 0; return 0;}

  hWnd = GetForegroundWindow(); if (hWnd==0) hWnd = GetDesktopWindow();
  if (IDirectSound_SetCooperativeLevel(pDS, hWnd, DSSCL_PRIORITY)!=DS_OK) {IDirectSound_Release(pDS); pDS = 0; return 0;}

  dsBD.dwSize = sizeof(DSBUFFERDESC);
  dsBD.dwFlags = DSBCAPS_PRIMARYBUFFER;
  dsBD.dwBufferBytes = 0;
  dsBD.dwReserved = 0;
  dsBD.lpwfxFormat = 0;
  if (IDirectSound_CreateSoundBuffer(pDS, &dsBD, &pDSB, 0)!=DS_OK) {IDirectSound_Release(pDS); pDS = 0; return 0;}

  wfex.wFormatTag = WAVE_FORMAT_PCM;
  wfex.nSamplesPerSec = rate;
  wfex.wBitsPerSample = (WORD)bits;
  wfex.nChannels = (WORD)channels;
  wfex.nBlockAlign = wfex.wBitsPerSample*wfex.nChannels/8;
  wfex.nAvgBytesPerSec = wfex.nBlockAlign*wfex.nSamplesPerSec;
  wfex.cbSize = 0;
  IDirectSoundBuffer_SetFormat(pDSB, &wfex);

  IDirectSoundBuffer_Play(pDSB, 0, 0, DSBPLAY_LOOPING);

  return 1;
}



void ShutdownDirectSound(void)
{
  if (pDS) {IDirectSound_Release(pDS); pDS = 0;}
}

//----------------------------------------------------------------------------

IDirectSoundBuffer *pDSB_Channels[MAX_CHANNELS];



void ShutdownAudio(void)
{
  if (pDS==0) return;
  ShutdownDirectSound();
}



int InitAudio(void)
{
  int i;

  if (pDS) return 1;
  if (InitDirectSound(22050, 16, 2)==0) return 0;
  atexit(ShutdownAudio);
  for (i=0; i<MAX_CHANNELS; i++) pDSB_Channels[i] = 0;
  return 1;
}



//return: number of channels currently playing
int ServiceAudio(void)
{
  int i, count;
  DWORD status;

  if (pDS==0) return 0;

  count = 0;
  for (i=0; i<MAX_CHANNELS; i++)
  {
    if (pDSB_Channels[i]==0) continue;
    IDirectSoundBuffer_GetStatus(pDSB_Channels[i], &status);
    if ((status&DSBSTATUS_PLAYING)==0)
    {
      IDirectSoundBuffer_Release(pDSB_Channels[i]);
      pDSB_Channels[i] = 0;
      continue;
    }
    count++;
  }
  return count;
}



void PlayAudio(char *resource_name)
{
  int i;
  char *filename;

  if (SoundEnabled==0) return;



  if (pDS==0) return;

  for (i=0; i<NUM_RESOURCES; i++) if (strcmp(resource_name, ResourceToFilename[i].r)==0) break;
  if (i==NUM_RESOURCES) return;
  filename = ResourceToFilename[i].f;

  for (i=0; i<MAX_CHANNELS; i++) if (pDSB_Channels[i]==0) break;
  if (i==MAX_CHANNELS) return;

  pDSB_Channels[i] = DSLoadSoundBuffer(filename);
  if (pDSB_Channels[i]==0) return;

  IDirectSoundBuffer_Play(pDSB_Channels[i], 0, 0, 0);
}
//****************************************************************************



//***************************************************************************
void UpdateClient(void)
{
  int w, h;

  if (UpdateX1<0) UpdateX1 = 0; if (UpdateX2>CLIENTW-1) UpdateX2 = CLIENTW-1;
  if (UpdateY1<0) UpdateY1 = 0; if (UpdateY2>CLIENTH-1) UpdateY2 = CLIENTH-1;

  w = UpdateX2-UpdateX1+1;
  h = UpdateY2-UpdateY1+1;

  if (w>0 && h>0) BitBlt(hDC, UpdateX1, UpdateY1, w, h, hMemDC, UpdateX1, UpdateY1, SRCCOPY);

  SetUpdateRegion_Empty();
}



void SetShellMode(int mode)
{
  ShellOn = mode;

  SetClassLong(hWnd, GCL_HICON, (LONG)LoadIcon(ShellOn?NULL:hInstance, ShellOn?IDI_APPLICATION:"MyIcon"));

  if (EnableFullScreen==0) RemakeWindow(0);
  else SetWindowText(hWnd, ShellOn?"Command Prompt":MYTITLE);
}



void GetInput(int *code, int *ch)
{
  MSG msg;
  HACCEL hAccel;



  Sleep(2);



  ServiceAudio();



  wndproc_enabled = 1;
  hAccel = LoadAccelerators(hInstance, "MyAccel");
  if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
  {
    if (msg.message==WM_QUIT) if (ConfirmClose()) exit(0);
    if (!TranslateAccelerator(hWnd, hAccel, &msg)) {TranslateMessage(&msg); DispatchMessage(&msg);}
  }
  wndproc_enabled = 0;



  *code = 0;
  switch (virtualkey)
  {
    case VK_HOME  : *code = 71; break;
    case VK_UP    : *code = 72; break;
    case VK_PRIOR : *code = 73; break;
    case VK_LEFT  : *code = 75; break;
    case VK_RIGHT : *code = 77; break;
    case VK_END   : *code = 79; break;
    case VK_DOWN  : *code = 80; break;
    case VK_NEXT  : *code = 81; break;
    case VK_INSERT: *code = 82; break;
    case VK_DELETE: *code = 83; break;

    case VK_F1    : *code = 59; break;
    case VK_F2    : *code = 60; break;
    case VK_F3    : *code = 61; break;
    case VK_F4    : *code = 62; break;
    case VK_F5    : *code = 63; break;
    case VK_F6    : *code = 64; break;
    case VK_F7    : *code = 65; break;
    case VK_F8    : *code = 66; break;
    case VK_F9    : *code = 67; break;
    case VK_F10   : *code = 68; break;
    case VK_F11   : SaveIMG_BMP(&ClientIMG, "screenshot.bmp"); break;
    case VK_F12   : RemakeWindow(1); break;
  }
  virtualkey = 0;



  if (shift_on) if (*code>=71 && *code<=83) *code += 2000;



  switch (altvirtualkey)
  {
    case VK_F1 : *code = 1059; break;
    case VK_F2 : *code = 1060; break;
    case VK_F3 : *code = 1061; break;
    case VK_F4 : *code = 1062; break;
    case VK_F5 : *code = 1063; break;
    case VK_F6 : *code = 1064; break;
    case VK_F7 : *code = 1065; break;
    case VK_F8 : *code = 1066; break;
    case VK_F9 : *code = 1067; break;
    case VK_F10: *code = 1068; break;
  }
  altvirtualkey = 0;



  *ch = typedch;
  typedch = 0;



  if (*code==1062) if (ConfirmClose()) exit(0); //exit program if [alt-f4] pressed
}



//GetTickCount(): number of milliseconds since system start, up to 49.7 days
int GetElapsed(int flag)
{
  unsigned long e;

  static unsigned long start;

  if (!flag) {start = GetTickCount(); return 0;}

  e = GetTickCount()-start; if (e<1) e = 1; if (e>1000*10) e = 1000*10;

  return (int)e;
}



void ShutdownInterface(void)
{
  WindowOff();
  ShutdownCursor();
  ShutdownClass();
}



void InitInterface(void)
{
  atexit(ShutdownInterface);

  if (!InitClass()) exit(1);
  InitCursor();
  if (!WindowOn()) exit(1);



  ClearIMG(&ClientIMG);
  UpdateClient();



  InitAudio();
}
//***************************************************************************



//############################################################################
//call wrapped_main() from Windows GUI entry point WinMain()

int wrapped_main(int argc, char **argv);



//ridiculously large, but there's no way to tell how big it should be at runtime
#define MAX_MODULE_FILENAME_SIZE  4096



char  *ModuleFileName = 0;
char  *CommandLine    = 0;
char **CLParameters   = 0;



void FreeWinMain(void)
{
  if (ModuleFileName) free(ModuleFileName);
  if (CommandLine   ) free(CommandLine   );
  if (CLParameters  ) free(CLParameters  );
}



int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
  int i, len, flag, count;
  char *p, ch;



  atexit(FreeWinMain);



  ModuleFileName = (char *)malloc(MAX_MODULE_FILENAME_SIZE); if (ModuleFileName==0) return 1;
  ModuleFileName[0] = 0; //in case below fails
  GetModuleFileName(NULL, ModuleFileName, MAX_MODULE_FILENAME_SIZE);



  p = ModuleFileName;
  i = strlen(p);
  while (i>0) {i--; if (p[i]=='/' || p[i]=='\\') {i++; break;}}
  ch = p[i]; p[i] = 0; SetCurrentDirectory(p); p[i] = ch;



  len = strlen(lpCmdLine);
  CommandLine = (char *)malloc(len+1); if (CommandLine==0) return 1;
  memcpy(CommandLine, lpCmdLine, len+1);

  flag = 0; count = 1;
  for (i=0; i<len; i++)
  {
    if (CommandLine[i]==' ' || CommandLine[i]=='\t') {flag = 0; CommandLine[i] = 0;}
    else if (!flag) {flag = 1; count++;}
  }

  CLParameters = (char **)malloc(sizeof(char *)*count); if (CLParameters==0) return 1;
  CLParameters[0] = ModuleFileName;

  flag = 0; count = 1;
  for (i=0; i<len; i++)
  {
    if (CommandLine[i]==0) flag = 0;
    else if (!flag) {flag = 1; CLParameters[count++] = CommandLine+i;}
  }



  return wrapped_main(count, CLParameters);
}
//############################################################################
