/*
 * Copyright (c) 1988, 1993
 *  The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Timothy C. Stoehr.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *  This product includes software developed by the University of
 *  California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 *
 * This source herein may be modified and/or distributed by anybody who
 * so desires, with the following restrictions:
 *    1.)  No portion of this notice shall be removed.
 *    2.)  Credit shall not be taken for the creation of this source.
 *    3.)  This code is not to be traded, sold, or used for personal
 *         gain or profit.
 *
 */

//The following source code is derived from the NetBSD version of Rogue
//(last modified 2002/10/01)



#include <stdlib.h> //exit
#include <string.h> //strcpy strcat strlen memcpy strncmp memset strncpy

#include "def.h"



//............................................................................
extern int WarningOnClose;



int PrefixCount = 0;



//the following is part of a hack to make non level_objects tiles display properly
         short MovingObj_row        = -1;
         short MovingObj_col        = -1;
unsigned short MovingObj_which_kind = 65535;



boolean ask_quit;
boolean passgo;
boolean mon_disappeared;
boolean interrupted = 0;
boolean r_teleport;
boolean r_see_invisible;
boolean sustain_strength;
boolean maintain_armor;
boolean being_held;
boolean trap_door = 0;
boolean see_invisible = 0;
boolean detect_monster = 0;
boolean con_mon = 0;
boolean wizard = 0;

boolean rooms_visited[MAXROOMS];
boolean is_wood[WANDS];

short cur_level = 0;
short max_level = 1;
short cur_room;
short party_room = NO_ROOM;
short r_de;
short m_moves = 0;
short foods = 0;
short stealthy;
short r_rings;
short add_strength;
short e_rings;
short regeneration;
short ring_exp;
short auto_search;
short write_failed = 0;
short less_hp = 0;
short bear_trap = 0;
short halluc = 0;
short blind = 0;
short confused = 0;
short levitate = 0;
short haste_self = 0;
short extra_hp = 0;

short random_rooms[MAXROOMS] = {3, 7, 5, 2, 0, 6, 1, 4, 8};

unsigned short dungeon[DROWS][DCOLS];

const char *you_can_move_again = "you can move again";
const char *curse_message = "you can't, it appears to be cursed";
const char *unknown_command = "unknown command";
const char *left_or_right = "left or right hand?";
const char *no_ring = "there's no ring on that hand";
const char *strange_feeling = "you have a strange feeling for a moment, then it passes";

const char *new_level_message = 0;

char login_name[MAX_OPT_LEN];
char fruit[MAX_OPT_LEN];

char save_file[MAX_OPT_LEN];

char hit_message[80];
char hunger_str[HUNGER_STR_LEN];

object *fight_monster = 0;
object level_monsters;
object level_objects;

room rooms[MAXROOMS];
trap traps[MAX_TRAPS];

const char *const wand_materials[WAND_MATERIALS] =
{
  "steel ",
  "bronze ",
  "gold ",
  "silver ",
  "copper ",
  "nickel ",
  "cobalt ",
  "tin ",
  "iron ",
  "magnesium ",
  "chrome ",
  "carbon ",
  "platinum ",
  "silicon ",
  "titanium ",

  "teak ",
  "oak ",
  "cherry ",
  "birch ",
  "pine ",
  "cedar ",
  "redwood ",
  "balsa ",
  "ivory ",
  "walnut ",
  "maple ",
  "mahogany ",
  "elm ",
  "palm ",
  "wooden "
};

const char *const gems[GEMS] =
{
  "diamond ",
  "stibotantalite ",
  "lapi-lazuli ",
  "ruby ",
  "emerald ",
  "sapphire ",
  "amethyst ",
  "quartz ",
  "tiger-eye ",
  "opal ",
  "agate ",
  "turquoise ",
  "pearl ",
  "garnet "
};

const char *const syllables[MAXSYLLABLES] =
{
  "blech ",
  "foo ",
  "barf ",
  "rech ",
  "bar ",
  "blech ",
  "quo ",
  "bloto ",
  "oh ",
  "caca ",
  "blorp ",
  "erp ",
  "festr ",
  "rot ",
  "slie ",
  "snorf ",
  "iky ",
  "yuky ",
  "ooze ",
  "ah ",
  "bahl ",
  "zep ",
  "druhl ",
  "flem ",
  "behil ",
  "arek ",
  "mep ",
  "zihr ",
  "grit ",
  "kona ",
  "kini ",
  "ichi ",
  "tims ",
  "ogr ",
  "oo ",
  "ighr ",
  "coph ",
  "swerr ",
  "mihln ",
  "poxi "
};

const long level_points[MAX_EXP_LEVEL] =
{
        10L,
        20L,
        40L,
        80L,
       160L,
       320L,
       640L,
      1300L,
      2600L,
      5200L,
     10000L,
     20000L,
     40000L,
     80000L,
    160000L,
    320000L,
   1000000L,
   3333333L,
   6666666L,
    MAX_EXP,
  99900000L
};

const char *const m_names[MONSTERS] =
{
  "aquator",
  "bat",
  "centaur",
  "dragon",
  "emu",
  "venus fly-trap",
  "griffin",
  "hobgoblin",
  "ice monster",
  "jabberwock",
  "kestrel",
  "leprechaun",
  "medusa",
  "nymph",
  "orc",
  "phantom",
  "quagga",
  "rattlesnake",
  "snake",
  "troll",
  "black unicorn",
  "vampire",
  "wraith",
  "xeroc",
  "yeti",
  "zombie"
};

object mon_tab[MONSTERS] =
{
  {(ASLEEP|WAKENS|WANDERS|RUSTS),       "0d0",       25, 'A',   20,  9,  18, 100, 0,   0, 0, 0, 0},
  {(ASLEEP|WANDERS|FLITS|FLIES),        "1d3",       10, 'B',    2,  1,   8,  60, 0,   0, 0, 0, 0},
  {(ASLEEP|WANDERS),                    "3d3/2d5",   32, 'C',   15,  7,  16,  85, 0,  10, 0, 0, 0},
  {(ASLEEP|WAKENS|FLAMES),              "4d6/4d9",  145, 'D', 5000, 21, 126, 100, 0,  90, 0, 0, 0},
  {(ASLEEP|WAKENS),                     "1d3",       11, 'E',    2,  1,   7,  65, 0,   0, 0, 0, 0},
  {(HOLDS|STATIONARY),                  "5d5",       73, 'F',   91, 12, 126,  80, 0,   0, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS|FLIES),       "5d5/5d5",  115, 'G', 2000, 20, 126,  85, 0,  10, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS),             "1d3/1d2",   15, 'H',    3,  1,  10,  67, 0,   0, 0, 0, 0},
  {(ASLEEP|FREEZES),                    "0d0",       15, 'I',    5,  2,  11,  68, 0,   0, 0, 0, 0},
  {(ASLEEP|WANDERS),                    "3d10/4d5", 132, 'J', 3000, 21, 126, 100, 0,   0, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS|FLIES),       "1d4",       10, 'K',    2,  1,   6,  60, 0,   0, 0, 0, 0},
  {(ASLEEP|STEALS_GOLD),                "0d0",       25, 'L',   21,  6,  16,  75, 0,   0, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS|CONFUSES),    "4d4/3d7",   97, 'M',  250, 18, 126,  85, 0,  25, 0, 0, 0},
  {(ASLEEP|STEALS_ITEM),                "0d0",       25, 'N',   39, 10,  19,  75, 0, 100, 0, 0, 0},
  {(ASLEEP|WANDERS|WAKENS|SEEKS_GOLD),  "1d6",       25, 'O',    5,  4,  13,  70, 0,  10, 0, 0, 0},
  {(ASLEEP|INVISIBLE|WANDERS|FLITS),    "5d4",       76, 'P',  120, 15,  24,  80, 0,  50, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS),             "3d5",       30, 'Q',   20,  8,  17,  78, 0,  20, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS|STINGS),      "2d5",       19, 'R',   10,  3,  12,  70, 0,   0, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS),             "1d3",        8, 'S',    2,  1,   9,  50, 0,   0, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS),             "4d6/1d4",   75, 'T',  125, 13,  22,  75, 0,  33, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS),             "4d10",      90, 'U',  200, 17,  26,  85, 0,  33, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS|DRAINS_LIFE), "1d14/1d4",  55, 'V',  350, 19, 126,  85, 0,  18, 0, 0, 0},
  {(ASLEEP|WANDERS|DROPS_LEVEL),        "2d8",       45, 'W',   55, 14,  23,  75, 0,   0, 0, 0, 0},
  {(ASLEEP|IMITATES),                   "4d6",       42, 'X',  110, 16,  25,  75, 0,   0, 0, 0, 0},
  {(ASLEEP|WANDERS),                    "3d6",       35, 'Y',   50, 11,  20,  80, 0,  20, 0, 0, 0},
  {(ASLEEP|WAKENS|WANDERS),             "1d7",       21, 'Z',    8,  5,  14,  69, 0,   0, 0, 0, 0}
};

fighter rogue =
{
  INIT_AW,       //armor
  INIT_AW,       //weapon
  INIT_RINGS,    //left ring
  INIT_RINGS,    //right ring
  INIT_HP,       //Hp current
  INIT_HP,       //Hp max
  INIT_STR,      //Str current
  INIT_STR,      //Str max
  INIT_PACK,     //pack
  INIT_GOLD,     //gold
  INIT_EXPLEVEL, //exp level
  INIT_EXP,      //exp points
  0, 0,          //row, col
  INIT_CHAR,     //char
  INIT_MOVES     //moves
};

struct id id_potions[POTIONS] =
{
  {100, "blue \0                           ", "of increase strength ", 0},
  {250, "red \0                            ", "of restore strength ",  0},
  {100, "green \0                          ", "of healing ",           0},
  {200, "grey \0                           ", "of extra healing ",     0},
  { 10, "brown \0                          ", "of poison ",            0},
  {300, "clear \0                          ", "of raise level ",       0},
  { 10, "pink \0                           ", "of blindness ",         0},
  { 25, "white \0                          ", "of hallucination ",     0},
  {100, "purple \0                         ", "of detect monster ",    0},
  {100, "black \0                          ", "of detect things ",     0},
  { 10, "yellow \0                         ", "of confusion ",         0},
  { 80, "plaid \0                          ", "of levitation ",        0},
  {150, "burgundy \0                       ", "of haste self ",        0},
  {145, "beige \0                          ", "of see invisible ",     0}
};

struct id id_scrolls[SCROLS] =
{
  {505, "                                   ", "of protect armor ",     0},
  {200, "                                   ", "of hold monster ",      0},
  {235, "                                   ", "of enchant weapon ",    0},
  {235, "                                   ", "of enchant armor ",     0},
  {175, "                                   ", "of identify ",          0},
  {190, "                                   ", "of teleportation ",     0},
  { 25, "                                   ", "of sleep ",             0},
  {610, "                                   ", "of scare monster ",     0},
  {210, "                                   ", "of remove curse ",      0},
  { 80, "                                   ", "of create monster ",    0},
  { 25, "                                   ", "of aggravate monster ", 0},
  {180, "                                   ", "of magic mapping ",     0},
  { 90, "                                   ", "of confuse monster ",   0}
};

struct id id_weapons[WEAPONS] =
{
  {150, "short bow ",        "", 0},
  {  8, "darts ",            "", 0},
  { 15, "arrows ",           "", 0},
  { 27, "daggers ",          "", 0},
  { 35, "shurikens ",        "", 0},
  {360, "mace ",             "", 0},
  {470, "long sword ",       "", 0},
  {580, "two-handed sword ", "", 0}
};

struct id id_armors[ARMORS] =
{
  {300, "leather armor ", "", (UNIDENTIFIED)},
  {300, "ring mail ",     "", (UNIDENTIFIED)},
  {400, "scale mail ",    "", (UNIDENTIFIED)},
  {500, "chain mail ",    "", (UNIDENTIFIED)},
  {600, "banded mail ",   "", (UNIDENTIFIED)},
  {600, "splint mail ",   "", (UNIDENTIFIED)},
  {700, "plate mail ",    "", (UNIDENTIFIED)}
};

struct id id_wands[WANDS] =
{
  {25, "                                 ", "of teleport away ", 0},
  {50, "                                 ", "of slow monster ",  0},
  { 8, "                                 ", "of invisibility ",  0},
  {55, "                                 ", "of polymorph ",     0},
  { 2, "                                 ", "of haste monster ", 0},
  {20, "                                 ", "of magic missile ", 0},
  {20, "                                 ", "of cancellation ",  0},
  { 0, "                                 ", "of do nothing ",    0},
  {35, "                                 ", "of drain life ",    0},
  {20, "                                 ", "of cold ",          0},
  {20, "                                 ", "of fire ",          0}
};

struct id id_rings[RINGS] =
{
  {250, "                                 ", "of stealth ",          0},
  {100, "                                 ", "of teleportation ",    0},
  {255, "                                 ", "of regeneration ",     0},
  {295, "                                 ", "of slow digestion ",   0},
  {200, "                                 ", "of add strength ",     0},
  {250, "                                 ", "of sustain strength ", 0},
  {250, "                                 ", "of dexterity ",        0},
  { 25, "                                 ", "of adornment ",        0},
  {300, "                                 ", "of see invisible ",    0},
  {290, "                                 ", "of maintain armor ",   0},
  {270, "                                 ", "of searching ",        0},
};

const char *const trap_strings[TRAPS * 2] =
{
  "trap door", "you fell down a trap",
  "bear trap", "you are caught in a bear trap",
  "teleport trap", "teleport",
  "poison dart trap", "a small dart just hit you in the shoulder",
  "sleeping gas trap", "a strange white mist envelops you and you fall asleep",
  "rust trap", "a gush of water hits you on the head"
};
//............................................................................



//****************************************************************************
//game.c

void game(void)
{
  char buf[128];



  ask_quit = 1; //1: ask before quitting
  passgo   = 1; //1: follow turnings in passageways



  //construct save_file from login_name
  {
    char *p, *q;
    int ch;

    p = login_name; q = save_file; while (q-save_file<8)
    {
      ch = *p;
      if (ch>='a' && ch<='z') *q++ = ch;
      if (ch>='A' && ch<='Z') *q++ = ch-'A'+'a';
      if (ch>='0' && ch<='9') *q++ = ch;
      if (ch==0) *q++ = '_'; else p++;
    }
    *q = 0;
    strcat(save_file, ".sav");
  }



  if (restore_game())
  {
    sprintf(buf, "Hello %s, welcome back to the Dungeons of Doom!", login_name);
    message(buf);

    goto PL;
  }



  sprintf(buf, "Hello %s, welcome to the Dungeons of Doom!", login_name);
  message(buf);

  mix_colors();
  get_wand_and_ring_materials();
  make_scroll_titles();

  level_objects.next_object = (object *) 0;
  level_monsters.next_monster = (object *) 0;

  player_init();
  ring_stats(0);

  for (;;)
  {
    clear_level();
    make_level();
    put_objects();
    put_stairs();
    add_traps();
    put_mons();
    put_player(party_room);
PL:
    level_transition();
    play_level();
    free_stuff(&level_objects);
    free_stuff(&level_monsters);
  }
}



void player_init(void)
{
  object *obj;

  rogue.pack.next_object = (object *) 0;

  obj = alloc_object();
  get_food(obj, 1);
  (void) add_to_pack(obj, &rogue.pack, 1);

  obj = alloc_object(); //initial armor
  obj->what_is = ARMOR;
  obj->which_kind = RINGMAIL;
  obj->class = RINGMAIL+2;
  obj->is_protected = 0;
  obj->d_enchant = 1;
  (void) add_to_pack(obj, &rogue.pack, 1);
  do_wear(obj);

  obj = alloc_object(); //initial weapons
  obj->what_is = WEAPON;
  obj->which_kind = MACE;
  obj->damage = "2d3";
  obj->hit_enchant = obj->d_enchant = 1;
  obj->identified = 1;
  (void) add_to_pack(obj, &rogue.pack, 1);
  do_wield(obj);

  obj = alloc_object();
  obj->what_is = WEAPON;
  obj->which_kind = BOW;
  obj->damage = "1d2";
  obj->hit_enchant = 1;
  obj->d_enchant = 0;
  obj->identified = 1;
  (void) add_to_pack(obj, &rogue.pack, 1);

  obj = alloc_object();
  obj->what_is = WEAPON;
  obj->which_kind = ARROW;
  obj->quantity = get_rand(25, 35);
  obj->damage = "1d2";
  obj->hit_enchant = 0;
  obj->d_enchant = 0;
  obj->identified = 1;
  (void) add_to_pack(obj, &rogue.pack, 1);
}
//****************************************************************************



//****************************************************************************
//hit.c

void mon_hit(object *monster)
{
  short damage, hit_chance;
  const char *mn;
  float minus;

  if (fight_monster && (monster != fight_monster)) {fight_monster = 0;}
  monster->trow = NO_ROOM;
  if (cur_level >= (AMULET_LEVEL * 2)) {hit_chance = 100;}
  else
  {
    hit_chance = monster->m_hit_chance;
    hit_chance -= (((2 * rogue.exp) + (2 * ring_exp)) - r_rings);
  }
  if (wizard) {hit_chance /= 2;}
  if (!fight_monster) {interrupted = 1;}
  mn = mon_name(monster);

  if (!rand_percent(hit_chance))
  {
    if (!fight_monster)
    {
      PlayAudio("MonsterMissSound");

      sprintf(hit_message + strlen(hit_message), "the %s misses", mn);
      message(hit_message);
      interrupted = 1;
      hit_message[0] = 0;
    }
    return;
  }
  if (!fight_monster)
  {
    PlayAudio("MonsterHitSound");

    sprintf(hit_message + strlen(hit_message), "the %s hit", mn);
    message(hit_message);
    interrupted = 1;
    hit_message[0] = 0;
  }
  if (!(monster->m_flags & STATIONARY))
  {
    damage = get_damage(monster->m_damage, 1);
    if (cur_level >= (AMULET_LEVEL * 2)) {minus = (float) ((AMULET_LEVEL * 2) - cur_level);}
    else
    {
      minus = (float) get_armor_class(rogue.armor) * 3.00;
      minus = minus/100.00 * (float) damage;
    }
    damage -= (short) minus;
  }
  else {damage = monster->stationary_damage++;}
  if (wizard) {damage /= 3;}
  if (damage > 0) {rogue_damage(damage, monster, 0);}
  if (monster->m_flags & SPECIAL_HIT) {special_hit(monster);}
}



void rogue_hit(object *monster, boolean force_hit)
{
  short damage, hit_chance;

  if (monster)
  {
    if (check_imitator(monster)) {return;}
    hit_chance = force_hit ? 100 : get_hit_chance(rogue.weapon);

    if (wizard) {hit_chance *= 2;}
    if (!rand_percent(hit_chance))
    {
      if (!fight_monster)
      {
        PlayAudio("RogueMissSound");

        (void) strcpy(hit_message, "you miss  ");
      }
      goto RET;
    }
    damage = get_weapon_damage(rogue.weapon);
    if (wizard) {damage *= 3;}
    if (con_mon) {s_con_mon(monster);}
    if (mon_damage(monster, damage))
    {
      //still alive?
      if (!fight_monster)
      {
        (void) strcpy(hit_message, "you hit  ");
      }
    }
RET:
    check_gold_seeker(monster);
    wake_up(monster);
  }
}



void rogue_damage(short d, object *monster, short other)
{
  if (d >= rogue.hp_current)
  {
    rogue.hp_current = 0;
    killed_by(monster, other);
  }
  if (d > 0)
  {
    rogue.hp_current -= d;
  }
}



int get_damage(const char *ds, boolean r)
{
  int i = 0, j, n, d, total = 0;

  while (ds[i])
  {
    n = get_number(ds+i);
    while (ds[i++] != 'd') ;
    d = get_number(ds+i);
    while ((ds[i] != '/') && ds[i]) i++;

    for (j = 0; j < n; j++)
    {
      if (r) {total += get_rand(1, d);}
      else {total += d;}
    }
    if (ds[i] == '/') {i++;}
  }
  return(total);
}



int get_w_damage(const object *obj)
{
  char new_damage[12];
  int tmp_to_hit, tmp_damage;
  int i = 0;

  if ((!obj) || (obj->what_is != WEAPON)) {return(-1);}
  tmp_to_hit = get_number(obj->damage) + obj->hit_enchant;
  while (obj->damage[i++] != 'd') ;
  tmp_damage = get_number(obj->damage + i) + obj->d_enchant;

  sprintf(new_damage, "%dd%d", tmp_to_hit, tmp_damage);

  return(get_damage(new_damage, 1));
}



int get_number(const char *s)
{
  int i = 0;
  int total = 0;

  while ((s[i] >= '0') && (s[i] <= '9'))
  {
    total = (10 * total) + (s[i] - '0');
    i++;
  }
  return(total);
}



long lget_number(const char *s)
{
  short i = 0;
  long total = 0;

  while ((s[i] >= '0') && (s[i] <= '9'))
  {
    total = (10 * total) + (s[i] - '0');
    i++;
  }
  return(total);
}



int to_hit(const object *obj)
{
  if (!obj) {return(1);}
  return(get_number(obj->damage) + obj->hit_enchant);
}



int damage_for_strength(void)
{
  short strength;

  strength = rogue.str_current + add_strength;

  if (strength <= 6) {return(strength-5);}
  if (strength <= 14) {return(1);}
  if (strength <= 17) {return(3);}
  if (strength <= 18) {return(4);}
  if (strength <= 20) {return(5);}
  if (strength <= 21) {return(6);}
  if (strength <= 30) {return(7);}
  return(8);
}



int mon_damage(object *monster, short damage)
{
  const char *mn;
  short row, col;

  monster->hp_to_kill -= damage;

  PlayAudio("RogueHitSound");

  if (monster->hp_to_kill <= 0)
  {
    PlayAudio("MonsterDieSound");

    row = monster->row;
    col = monster->col;
    dungeon[row][col] &= ~MONSTER;
    mvaddch(row, col, (int) get_dungeon_char(row, col));

    fight_monster = 0;
    cough_up(monster);
    mn = mon_name(monster);
    sprintf(hit_message+strlen(hit_message), "defeated the %s", mn);
    message(hit_message);
    interrupted = 1;
    hit_message[0] = 0;
    add_exp(monster->kill_exp, 1);
    take_from_pack(monster, &level_monsters);

    if (monster->m_flags & HOLDS) {being_held = 0;}
    free_object(monster);
    return(0);
  }
  return(1);
}



void fight(boolean to_the_death)
{
  short ch, c, d;
  short row, col;
  short possible_damage;
  object *monster;



  message("direction?");
  SetDirArrow(8);
  while (!is_direction(ch = rgetchar(), &d)) sound_bell();
  SetDirArrow(-1);
  if (ch==CANCEL) return;



  row = rogue.row; col = rogue.col;
  get_dir_rc(d, &row, &col, 0);

  c = mvinch(row, col);
  if (((c < 'A') || (c > 'Z')) || (!can_move(rogue.row, rogue.col, row, col)))
  {
    message("I see no monster there");
    return;
  }
  if (!(fight_monster = object_at(&level_monsters, row, col))) {return;}
  if (!(fight_monster->m_flags & STATIONARY)) {possible_damage = ((get_damage(fight_monster->m_damage, 0) * 2) / 3);}
  else {possible_damage = fight_monster->stationary_damage - 1;}
  while (fight_monster)
  {
    (void) one_move_rogue(ch, 0);
    if (((!to_the_death) && (rogue.hp_current <= possible_damage)) || interrupted || (!(dungeon[row][col] & MONSTER))) {fight_monster = 0;}
    else
    {
      monster = object_at(&level_monsters, row, col);
      if (monster != fight_monster) {fight_monster = 0;}
    }
  }
}



void get_dir_rc(short dir, short *row, short *col, short allow_off_screen)
{
  switch(dir)
  {
    case LEFT:
      if (allow_off_screen || (*col > 0)) {(*col)--;}
    break;
    case DOWN:
      if (allow_off_screen || (*row < (DROWS-2))) {(*row)++;}
    break;
    case UPWARD:
      if (allow_off_screen || (*row > MIN_ROW)) {(*row)--;}
    break;
    case RIGHT:
      if (allow_off_screen || (*col < (DCOLS-1))) {(*col)++;}
    break;
    case UPLEFT:
      if (allow_off_screen || ((*row > MIN_ROW) && (*col > 0))) {(*row)--; (*col)--;}
    break;
    case UPRIGHT:
      if (allow_off_screen || ((*row > MIN_ROW) && (*col < (DCOLS-1)))) {(*row)--; (*col)++;}
    break;
    case DOWNRIGHT:
      if (allow_off_screen || ((*row < (DROWS-2)) && (*col < (DCOLS-1)))) {(*row)++; (*col)++;}
    break;
    case DOWNLEFT:
      if (allow_off_screen || ((*row < (DROWS-2)) && (*col > 0))) {(*row)++; (*col)--;}
    break;
  }
}



int get_hit_chance(const object *weapon)
{
  short hit_chance;

  hit_chance = 40;
  hit_chance += 3 * to_hit(weapon);
  hit_chance += (((2 * rogue.exp) + (2 * ring_exp)) - r_rings);
  return(hit_chance);
}



int get_weapon_damage(const object *weapon)
{
  short damage;

  damage = get_w_damage(weapon);
  damage += damage_for_strength();
  damage += ((((rogue.exp + ring_exp) - r_rings) + 1) / 2);
  return(damage);
}



void s_con_mon(object *monster)
{
  if (con_mon)
  {
    monster->m_flags |= CONFUSED;
    monster->moves_confused += get_rand(12, 22);
    message("the monster appears confused");
    con_mon = 0;
  }
}
//****************************************************************************



//****************************************************************************
//inventory.c

void inventory(const object *pack, unsigned short mask)
{
  object *obj;
  char buf[128];

  obj = pack->next_object;

  if (!obj) {message("your pack is empty"); return;}

  while (obj)
  {
    if (obj->what_is & mask)
    {
      buf[0] = ' ';
      buf[1] = obj->ichar;
      buf[2] = ((obj->what_is & ARMOR) && obj->is_protected) ? '}' : ')';
      buf[3] = ' ';
      get_desc(obj, buf+4);

      message(buf);
    }
    obj = obj->next_object;
  }
}



void mix_colors(void)
{
  short i, j, k;
  char t[MAX_ID_TITLE_LEN];

  for (i = 0; i <= 32; i++)
  {
    j = get_rand(0, (POTIONS - 1));
    k = get_rand(0, (POTIONS - 1));
    memcpy(t, id_potions[j].title, MAX_ID_TITLE_LEN);
    memcpy(id_potions[j].title, id_potions[k].title, MAX_ID_TITLE_LEN);
    memcpy(id_potions[k].title, t, MAX_ID_TITLE_LEN);
  }
}



void make_scroll_titles(void)
{
  short i, j, n;
  short sylls, s;

  for (i = 0; i < SCROLS; i++)
  {
    sylls = get_rand(2, 5);
    (void) strcpy(id_scrolls[i].title, "'");

    for (j = 0; j < sylls; j++)
    {
      s = get_rand(1, (MAXSYLLABLES-1));
      (void) strcat(id_scrolls[i].title, syllables[s]);
    }
    n = strlen(id_scrolls[i].title);
    (void) strcpy(id_scrolls[i].title+(n-1), "' ");
  }
}



void get_desc(const object *obj, char *desc)
{
  const char *item_name;
  struct id *id_table;
  char more_info[32];
  short i;

  if (obj->what_is == AMULET)
  {
    (void) strcpy(desc, "the amulet of Yendor ");
    return;
  }
  item_name = name_of(obj);

  if (obj->what_is == GOLD)
  {
    sprintf(desc, "%d pieces of gold", obj->quantity);
    return;
  }

  if (obj->what_is != ARMOR)
  {
    if (obj->quantity == 1) {(void) strcpy(desc, "a ");}
    else {sprintf(desc, "%d ", obj->quantity);}
  }
  if (obj->what_is == FOOD)
  {
    if (obj->which_kind == RATION)
    {
      if (obj->quantity > 1) {sprintf(desc, "%d rations of ", obj->quantity);}
      else {(void) strcpy(desc, "some ");}
    }
    else {(void) strcpy(desc, "a ");}
    (void) strcat(desc, item_name);
    goto ANA;
  }
  id_table = get_id_table(obj);

  if (wizard) {goto ID;}
  if (obj->what_is & (WEAPON | ARMOR | WAND | RING)) {goto CHECK;}

  switch(id_table[obj->which_kind].id_status)
  {
    case UNIDENTIFIED:
CHECK:
      switch(obj->what_is)
      {
        case SCROL:
          (void) strcat(desc, item_name);
          (void) strcat(desc, "entitled: ");
          (void) strcat(desc, id_table[obj->which_kind].title);
        break;
        case POTION:
          (void) strcat(desc, id_table[obj->which_kind].title);
          (void) strcat(desc, item_name);
        break;
        case WAND:
        case RING:
          if (obj->identified || (id_table[obj->which_kind].id_status == IDENTIFIED)) {goto ID;}
          if (id_table[obj->which_kind].id_status == CALLED) {goto CALL;}
          (void) strcat(desc, id_table[obj->which_kind].title);
          (void) strcat(desc, item_name);
        break;
        case ARMOR:
          if (obj->identified) {goto ID;}
          (void) strcpy(desc, id_table[obj->which_kind].title);
        break;
        case WEAPON:
          if (obj->identified) {goto ID;}
          (void) strcat(desc, name_of(obj));
        break;
      }
    break;
    case CALLED:
CALL:
      switch(obj->what_is)
      {
        case SCROL:
        case POTION:
        case WAND:
        case RING:
          (void) strcat(desc, item_name);
          (void) strcat(desc, "called ");
          (void) strcat(desc, id_table[obj->which_kind].title);
        break;
      }
    break;
    case IDENTIFIED:
ID:
      switch(obj->what_is)
      {
        case SCROL:
        case POTION:
          (void) strcat(desc, item_name);
          (void) strcat(desc, id_table[obj->which_kind].real);
        break;
        case RING:
          if (wizard || obj->identified)
          {
            if ((obj->which_kind == DEXTERITY) || (obj->which_kind == ADD_STRENGTH))
            {
              sprintf(more_info, "%s%d ", ((obj->class > 0) ? "+" : ""), obj->class);
              (void) strcat(desc, more_info);
            }
          }
          (void) strcat(desc, item_name);
          (void) strcat(desc, id_table[obj->which_kind].real);
        break;
        case WAND:
          (void) strcat(desc, item_name);
          (void) strcat(desc, id_table[obj->which_kind].real);
          if (wizard || obj->identified)
          {
            sprintf(more_info, "[%d]", obj->class);
            (void) strcat(desc, more_info);
          }
        break;
        case ARMOR:
          sprintf(desc, "%s%d ", ((obj->d_enchant >= 0) ? "+" : ""), obj->d_enchant);
          (void) strcat(desc, id_table[obj->which_kind].title);
          sprintf(more_info, "[%d] ", get_armor_class(obj));
          (void) strcat(desc, more_info);
        break;
        case WEAPON:
          sprintf(desc+strlen(desc), "%s%d,%s%d ", ((obj->hit_enchant >= 0) ? "+" : ""), obj->hit_enchant, ((obj->d_enchant >= 0) ? "+" : ""), obj->d_enchant);
          (void) strcat(desc, name_of(obj));
        break;
      }
    break;
  }
ANA:
  if (!strncmp(desc, "a ", 2))
  {
    if (is_vowel(desc[2]))
    {
      for (i = strlen(desc) + 1; i > 1; i--) {desc[i] = desc[i-1];}
      desc[1] = 'n';
    }
  }
  if (obj->in_use_flags & BEING_WIELDED) {(void) strcat(desc, "in hand");}
  else if (obj->in_use_flags & BEING_WORN) {(void) strcat(desc, "being worn");}
  else if (obj->in_use_flags & ON_LEFT_HAND) {(void) strcat(desc, "on left hand");}
  else if (obj->in_use_flags & ON_RIGHT_HAND) {(void) strcat(desc, "on right hand");}
}



void get_wand_and_ring_materials(void)
{
  short i, j;
  boolean used[WAND_MATERIALS];

  for (i = 0; i < WAND_MATERIALS; i++) {used[i] = 0;}
  for (i = 0; i < WANDS; i++)
  {
    do {j = get_rand(0, WAND_MATERIALS-1);} while (used[j]);
    used[j] = 1;
    (void) strcpy(id_wands[i].title, wand_materials[j]);
    is_wood[i] = (j > MAX_METAL);
  }
  for (i = 0; i < GEMS; i++) {used[i] = 0;}
  for (i = 0; i < RINGS; i++)
  {
    do {j = get_rand(0, GEMS-1);} while (used[j]);
    used[j] = 1;
    (void) strcpy(id_rings[i].title, gems[j]);
  }
}



struct id *get_id_table(const object *obj)
{
  switch(obj->what_is)
  {
    case SCROL: return(id_scrolls);
    case POTION: return(id_potions);
    case WAND: return(id_wands);
    case RING: return(id_rings);
    case WEAPON: return(id_weapons);
    case ARMOR: return(id_armors);
  }
  return((struct id *) 0);
}



void single_inv(short ch)
{
  char desc[DCOLS];
  object *obj;

  obj = get_letter_object(ch); if (!obj) {message("no such item."); return;}

  desc[0] = ch;
  desc[1] = ((obj->what_is & ARMOR) && obj->is_protected) ? '}' : ')';
  desc[2] = ' ';
  desc[3] = 0;
  get_desc(obj, desc+3);

  message(desc);
}



void id_type(void)
{
  const char *id;
  int ch;
  char buf[DCOLS];

  message("what do you want identified?");

  ch = rgetchar();

  if ((ch >= 'A') && (ch <= 'Z')) {id = m_names[ch-'A'];}
  else if (ch < 32) {return;}
  else
  {
    switch(ch)
    {
      case '@': id = "you"; break;
      case '%': id = "staircase"; break;
      case '^': id = "trap"; break;
      case '+': id = "door"; break;
      case '-': case '|': id = "wall of a room"; break;
      case '.': id = "floor"; break;
      case '#': id = "passage"; break;
      case ' ': id = "solid rock"; break;
      case '=': id = "ring"; break;
      case '?': id = "scroll"; break;
      case '!': id = "potion"; break;
      case '/': id = "wand or staff"; break;
      case ')': id = "weapon"; break;
      case ']': id = "armor"; break;
      case '*': id = "gold"; break;
      case ':': id = "food"; break;
      case ',': id = "the Amulet of Yendor"; break;
      default: id = "unknown character"; break;
    }
  }
  sprintf(buf, "'%c': %s", ch, id);
  message(buf);
}
//****************************************************************************



//****************************************************************************
//level.c

void make_level(void)
{
  short i, j;
  short must_1, must_2, must_3;
  boolean big_room;

  must_2 = must_3 = 0;
  if (cur_level < LAST_DUNGEON) {cur_level++;}
  if (cur_level > max_level) {max_level = cur_level;}
  must_1 = get_rand(0, 5);

  switch(must_1)
  {
    case 0: must_1 = 0; must_2 = 1; must_3 = 2; break;
    case 1: must_1 = 3; must_2 = 4; must_3 = 5; break;
    case 2: must_1 = 6; must_2 = 7; must_3 = 8; break;
    case 3: must_1 = 0; must_2 = 3; must_3 = 6; break;
    case 4: must_1 = 1; must_2 = 4; must_3 = 7; break;
    case 5: must_1 = 2; must_2 = 5; must_3 = 8; break;
  }
  if (rand_percent(8)) {party_room = 0;}
  big_room = ((party_room != NO_ROOM) && rand_percent(1));
  if (big_room) {make_room(BIG_ROOM, 0, 0, 0);}
  else
  {
    for (i = 0; i < MAXROOMS; i++) {make_room(i, must_1, must_2, must_3);}
  }
  if (!big_room)
  {
    add_mazes();

    mix_random_rooms();

    for (j = 0; j < MAXROOMS; j++)
    {
      i = random_rooms[j];

      if (i < (MAXROOMS-1)) {(void) connect_rooms(i, i+1);}
      if (i < (MAXROOMS-3)) {(void) connect_rooms(i, i+3);}
      if (i < (MAXROOMS-2))
      {
        if (rooms[i+1].is_room & R_NOTHING)
        {
          if (connect_rooms(i, i+2)) {rooms[i+1].is_room = R_CROSS;}
        }
      }
      if (i < (MAXROOMS-6))
      {
        if (rooms[i+3].is_room & R_NOTHING)
        {
          if (connect_rooms(i, i+6)) {rooms[i+3].is_room = R_CROSS;}
        }
      }
      if (is_all_connected()) {break;}
    }
    fill_out_level();
  }
  if (!has_amulet() && (cur_level >= AMULET_LEVEL)) {put_amulet();}
}



void make_room(short rn, short r1, short r2, short r3)
{
  short left_col, right_col, top_row, bottom_row;
  short width, height;
  short row_offset, col_offset;
  short i, j, ch;

  left_col = right_col = top_row = bottom_row = 0;
  switch(rn)
  {
    case 0: left_col = 0; right_col = COL1-1; top_row = MIN_ROW; bottom_row = ROW1-1; break;
    case 1: left_col = COL1+1; right_col = COL2-1; top_row = MIN_ROW; bottom_row = ROW1-1; break;
    case 2: left_col = COL2+1; right_col = DCOLS-1; top_row = MIN_ROW; bottom_row = ROW1-1; break;
    case 3: left_col = 0; right_col = COL1-1; top_row = ROW1+1; bottom_row = ROW2-1; break;
    case 4: left_col = COL1+1; right_col = COL2-1; top_row = ROW1+1; bottom_row = ROW2-1; break;
    case 5: left_col = COL2+1; right_col = DCOLS-1; top_row = ROW1+1; bottom_row = ROW2-1; break;
    case 6: left_col = 0; right_col = COL1-1; top_row = ROW2+1; bottom_row = DROWS - 2; break;
    case 7: left_col = COL1+1; right_col = COL2-1; top_row = ROW2+1; bottom_row = DROWS - 2; break;
    case 8: left_col = COL2+1; right_col = DCOLS-1; top_row = ROW2+1; bottom_row = DROWS - 2; break;
    case BIG_ROOM: top_row = get_rand(MIN_ROW, MIN_ROW+5); bottom_row = get_rand(DROWS-7, DROWS-2); left_col = get_rand(0, 10); right_col = get_rand(DCOLS-11, DCOLS-1); rn = 0; goto B;
  }
  height = get_rand(4, (bottom_row - top_row + 1));
  width = get_rand(7, (right_col - left_col - 2));

  row_offset = get_rand(0, ((bottom_row - top_row) - height + 1));
  col_offset = get_rand(0, ((right_col - left_col) - width + 1));

  top_row += row_offset;
  bottom_row = top_row + height - 1;

  left_col += col_offset;
  right_col = left_col + width - 1;

  if ((rn != r1) && (rn != r2) && (rn != r3) && rand_percent(40)) {goto END;}
B:
  rooms[rn].is_room = R_ROOM;

  for (i = top_row; i <= bottom_row; i++)
  {
    for (j = left_col; j <= right_col; j++)
    {
      if ((i == top_row) || (i == bottom_row)) {ch = HORWALL;}
      else if ( ((i != top_row) && (i != bottom_row)) && ((j == left_col) || (j == right_col))) {ch = VERTWALL;}
      else {ch = FLOOR;}
      dungeon[i][j] = ch;
    }
  }
END:
  rooms[rn].top_row = top_row;
  rooms[rn].bottom_row = bottom_row;
  rooms[rn].left_col = left_col;
  rooms[rn].right_col = right_col;
}



int connect_rooms(short room1, short room2)
{
  short row1, col1, row2, col2, dir;

  if ((!(rooms[room1].is_room & (R_ROOM | R_MAZE))) || (!(rooms[room2].is_room & (R_ROOM | R_MAZE)))) {return(0);}
  if (same_row(room1, room2) && (rooms[room1].left_col > rooms[room2].right_col))
  {
    put_door(&rooms[room1], LEFT, &row1, &col1);
    put_door(&rooms[room2], RIGHT, &row2, &col2);
    dir = LEFT;
  }
  else if (same_row(room1, room2) && (rooms[room2].left_col > rooms[room1].right_col))
  {
    put_door(&rooms[room1], RIGHT, &row1, &col1);
    put_door(&rooms[room2], LEFT, &row2, &col2);
    dir = RIGHT;
  }
  else if (same_col(room1, room2) && (rooms[room1].top_row > rooms[room2].bottom_row))
  {
    put_door(&rooms[room1], UPWARD, &row1, &col1);
    put_door(&rooms[room2], DOWN, &row2, &col2);
    dir = UPWARD;
  }
  else if (same_col(room1, room2) && (rooms[room2].top_row > rooms[room1].bottom_row))
  {
    put_door(&rooms[room1], DOWN, &row1, &col1);
    put_door(&rooms[room2], UPWARD, &row2, &col2);
    dir = DOWN;
  }
  else {return(0);}

  do {draw_simple_passage(row1, col1, row2, col2, dir);} while (rand_percent(4));

  rooms[room1].doors[dir/2].oth_room = room2;
  rooms[room1].doors[dir/2].oth_row = row2;
  rooms[room1].doors[dir/2].oth_col = col2;

  rooms[room2].doors[(((dir+4)%DIRS)/2)].oth_room = room1;
  rooms[room2].doors[(((dir+4)%DIRS)/2)].oth_row = row1;
  rooms[room2].doors[(((dir+4)%DIRS)/2)].oth_col = col1;
  return(1);
}



void clear_level(void)
{
  short i, j;

  for (i = 0; i < MAXROOMS; i++)
  {
    rooms[i].is_room = R_NOTHING;
    for (j = 0; j < 4; j++) {rooms[i].doors[j].oth_room = NO_ROOM;}
  }

  for (i = 0; i < MAX_TRAPS; i++) {traps[i].trap_type = NO_TRAP;}
  for (i = 0; i < DROWS; i++)
  {
    for (j = 0; j < DCOLS; j++) {dungeon[i][j] = NOTHING;}
  }
  detect_monster = see_invisible = 0;
  being_held = bear_trap = 0;
  party_room = NO_ROOM;
  rogue.row = rogue.col = -1;
  clear();
}



void put_door(room *rm, short dir, short *row, short *col)
{
  short wall_width;

  wall_width = (rm->is_room & R_MAZE) ? 0 : 1;

  switch(dir)
  {
    case UPWARD:
    case DOWN:
      *row = ((dir == UPWARD) ? rm->top_row : rm->bottom_row);
      do {*col = get_rand(rm->left_col+wall_width, rm->right_col-wall_width);} while (!(dungeon[*row][*col] & (HORWALL | TUNNEL)));
    break;
    case RIGHT:
    case LEFT:
      *col = (dir == LEFT) ? rm->left_col : rm->right_col;
      do {*row = get_rand(rm->top_row+wall_width, rm->bottom_row-wall_width);} while (!(dungeon[*row][*col] & (VERTWALL | TUNNEL)));
    break;
  }
  if (rm->is_room & R_ROOM) {dungeon[*row][*col] = DOOR;}
  if ((cur_level > 2) && rand_percent(HIDE_PERCENT)) {dungeon[*row][*col] |= HIDDEN;}
  rm->doors[dir/2].door_row = *row;
  rm->doors[dir/2].door_col = *col;
}



void draw_simple_passage(short row1, short col1, short row2, short col2, short dir)
{
  short i, middle, t;

  if ((dir == LEFT) || (dir == RIGHT))
  {
    if (col1 > col2)
    {
      swap(row1, row2);
      swap(col1, col2);
    }
    middle = get_rand(col1+1, col2-1);
    for (i = col1+1; i != middle; i++) {dungeon[row1][i] = TUNNEL;}
    for (i = row1; i != row2; i += (row1 > row2) ? -1 : 1) {dungeon[i][middle] = TUNNEL;}
    for (i = middle; i != col2; i++) {dungeon[row2][i] = TUNNEL;}
  }
  else
  {
    if (row1 > row2)
    {
      swap(row1, row2);
      swap(col1, col2);
    }
    middle = get_rand(row1+1, row2-1);
    for (i = row1+1; i != middle; i++) {dungeon[i][col1] = TUNNEL;}
    for (i = col1; i != col2; i += (col1 > col2) ? -1 : 1) {dungeon[middle][i] = TUNNEL;}
    for (i = middle; i != row2; i++) {dungeon[i][col2] = TUNNEL;}
  }
  if (rand_percent(HIDE_PERCENT)) {hide_boxed_passage(row1, col1, row2, col2, 1);}
}



int same_row(int room1, int room2)
{
  return((room1 / 3) == (room2 / 3));
}



int same_col(int room1, int room2)
{
  return((room1 % 3) == (room2 % 3));
}



void add_mazes(void)
{
  short i, j;
  short start;
  short maze_percent;

  if (cur_level > 1)
  {
    start = get_rand(0, (MAXROOMS-1));
    maze_percent = (cur_level * 5) / 4;

    if (cur_level > 15) {maze_percent += cur_level;}
    for (i = 0; i < MAXROOMS; i++)
    {
      j = ((start + i) % MAXROOMS);
      if (rooms[j].is_room & R_NOTHING)
      {
        if (rand_percent(maze_percent))
        {
          rooms[j].is_room = R_MAZE;
          make_maze(get_rand(rooms[j].top_row+1, rooms[j].bottom_row-1), get_rand(rooms[j].left_col+1, rooms[j].right_col-1), rooms[j].top_row, rooms[j].bottom_row, rooms[j].left_col, rooms[j].right_col);
          hide_boxed_passage(rooms[j].top_row, rooms[j].left_col, rooms[j].bottom_row, rooms[j].right_col, get_rand(0, 2));
        }
      }
    }
  }
}



void fill_out_level(void)
{
  short i, rn;

  mix_random_rooms();

  r_de = NO_ROOM;

  for (i = 0; i < MAXROOMS; i++)
  {
    rn = random_rooms[i];
    if ((rooms[rn].is_room & R_NOTHING) || ((rooms[rn].is_room & R_CROSS) && coin_toss())) {fill_it(rn, 1);}
  }
  if (r_de != NO_ROOM) {fill_it(r_de, 0);}
}



void fill_it(int rn, boolean do_rec_de)
{
  short i, tunnel_dir, door_dir, drow, dcol;
  short target_room, rooms_found = 0;
  short srow, scol, t;
  static short offsets[4] = {-1, 1, 3, -3};
  boolean did_this = 0;

  for (i = 0; i < 10; i++)
  {
    srow = get_rand(0, 3);
    scol = get_rand(0, 3);
    t = offsets[srow];
    offsets[srow] = offsets[scol];
    offsets[scol] = t;
  }
  for (i = 0; i < 4; i++)
  {
    target_room = rn + offsets[i];

    if (((target_room < 0) || (target_room >= MAXROOMS)) || (!(same_row(rn,target_room) || same_col(rn,target_room))) || (!(rooms[target_room].is_room & (R_ROOM | R_MAZE)))) {continue;}
    if (same_row(rn, target_room)) {tunnel_dir = (rooms[rn].left_col < rooms[target_room].left_col) ? RIGHT : LEFT;}
    else {tunnel_dir = (rooms[rn].top_row < rooms[target_room].top_row) ? DOWN : UPWARD;}
    door_dir = ((tunnel_dir + 4) % DIRS);
    if (rooms[target_room].doors[door_dir/2].oth_room != NO_ROOM) {continue;}
    if (((!do_rec_de) || did_this) || (!mask_room(rn, &srow, &scol, TUNNEL)))
    {
      srow = (rooms[rn].top_row + rooms[rn].bottom_row) / 2;
      scol = (rooms[rn].left_col + rooms[rn].right_col) / 2;
    }
    put_door(&rooms[target_room], door_dir, &drow, &dcol);
    rooms_found++;
    draw_simple_passage(srow, scol, drow, dcol, tunnel_dir);
    rooms[rn].is_room = R_DEADEND;
    dungeon[srow][scol] = TUNNEL;

    if ((i < 3) && (!did_this))
    {
      did_this = 1;
      if (coin_toss()) {continue;}
    }
    if ((rooms_found < 2) && do_rec_de) {recursive_deadend(rn, offsets, srow, scol);}
    break;
  }
}



void recursive_deadend(short rn, const short *offsets, short srow, short scol)
{
  short i, de;
  short drow, dcol, tunnel_dir;

  rooms[rn].is_room = R_DEADEND;
  dungeon[srow][scol] = TUNNEL;

  for (i = 0; i < 4; i++)
  {
    de = rn + offsets[i];
    if (((de < 0) || (de >= MAXROOMS)) || (!(same_row(rn, de) || same_col(rn, de)))) {continue;}
    if (!(rooms[de].is_room & R_NOTHING)) {continue;}
    drow = (rooms[de].top_row + rooms[de].bottom_row) / 2;
    dcol = (rooms[de].left_col + rooms[de].right_col) / 2;
    if (same_row(rn, de)) {tunnel_dir = (rooms[rn].left_col < rooms[de].left_col) ? RIGHT : LEFT;}
    else {tunnel_dir = (rooms[rn].top_row < rooms[de].top_row) ? DOWN : UPWARD;}
    draw_simple_passage(srow, scol, drow, dcol, tunnel_dir);
    r_de = de;
    recursive_deadend(de, offsets, drow, dcol);
  }
}



boolean mask_room(short rn, short *row, short *col, unsigned short mask)
{
  short i, j;

  for (i = rooms[rn].top_row; i <= rooms[rn].bottom_row; i++)
  {
    for (j = rooms[rn].left_col; j <= rooms[rn].right_col; j++)
    {
      if (dungeon[i][j] & mask)
      {
        *row = i;
        *col = j;
        return(1);
      }
    }
  }
  return(0);
}



void make_maze(short r, short c, short tr, short br, short lc, short rc)
{
  char dirs[4];
  short i, t;

  dirs[0] = UPWARD;
  dirs[1] = DOWN;
  dirs[2] = LEFT;
  dirs[3] = RIGHT;

  dungeon[r][c] = TUNNEL;

  if (rand_percent(20))
  {
    for (i = 0; i < 10; i++)
    {
      short t1, t2;

      t1 = get_rand(0, 3);
      t2 = get_rand(0, 3);

      swap(dirs[t1], dirs[t2]);
    }
  }
  for (i = 0; i < 4; i++)
  {
    switch(dirs[i])
    {
      case UPWARD:
        if (((r-1) >= tr) && (dungeon[r-1][c] != TUNNEL) && (dungeon[r-1][c-1] != TUNNEL) && (dungeon[r-1][c+1] != TUNNEL) && (dungeon[r-2][c] != TUNNEL)) {make_maze((r-1), c, tr, br, lc, rc);}
      break;
      case DOWN:
        if (((r+1) <= br) && (dungeon[r+1][c] != TUNNEL) && (dungeon[r+1][c-1] != TUNNEL) && (dungeon[r+1][c+1] != TUNNEL) && (dungeon[r+2][c] != TUNNEL)) {make_maze((r+1), c, tr, br, lc, rc);}
      break;
      case LEFT:
        if (((c-1) >= lc) && (dungeon[r][c-1] != TUNNEL) && (dungeon[r-1][c-1] != TUNNEL) && (dungeon[r+1][c-1] != TUNNEL) && (dungeon[r][c-2] != TUNNEL)) {make_maze(r, (c-1), tr, br, lc, rc);}
      break;
      case RIGHT:
        if (((c+1) <= rc) && (dungeon[r][c+1] != TUNNEL) && (dungeon[r-1][c+1] != TUNNEL) && (dungeon[r+1][c+1] != TUNNEL) && (dungeon[r][c+2] != TUNNEL)) {make_maze(r, (c+1), tr, br, lc, rc);}
      break;
    }
  }
}



void hide_boxed_passage(short row1, short col1, short row2, short col2, short n)
{
  short i, j, t;
  short row, col, row_cut, col_cut;
  short h, w;

  if (cur_level > 2)
  {
    if (row1 > row2) {swap(row1, row2);}
    if (col1 > col2) {swap(col1, col2);}
    h = row2 - row1;
    w = col2 - col1;

    if ((w >= 5) || (h >= 5))
    {
      row_cut = ((h >= 2) ? 1 : 0);
      col_cut = ((w >= 2) ? 1 : 0);

      for (i = 0; i < n; i++)
      {
        for (j = 0; j < 10; j++)
        {
          row = get_rand(row1 + row_cut, row2 - row_cut);
          col = get_rand(col1 + col_cut, col2 - col_cut);
          if (dungeon[row][col] == TUNNEL)
          {
            dungeon[row][col] |= HIDDEN;
            break;
          }
        }
      }
    }
  }
}



//nr: try not to put in this room
void put_player(short nr)
{
  short rn = nr, misses;
  short row = 0, col = 0;

  for (misses = 0; ((misses < 2) && (rn == nr)); misses++)
  {
    gr_row_col(&row, &col, (FLOOR | TUNNEL | OBJECT | STAIRS));
    rn = get_room_number(row, col);
  }
  rogue.row = row;
  rogue.col = col;

  if (dungeon[rogue.row][rogue.col] & TUNNEL) {cur_room = PASSAGE;}
  else {cur_room = rn;}
  if (cur_room != PASSAGE) {light_up_room(cur_room);}
  else {light_passage(rogue.row, rogue.col);}
  rn = get_room_number(rogue.row, rogue.col);
  wake_room(rn, 1, rogue.row, rogue.col);
  if (new_level_message)
  {
    message(new_level_message);
    new_level_message = 0;
  }
  mvaddch(rogue.row, rogue.col, rogue.fchar);
}



int drop_check(void)
{
  if (wizard) {return(1);}
  if (dungeon[rogue.row][rogue.col] & STAIRS)
  {
    if (levitate)
    {
      message("you're floating in the air!");
      return(0);
    }
    return(1);
  }
  message("I see no way down");
  return(0);
}



int check_up(void)
{
  if (!wizard)
  {
    if (!(dungeon[rogue.row][rogue.col] & STAIRS)) {message("I see no way up"); return 0;}
    if (!has_amulet()) {message("your way is magically blocked"); return 0;}
  }

  new_level_message = "you feel a wrenching sensation in your gut";

  if (cur_level == 1) win();

  cur_level -= 2;
  return 1;
}



void add_exp(int e, boolean promotion)
{
  char mbuf[40];
  short new_exp;
  short i, hp;

  rogue.exp_points += e;

  if (rogue.exp_points >= level_points[rogue.exp-1])
  {
    new_exp = get_exp_level(rogue.exp_points);
    if (rogue.exp_points > MAX_EXP) {rogue.exp_points = MAX_EXP + 1;}
    for (i = rogue.exp+1; i <= new_exp; i++)
    {
      PlayAudio("ExperienceSound");

      sprintf(mbuf, "welcome to level %d", i);
      message(mbuf);
      if (promotion)
      {
        hp = hp_raise();

        rogue.hp_current += hp;
        if (rogue.hp_current>MAX_HP) rogue.hp_current = MAX_HP;

        rogue.hp_max += hp;
        if (rogue.hp_max>MAX_HP) rogue.hp_max = MAX_HP;
      }
      rogue.exp = i;
    }
  }
}



int get_exp_level(long e)
{
  short i;

  for (i = 0; i < (MAX_EXP_LEVEL - 1); i++)
  {
    if (level_points[i] > e) {break;}
  }
  return(i+1);
}



int hp_raise(void)
{
  int hp;

  hp = (wizard ? 10 : get_rand(3, 10));
  return(hp);
}



void show_average_hp(void)
{
  char mbuf[80];
  float real_average;
  float effective_average;

  if (rogue.exp == 1) {real_average = effective_average = 0.00;}
  else
  {
    real_average = (float) ((rogue.hp_max - extra_hp - INIT_HP) + less_hp) / (rogue.exp - 1);
    effective_average = (float) (rogue.hp_max - INIT_HP) / (rogue.exp - 1);
  }
  sprintf(mbuf, "R-Hp: %.2f, E-Hp: %.2f (!: %d, V: %d)", real_average, effective_average, extra_hp, less_hp);
  message(mbuf);
}



void mix_random_rooms(void)
{
  short i, t;
  short x, y;

  for (i = 0; i < (3 * MAXROOMS); i++)
  {
    do
    {
      x = get_rand(0, (MAXROOMS-1));
      y = get_rand(0, (MAXROOMS-1));
    } while (x == y);
    swap(random_rooms[x], random_rooms[y]);
  }
}
//****************************************************************************



//****************************************************************************
//monster.c

void put_mons(void)
{
  short i;
  short n;
  object *monster;
  short row, col;

  n = get_rand(4, 6);

  for (i = 0; i < n; i++)
  {
    monster = gr_monster((object *) 0, 0);
    if ((monster->m_flags & WANDERS) && coin_toss()) {wake_up(monster);}
    gr_row_col(&row, &col, (FLOOR | TUNNEL | STAIRS | OBJECT));
    put_m_at(row, col, monster);
  }
}



object *gr_monster(object *monster, int mn)
{
  if (!monster)
  {
    monster = alloc_object();

    for (;;)
    {
      mn = get_rand(0, MONSTERS-1);
      if ((cur_level >= mon_tab[mn].first_level) && (cur_level <= mon_tab[mn].last_level)) {break;}
    }
  }
  *monster = mon_tab[mn];
  if (monster->m_flags & IMITATES) {monster->disguise = gr_obj_char();}
  if (cur_level > (AMULET_LEVEL + 2)) {monster->m_flags |= HASTED;}
  monster->trow = NO_ROOM;
  return(monster);
}



void mv_mons(void)
{
  object *monster, *next_monster, *test_mons;
  boolean flew;

  if (haste_self % 2) {return;}

  monster = level_monsters.next_monster;

  while (monster)
  {
    next_monster = monster->next_monster;
    mon_disappeared = 0;
    if (monster->m_flags & HASTED)
    {
      mv_1_monster(monster, rogue.row, rogue.col);
      if (mon_disappeared) {goto NM;}
    }
    else if (monster->m_flags & SLOWED)
    {
      monster->slowed_toggle = !monster->slowed_toggle;
      if (monster->slowed_toggle) {goto NM;}
    }
    if ((monster->m_flags & CONFUSED) && move_confused(monster)) {goto NM;}
    flew = 0;
    if ((monster->m_flags & FLIES) && !(monster->m_flags & NAPPING) && !mon_can_go(monster, rogue.row, rogue.col))
    {
      flew = 1;
      mv_1_monster(monster, rogue.row, rogue.col);
      if (mon_disappeared) {goto NM;}
    }
    if (!(flew && mon_can_go(monster, rogue.row, rogue.col))) {mv_1_monster(monster, rogue.row, rogue.col);}
NM:
    test_mons = level_monsters.next_monster;
    monster = NULL;
    while (test_mons)
    {
      if (next_monster == test_mons)
      {
        monster = next_monster;
        break;
      }
      test_mons = test_mons -> next_monster;
    }
  }
}



void party_monsters(int rn, int n)
{
  short i, j;
  short row, col;
  object *monster;
  boolean found;

  row = col = 0;
  n += n;

  for (i = 0; i < MONSTERS; i++)
  {
    mon_tab[i].first_level -= (cur_level % 3);
  }
  for (i = 0; i < n; i++)
  {
    if (no_room_for_monster(rn)) {break;}
    for (j = found = 0; ((!found) && (j < 250)); j++)
    {
      row = get_rand(rooms[rn].top_row+1, rooms[rn].bottom_row-1);
      col = get_rand(rooms[rn].left_col+1, rooms[rn].right_col-1);
      if ((!(dungeon[row][col] & MONSTER)) && (dungeon[row][col] & (FLOOR | TUNNEL))) {found = 1;}
    }
    if (found)
    {
      monster = gr_monster((object *) 0, 0);
      if (!(monster->m_flags & IMITATES)) {monster->m_flags |= WAKENS;}
      put_m_at(row, col, monster);
    }
  }
  for (i = 0; i < MONSTERS; i++) {mon_tab[i].first_level += (cur_level % 3);}
}



char gmc_row_col(int row, int col)
{
  object *monster;

  if ((monster = object_at(&level_monsters, row, col)) != NULL)
  {
    if ((!(detect_monster || see_invisible || r_see_invisible) && (monster->m_flags & INVISIBLE)) || blind) {return(monster->trail_char);}
    if (monster->m_flags & IMITATES) {return(monster->disguise);}
    return(monster->m_char);
  }
  else
  {
    return('&'); //BUG if this ever happens
  }
}



char gmc(object *monster)
{
  if ((!(detect_monster || see_invisible || r_see_invisible) && (monster->m_flags & INVISIBLE)) || blind) {return(monster->trail_char);}
  if (monster->m_flags & IMITATES) {return(monster->disguise);}
  return(monster->m_char);
}



void mv_1_monster(object *monster, short row, short col)
{
  short i, n;
  boolean tried[6];

  if (monster->m_flags & ASLEEP)
  {
    if (monster->m_flags & NAPPING)
    {
      if (--monster->nap_length <= 0) {monster->m_flags &= (~(NAPPING | ASLEEP));}
      return;
    }
    if ((monster->m_flags & WAKENS) && rogue_is_around(monster->row, monster->col) && rand_percent(((stealthy > 0) ? (WAKE_PERCENT / (STEALTH_FACTOR + stealthy)) : WAKE_PERCENT))) {wake_up(monster);}
    return;
  }
  else if (monster->m_flags & ALREADY_MOVED)
  {
    monster->m_flags &= (~ALREADY_MOVED);
    return;
  }
  if ((monster->m_flags & FLITS) && flit(monster)) {return;}
  if ((monster->m_flags & STATIONARY) && (!mon_can_go(monster, rogue.row, rogue.col))) {return;}
  if (monster->m_flags & FREEZING_ROGUE) {return;}
  if ((monster->m_flags & CONFUSES) && m_confuse(monster)) {return;}
  if (mon_can_go(monster, rogue.row, rogue.col))
  {
    mon_hit(monster);
    return;
  }
  if ((monster->m_flags & FLAMES) && flame_broil(monster)) {return;}
  if ((monster->m_flags & SEEKS_GOLD) && seek_gold(monster)) {return;}
  if ((monster->trow == monster->row) && (monster->tcol == monster->col)) {monster->trow = NO_ROOM;}
  else if (monster->trow != NO_ROOM)
  {
    row = monster->trow;
    col = monster->tcol;
  }
  if (monster->row > row) {row = monster->row - 1;}
  else if (monster->row < row) {row = monster->row + 1;}
  if ((dungeon[row][monster->col] & DOOR) && mtry(monster, row, monster->col)) {return;}
  if (monster->col > col) {col = monster->col - 1;}
  else if (monster->col < col) {col = monster->col + 1;}
  if ((dungeon[monster->row][col] & DOOR) && mtry(monster, monster->row, col)) {return;}
  if (mtry(monster, row, col)) {return;}

  for (i = 0; i <= 5; i++) tried[i] = 0;

  for (i = 0; i < 6; i++)
  {
NEXT_TRY:
    n = get_rand(0, 5);
    switch(n)
    {
      case 0:
        if (!tried[n] && mtry(monster, row, monster->col-1)) {goto O;}
      break;
      case 1:
        if (!tried[n] && mtry(monster, row, monster->col)) {goto O;}
      break;
      case 2:
        if (!tried[n] && mtry(monster, row, monster->col+1)) {goto O;}
      break;
      case 3:
        if (!tried[n] && mtry(monster, monster->row-1, col)) {goto O;}
      break;
      case 4:
        if (!tried[n] && mtry(monster, monster->row, col)) {goto O;}
      break;
      case 5:
        if (!tried[n] && mtry(monster, monster->row+1, col)) {goto O;}
      break;
    }
    if (!tried[n]) {tried[n] = 1;}
    else {goto NEXT_TRY;}
  }
O:
  if ((monster->row == monster->o_row) && (monster->col == monster->o_col))
  {
    if (++(monster->o) > 4)
    {
      if ((monster->trow == NO_ROOM) && (!mon_sees(monster, rogue.row, rogue.col)))
      {
        monster->trow = get_rand(1, (DROWS - 2));
        monster->tcol = get_rand(0, (DCOLS - 1));
      }
      else
      {
        monster->trow = NO_ROOM;
        monster->o = 0;
      }
    }
  }
  else
  {
    monster->o_row = monster->row;
    monster->o_col = monster->col;
    monster->o = 0;
  }
}



int mtry(object *monster, short row, short col)
{
  if (mon_can_go(monster, row, col))
  {
    move_mon_to(monster, row, col);
    return(1);
  }
  return(0);
}



void move_mon_to(object *monster, short row, short col)
{
  short c;
  int mrow, mcol;

  mrow = monster->row;
  mcol = monster->col;

  dungeon[mrow][mcol] &= ~MONSTER;
  dungeon[row][col] |= MONSTER;

  c = mvinch(mrow, mcol);

  if ((c >= 'A') && (c <= 'Z'))
  {
    if (!detect_monster) {mvaddch(mrow, mcol, monster->trail_char);}
    else
    {
      if (rogue_can_see(mrow, mcol)) {mvaddch(mrow, mcol, monster->trail_char);}
      else
      {
        if (monster->trail_char == '.') {monster->trail_char = ' ';}
        mvaddch(mrow, mcol, monster->trail_char);
      }
    }
  }
  monster->trail_char = mvinch(row, col);
  if (!blind && (detect_monster || rogue_can_see(row, col)))
  {
    if ((!(monster->m_flags & INVISIBLE) || (detect_monster || see_invisible || r_see_invisible))) {mvaddch(row, col, gmc(monster));}
  }
  if ((dungeon[row][col] & DOOR) && (get_room_number(row, col) != cur_room) && (dungeon[mrow][mcol] == FLOOR) && !blind) {mvaddch(mrow, mcol, ' ');}
  if (dungeon[row][col] & DOOR) {dr_course(monster, ((dungeon[mrow][mcol] & TUNNEL) ? 1 : 0), row, col);}
  else
  {
    monster->row = row;
    monster->col = col;
  }
}



int mon_can_go(const object *monster, short row, short col)
{
  object *obj;
  short dr, dc;

  dr = monster->row - row; //check if move distance > 1
  if ((dr >= 2) || (dr <= -2)) {return(0);}
  dc = monster->col - col;
  if ((dc >= 2) || (dc <= -2)) {return(0);}
  if ((!dungeon[monster->row][col]) || (!dungeon[row][monster->col])) {return(0);}
  if ((!is_passable(row, col)) || (dungeon[row][col] & MONSTER)) {return(0);}
  if ((monster->row!=row)&&(monster->col!=col)&&((dungeon[row][col]&DOOR) || (dungeon[monster->row][monster->col]&DOOR))) {return(0);}
  if (!(monster->m_flags & (FLITS | CONFUSED | CAN_FLIT)) && (monster->trow == NO_ROOM))
  {
    if ((monster->row < rogue.row) && (row < monster->row)) return(0);
    if ((monster->row > rogue.row) && (row > monster->row)) return(0);
    if ((monster->col < rogue.col) && (col < monster->col)) return(0);
    if ((monster->col > rogue.col) && (col > monster->col)) return(0);
  }
  if (dungeon[row][col] & OBJECT)
  {
    obj = object_at(&level_objects, row, col);
    if ((obj->what_is == SCROL) && (obj->which_kind == SCARE_MONSTER)) {return(0);}
  }
  return(1);
}



void wake_up(object *monster)
{
  if (!(monster->m_flags & NAPPING)) {monster->m_flags &= (~(ASLEEP | IMITATES | WAKENS));}
}



void wake_room(short rn, boolean entering, short row, short col)
{
  object *monster;
  short wake_percent;
  boolean in_room;

  wake_percent = (rn == party_room) ? PARTY_WAKE_PERCENT : WAKE_PERCENT;
  if (stealthy > 0) {wake_percent /= (STEALTH_FACTOR + stealthy);}

  monster = level_monsters.next_monster;

  while (monster)
  {
    in_room = (rn == get_room_number(monster->row, monster->col));
    if (in_room)
    {
      if (entering) {monster->trow = NO_ROOM;}
      else
      {
        monster->trow = row;
        monster->tcol = col;
      }
    }
    if ((monster->m_flags & WAKENS) && (rn == get_room_number(monster->row, monster->col)))
    {
      if (rand_percent(wake_percent)) {wake_up(monster);}
    }
    monster = monster->next_monster;
  }
}



const char *mon_name(const object *monster)
{
  short ch;

  if (blind || ((monster->m_flags & INVISIBLE) && !(detect_monster || see_invisible || r_see_invisible))) {return("something");}
  if (halluc)
  {
    ch = get_rand('A', 'Z') - 'A';
    return(m_names[ch]);
  }
  ch = monster->m_char - 'A';
  return(m_names[ch]);
}



int rogue_is_around(int row, int col)
{
  short rdif, cdif, retval;

  rdif = row - rogue.row;
  cdif = col - rogue.col;

  retval = (rdif >= -1) && (rdif <= 1) && (cdif >= -1) && (cdif <= 1);
  return(retval);
}



void wanderer(void)
{
  object *monster = 0;
  short row, col, i;
  boolean found = 0;

  for (i = 0; ((i < 15) && (!found)); i++)
  {
    monster = gr_monster((object *) 0, 0);
    if (!(monster->m_flags & (WAKENS | WANDERS))) {free_object(monster);}
    else {found = 1;}
  }
  if (found)
  {
    found = 0;
    wake_up(monster);
    for (i = 0; ((i < 25) && (!found)); i++)
    {
      gr_row_col(&row, &col, (FLOOR | TUNNEL | STAIRS | OBJECT));
      if (!rogue_can_see(row, col))
      {
        put_m_at(row, col, monster);
        found = 1;
      }
    }
    if (!found) {free_object(monster);}
  }
}



void show_monsters(void)
{
  object *monster;

  detect_monster = 1;

  if (blind) {return;}
  monster = level_monsters.next_monster;

  while (monster)
  {
    mvaddch(monster->row, monster->col, monster->m_char);
    if (monster->m_flags & IMITATES)
    {
      monster->m_flags &= (~IMITATES);
      monster->m_flags |= WAKENS;
    }
    monster = monster->next_monster;
  }
}



void create_monster(void)
{
  short row, col;
  short i;
  boolean found = 0;
  object *monster;

  row = rogue.row;
  col = rogue.col;

  for (i = 0; i < 9; i++)
  {
    rand_around(i, &row, &col);
    if (((row == rogue.row) && (col = rogue.col)) || (row < MIN_ROW) || (row > (DROWS-2)) || (col < 0) || (col > (DCOLS-1))) {continue;}
    if ((!(dungeon[row][col] & MONSTER)) && (dungeon[row][col] & (FLOOR|TUNNEL|STAIRS|DOOR)))
    {
      found = 1;
      break;
    }
  }
  if (found)
  {
    monster = gr_monster((object *) 0, 0);
    put_m_at(row, col, monster);
    mvaddch(row, col, gmc(monster));
    if (monster->m_flags & (WANDERS | WAKENS)) {wake_up(monster);}
  }
  else {message("you hear a faint cry of anguish in the distance");}
}



void put_m_at(short row, short col, object *monster)
{
  monster->row = row;
  monster->col = col;
  dungeon[row][col] |= MONSTER;
  monster->trail_char = mvinch(row, col);
  (void) add_to_pack(monster, &level_monsters, 0);
  aim_monster(monster);
}



void aim_monster(object *monster)
{
  short i, rn, d, r;

  rn = get_room_number(monster->row, monster->col);
  r = get_rand(0, 12);

  for (i = 0; i < 4; i++)
  {
    d = (r + i) % 4;
    if (rooms[rn].doors[d].oth_room != NO_ROOM)
    {
      monster->trow = rooms[rn].doors[d].door_row;
      monster->tcol = rooms[rn].doors[d].door_col;
      break;
    }
  }
}



int rogue_can_see(int row, int col)
{
  int retval;

  retval = !blind && (((get_room_number(row, col) == cur_room) && !(rooms[cur_room].is_room & R_MAZE)) || rogue_is_around(row, col));

  return(retval);
}



int move_confused(object *monster)
{
  short i, row, col;

  if (!(monster->m_flags & ASLEEP))
  {
    if (--monster->moves_confused <= 0) {monster->m_flags &= (~CONFUSED);}
    if (monster->m_flags & STATIONARY) {return(coin_toss() ? 1 : 0);}
    else if (rand_percent(15)) {return(1);}
    row = monster->row;
    col = monster->col;

    for (i = 0; i < 9; i++)
    {
      rand_around(i, &row, &col);
      if ((row == rogue.row) && (col == rogue.col)) {return(0);}
      if (mtry(monster, row, col)) {return(1);}
    }
  }
  return(0);
}



int flit(object *monster)
{
  short i, row, col;

  if (!rand_percent(FLIT_PERCENT + ((monster->m_flags & FLIES) ? 20 : 0))) {return(0);}
  if (rand_percent(10)) {return(1);}
  row = monster->row;
  col = monster->col;

  for (i = 0; i < 9; i++)
  {
    rand_around(i, &row, &col);
    if ((row == rogue.row) && (col == rogue.col)) {continue;}
    if (mtry(monster, row, col)) {return(1);}
  }
  return(1);
}



char gr_obj_char(void)
{
  short r;
  const char *rs = "%!?]=/):*";

  r = get_rand(0, 8);

  return(rs[r]);
}



int no_room_for_monster(int rn)
{
  short i, j;

  for (i = rooms[rn].top_row+1; i < rooms[rn].bottom_row; i++)
  {
    for (j = rooms[rn].left_col+1; j < rooms[rn].right_col; j++)
    {
      if (!(dungeon[i][j] & MONSTER)) {return(0);}
    }
  }
  return(1);
}



void aggravate(void)
{
  object *monster;

  message("you hear a high pitched humming noise");

  monster = level_monsters.next_monster;

  while (monster)
  {
    wake_up(monster);
    monster->m_flags &= (~IMITATES);
    if (rogue_can_see(monster->row, monster->col)) {mvaddch(monster->row, monster->col, monster->m_char);}
    monster = monster->next_monster;
  }
}



boolean mon_sees(const object *monster, int row, int col)
{
  short rn, rdif, cdif, retval;

  rn = get_room_number(row, col);

  if ((rn != NO_ROOM) && (rn == get_room_number(monster->row, monster->col)) && !(rooms[rn].is_room & R_MAZE)) {return(1);}
  rdif = row - monster->row;
  cdif = col - monster->col;

  retval = (rdif >= -1) && (rdif <= 1) && (cdif >= -1) && (cdif <= 1);
  return(retval);
}



void mv_aquatars(void)
{
  object *monster;

  monster = level_monsters.next_monster;

  while (monster)
  {
    if ((monster->m_char == 'A') && mon_can_go(monster, rogue.row, rogue.col))
    {
      mv_1_monster(monster, rogue.row, rogue.col);
      monster->m_flags |= ALREADY_MOVED;
    }
    monster = monster->next_monster;
  }
}
//****************************************************************************



//****************************************************************************
//move.c

int one_move_rogue(short dirch, short pickup)
{
  short row, col;
  object *obj;
  char desc[DCOLS];
  short n, status, d;

  row = rogue.row;
  col = rogue.col;

  if (confused) {dirch = gr_dir();}
  (void) is_direction(dirch, &d);
  get_dir_rc(d, &row, &col, 1);

  if (!can_move(rogue.row, rogue.col, row, col)) {return(MOVE_FAILED);}
  if (being_held || bear_trap)
  {
    if (!(dungeon[row][col] & MONSTER))
    {
      if (being_held)
      {
        message("you are being held");
        interrupted = 1;
      }
      else
      {
        message("you are still stuck in the bear trap");
        (void) reg_move();
      }
      return(MOVE_FAILED);
    }
  }
  if (r_teleport)
  {
    if (rand_percent(R_TELE_PERCENT))
    {
      tele();
      return(STOPPED_ON_SOMETHING);
    }
  }
  if (dungeon[row][col] & MONSTER)
  {
    rogue_hit(object_at(&level_monsters, row, col), 0);
    (void) reg_move();
    return(MOVE_FAILED);
  }
  if (dungeon[row][col] & DOOR)
  {
    if (cur_room == PASSAGE)
    {
      cur_room = get_room_number(row, col);
      light_up_room(cur_room);
      wake_room(cur_room, 1, row, col);
    }
    else {light_passage(row, col);}
  }
  else if ((dungeon[rogue.row][rogue.col] & DOOR) && (dungeon[row][col] & TUNNEL))
  {
    light_passage(row, col);
    wake_room(cur_room, 0, rogue.row, rogue.col);
    darken_room(cur_room);
    cur_room = PASSAGE;
  }
  else if (dungeon[row][col] & TUNNEL) {light_passage(row, col);}
  mvaddch(rogue.row, rogue.col, get_dungeon_char(rogue.row, rogue.col));
  mvaddch(row, col, rogue.fchar);

  rogue.row = row;
  rogue.col = col;

  if (dungeon[row][col] & OBJECT)
  {
    if (levitate && pickup) {return(STOPPED_ON_SOMETHING);}
    if (pickup && !levitate)
    {
      if ((obj = pick_up(row, col, &status)) != NULL)
      {
        get_desc(obj, desc);
        if (obj->what_is == GOLD)
        {
          free_object(obj);
          goto NOT_IN_PACK;
        }
      }
      else if (!status) {goto MVED;}
      else {goto MOVE_ON;}
    }
    else
    {
MOVE_ON:
      obj = object_at(&level_objects, row, col);
      (void) strcpy(desc, "moved onto ");
      get_desc(obj, desc+11);
      goto NOT_IN_PACK;
    }
    n = strlen(desc);
    desc[n] = '(';
    desc[n+1] = obj->ichar;
    desc[n+2] = ')';
    desc[n+3] = 0;
NOT_IN_PACK:
    message(desc);
    interrupted = 1;
    (void) reg_move();
    return(STOPPED_ON_SOMETHING);
  }
  if (dungeon[row][col] & (DOOR | STAIRS | TRAP))
  {
    if ((!levitate) && (dungeon[row][col] & TRAP)) {trap_player(row, col);}
    (void) reg_move();
    return(STOPPED_ON_SOMETHING);
  }
MVED:
  if (reg_move())
  {
    //fainted from hunger
    return(STOPPED_ON_SOMETHING);
  }
  return((confused ? STOPPED_ON_SOMETHING : MOVED));
}



void multiple_move_rogue(short dirch)
{
  switch (dirch)
  {
    case '\010': case '\012': case '\013': case '\014': case '\031': case '\025': case '\016': case '\002':
    {
      short row, col, m;

      do
      {
        row = rogue.row;
        col = rogue.col;
        if (((m = one_move_rogue((dirch + 96), 1)) == MOVE_FAILED) || (m == STOPPED_ON_SOMETHING) || interrupted) break;

        tick_pause();

      } while (!next_to_something(row, col));

      if ((!interrupted) && passgo && (m == MOVE_FAILED) && (dungeon[rogue.row][rogue.col] & TUNNEL)) turn_passage(dirch + 96, 0);
    }
    break;

    case 'H': case 'J': case 'K': case 'L': case 'B': case 'Y': case 'U': case 'N':
    {
      while ((!interrupted) && (one_move_rogue((dirch + 32), 1) == MOVED)) tick_pause();

      if ((!interrupted) && passgo && (dungeon[rogue.row][rogue.col] & TUNNEL)) turn_passage(dirch + 32, 1);
    }
    break;
  }
}



boolean is_passable(int row, int col)
{
  if ((row < MIN_ROW) || (row > (DROWS - 2)) || (col < 0) || (col > (DCOLS-1))) {return(0);}
  if (dungeon[row][col] & HIDDEN) {return((dungeon[row][col] & TRAP) ? 1 : 0);}
  return(dungeon[row][col] & (FLOOR | TUNNEL | DOOR | STAIRS | TRAP));
}



boolean next_to_something(int drow, int dcol)
{
  short i, j, i_end, j_end, row, col;
  short pass_count = 0;
  unsigned short s;

  if (confused) {return(1);}
  if (blind) {return(0);}
  i_end = (rogue.row < (DROWS-2)) ? 1 : 0;
  j_end = (rogue.col < (DCOLS-1)) ? 1 : 0;

  for (i = ((rogue.row > MIN_ROW) ? -1 : 0); i <= i_end; i++)
  {
    for (j = ((rogue.col > 0) ? -1 : 0); j <= j_end; j++)
    {
      if ((i == 0) && (j == 0)) {continue;}
      if (((rogue.row+i) == drow) && ((rogue.col+j) == dcol)) {continue;}
      row = rogue.row + i;
      col = rogue.col + j;
      s = dungeon[row][col];
      if (s & HIDDEN) {continue;}
      //If the rogue used to be right, up, left, down, or right of row,col, and now isn't, then don't stop
      if (s & (MONSTER | OBJECT | STAIRS))
      {
        if (((row == drow) || (col == dcol)) && (!((row == rogue.row) || (col == rogue.col)))) {continue;}
        return(1);
      }
      if (s & TRAP)
      {
        if (!(s & HIDDEN))
        {
          if (((row == drow) || (col == dcol)) && (!((row == rogue.row) || (col == rogue.col)))) {continue;}
          return(1);
        }
      }
      if ((((i - j) == 1) || ((i - j) == -1)) && (s & TUNNEL))
      {
        if (++pass_count > 1) {return(1);}
      }
      if ((s & DOOR) && ((i == 0) || (j == 0))) {return(1);}
    }
  }
  return(0);
}



boolean can_move(int row1, int col1, int row2, int col2)
{
  if (!is_passable(row2, col2)) {return(0);}
  if ((row1 != row2) && (col1 != col2))
  {
    if ((dungeon[row1][col1] & DOOR) || (dungeon[row2][col2] & DOOR)) {return(0);}
    if ((!dungeon[row1][col2]) || (!dungeon[row2][col1])) {return(0);}
  }
  return(1);
}



void move_onto(void)
{
  short ch, d;



  message("direction?");
  SetDirArrow(8);
  while (!is_direction(ch = rgetchar(), &d)) sound_bell();
  SetDirArrow(-1);
  if (ch==CANCEL) return;



  (void) one_move_rogue(ch, 0);
}



boolean is_direction(short c, short *d)
{
  switch(c)
  {
    case 'h': *d = LEFT; break;
    case 'j': *d = DOWN; break;
    case 'k': *d = UPWARD; break;
    case 'l': *d = RIGHT; break;
    case 'b': *d = DOWNLEFT; break;
    case 'y': *d = UPLEFT; break;
    case 'u': *d = UPRIGHT; break;
    case 'n': *d = DOWNRIGHT; break;
    case CANCEL: break;
    default: return(0);
  }
  return(1);
}



boolean check_hunger(boolean msg_only)
{
  short i, n;
  boolean fainted = 0;

  if (rogue.moves_left == HUNGRY)
  {
    (void) strcpy(hunger_str, "hungry");
    message(hunger_str);
  }
  if (rogue.moves_left == WEAK)
  {
    (void) strcpy(hunger_str, "weak");
    message(hunger_str);
    interrupted = 1;
  }
  if (rogue.moves_left <= FAINT)
  {
    if (rogue.moves_left == FAINT)
    {
      (void) strcpy(hunger_str, "faint");
      message(hunger_str);
      interrupted = 1;
    }
    n = get_rand(0, (FAINT - rogue.moves_left));
    if (n > 0)
    {
      fainted = 1;
      if (rand_percent(40)) {rogue.moves_left++;}
      message("you faint");
      interrupted = 1;
      for (i = 0; i < n; i++)
      {
        if (coin_toss()) {mv_mons();}
      }
      message(you_can_move_again);
      interrupted = 1;
    }
  }
  if (msg_only) {return(fainted);}
  if (rogue.moves_left <= STARVE) {killed_by((object *) 0, STARVATION);}

  switch(e_rings)
  {
    case -1: rogue.moves_left -= (rogue.moves_left % 2); break;
    case 0: rogue.moves_left--; break;
    case 1: rogue.moves_left--; (void) check_hunger(1); rogue.moves_left -= (rogue.moves_left % 2); break;
    case 2: rogue.moves_left--; (void) check_hunger(1); rogue.moves_left--; break;
  }
  return(fainted);
}



boolean reg_move(void)
{
  boolean fainted;

  if ((rogue.moves_left <= HUNGRY) || (cur_level >= max_level)) {fainted = check_hunger(0);}
  else {fainted = 0;}

  mv_mons();

  if (++m_moves >= 120)
  {
    m_moves = 0;
    wanderer();
  }
  if (halluc)
  {
    if (!(--halluc)) {unhallucinate();}
    else {hallucinate();}
  }
  if (blind)
  {
    if (!(--blind)) {unblind();}
  }
  if (confused)
  {
    if (!(--confused)) {unconfuse();}
  }
  if (bear_trap) {bear_trap--;}
  if (levitate)
  {
    if (!(--levitate))
    {
      message("you float gently to the ground");
      interrupted = 1;
      if (dungeon[rogue.row][rogue.col] & TRAP) {trap_player(rogue.row, rogue.col);}
    }
  }
  if (haste_self)
  {
    if (!(--haste_self)) {message("you feel yourself slowing down");}
  }
  heal();
  if (auto_search > 0) {search(auto_search, auto_search);}
  return(fainted);
}



void rest(int count)
{
  int i;

  interrupted = 0;

  for (i = 0; i < count; i++)
  {
    if (interrupted) {break;}

    (void) reg_move();



    if (PrefixCount>0) PrefixCount--;
    if (count>1) if (tick_pause()) break;
  }
}



char gr_dir(void)
{
  short d;

  d = get_rand(1, 8);

  switch(d)
  {
    case 1: d = 'j'; break;
    case 2: d = 'k'; break;
    case 3: d = 'l'; break;
    case 4: d = 'h'; break;
    case 5: d = 'y'; break;
    case 6: d = 'u'; break;
    case 7: d = 'b'; break;
    case 8: d = 'n'; break;
  }
  return(d);
}



void heal(void)
{
  static short heal_exp = -1, n, c = 0;
  static boolean alt;

  if (rogue.hp_current == rogue.hp_max)
  {
    c = 0;
    return;
  }
  if (rogue.exp != heal_exp)
  {
    heal_exp = rogue.exp;

    switch(heal_exp)
    {
      case 1: n = 20; break;
      case 2: n = 18; break;
      case 3: n = 17; break;
      case 4: n = 14; break;
      case 5: n = 13; break;
      case 6: n = 10; break;
      case 7: n = 9; break;
      case 8: n = 8; break;
      case 9: n = 7; break;
      case 10: n = 4; break;
      case 11: n = 3; break;
      case 12:
      default: n = 2;
    }
  }
  if (++c >= n)
  {
    c = 0;
    rogue.hp_current++;
    if ((alt = !alt) != 0) {rogue.hp_current++;}
    if ((rogue.hp_current += regeneration) > rogue.hp_max) {rogue.hp_current = rogue.hp_max;}
  }
}



boolean can_turn(short nrow, short ncol)
{
  if ((dungeon[nrow][ncol] & TUNNEL) && is_passable(nrow, ncol)) {return(1);}
  return(0);
}



void turn_passage(short dir, boolean fast)
{
  short crow = rogue.row, ccol = rogue.col, turns = 0;
  short ndir = 0;

  if ((dir != 'h') && can_turn(crow, ccol + 1))
  {
    turns++;
    ndir = 'l';
  }
  if ((dir != 'l') && can_turn(crow, ccol - 1))
  {
    turns++;
    ndir = 'h';
  }
  if ((dir != 'k') && can_turn(crow + 1, ccol))
  {
    turns++;
    ndir = 'j';
  }
  if ((dir != 'j') && can_turn(crow - 1, ccol))
  {
    turns++;
    ndir = 'k';
  }
  if (turns == 1) {multiple_move_rogue(ndir - (fast ? 32 : 96));}
}
//****************************************************************************



//****************************************************************************
//object.c

void put_objects(void)
{
  short i, n;
  object *obj;

  if (cur_level < max_level) {return;}
  n = coin_toss() ? get_rand(2, 4) : get_rand(3, 5);
  while (rand_percent(33)) {n++;}
  if (party_room != NO_ROOM) {make_party();}
  for (i = 0; i < n; i++)
  {
    obj = gr_object();
    rand_place(obj);
  }
  put_gold();
}



void put_gold(void)
{
  short i, j;
  short row,col;
  boolean is_maze, is_room;

  for (i = 0; i < MAXROOMS; i++)
  {
    is_maze = (rooms[i].is_room & R_MAZE) ? 1 : 0;
    is_room = (rooms[i].is_room & R_ROOM) ? 1 : 0;

    if (!(is_room || is_maze)) {continue;}
    if (is_maze || rand_percent(GOLD_PERCENT))
    {
      for (j = 0; j < 50; j++)
      {
        row = get_rand(rooms[i].top_row+1, rooms[i].bottom_row-1);
        col = get_rand(rooms[i].left_col+1, rooms[i].right_col-1);
        if ((dungeon[row][col] == FLOOR) || (dungeon[row][col] == TUNNEL))
        {
          plant_gold(row, col, is_maze);
          break;
        }
      }
    }
  }
}



void plant_gold(short row, short col, boolean is_maze)
{
  object *obj;

  obj = alloc_object();
  obj->row = row; obj->col = col;
  obj->what_is = GOLD;
  obj->quantity = get_rand((2 * cur_level), (16 * cur_level));
  if (is_maze) {obj->quantity += obj->quantity / 2;}
  dungeon[row][col] |= OBJECT;
  (void) add_to_pack(obj, &level_objects, 0);
}



void place_at(object *obj, int row, int col)
{
  obj->row = row;
  obj->col = col;
  dungeon[row][col] |= OBJECT;
  (void) add_to_pack(obj, &level_objects, 0);
}



object *object_at(object *pack, short row, short col)
{
  object *obj = (object *) 0;

  if (dungeon[row][col] & (MONSTER | OBJECT))
  {
    obj = pack->next_object;

    while (obj && ((obj->row != row) || (obj->col != col))) {obj = obj->next_object;}
    if (!obj)
    {
      message("object_at(): inconsistent");
      interrupted = 1;
    }
  }
  return(obj);
}



object *get_letter_object(int ch)
{
  object *obj;

  obj = rogue.pack.next_object;

  while (obj && (obj->ichar != ch)) {obj = obj->next_object;}
  return(obj);
}



void free_stuff(object *objlist)
{
  object *obj;

  while (objlist->next_object)
  {
    obj = objlist->next_object;
    objlist->next_object = objlist->next_object->next_object;
    free_object(obj);
  }
}



const char *name_of(const object *obj)
{
  const char *retstring;

  switch(obj->what_is)
  {
    case SCROL: retstring = obj->quantity > 1 ? "scrolls " : "scroll "; break;
    case POTION: retstring = obj->quantity > 1 ? "potions " : "potion "; break;
    case FOOD: if (obj->which_kind == RATION) {retstring = "food ";} else {retstring = fruit;} break;
    case WAND: retstring = is_wood[obj->which_kind] ? "staff " : "wand "; break;
    case WEAPON:
      switch(obj->which_kind)
      {
        case DART: retstring=obj->quantity > 1 ? "darts " : "dart "; break;
        case ARROW: retstring=obj->quantity > 1 ? "arrows " : "arrow "; break;
        case DAGGER: retstring=obj->quantity > 1 ? "daggers " : "dagger "; break;
        case SHURIKEN: retstring=obj->quantity > 1?"shurikens ":"shuriken "; break;
        default: retstring = id_weapons[obj->which_kind].title;
      }
    break;
    case ARMOR: retstring = "armor "; break;
    case RING: retstring = "ring "; break;
    case AMULET: retstring = "amulet "; break;
    default: retstring = "unknown "; break;
  }
  return(retstring);
}



object *gr_object(void)
{
  object *obj;

  obj = alloc_object();

  if (foods < (cur_level / 3))
  {
    obj->what_is = FOOD;
    foods++;
  }
  else {obj->what_is = gr_what_is();}
  switch(obj->what_is)
  {
    case SCROL: gr_scroll(obj); break;
    case POTION: gr_potion(obj); break;
    case WEAPON: gr_weapon(obj, 1); break;
    case ARMOR: gr_armor(obj); break;
    case WAND: gr_wand(obj); break;
    case FOOD: get_food(obj, 0); break;
    case RING: gr_ring(obj, 1); break;
  }
  return(obj);
}



unsigned short gr_what_is(void)
{
  short percent;
  unsigned short what_is;

  percent = get_rand(1, 91);

  if (percent <= 30) {what_is = SCROL;}
  else if (percent <= 60) {what_is = POTION;}
  else if (percent <= 64) {what_is = WAND;}
  else if (percent <= 74) {what_is = WEAPON;}
  else if (percent <= 83) {what_is = ARMOR;}
  else if (percent <= 88) {what_is = FOOD;}
  else {what_is = RING;}
  return(what_is);
}



void gr_scroll(object *obj)
{
  short percent;

  percent = get_rand(0, 91);

  obj->what_is = SCROL;

  if (percent <= 5) {obj->which_kind = PROTECT_ARMOR;}
  else if (percent <= 10) {obj->which_kind = HOLD_MONSTER;}
  else if (percent <= 20) {obj->which_kind = CREATE_MONSTER;}
  else if (percent <= 35) {obj->which_kind = IDENTIFY;}
  else if (percent <= 43) {obj->which_kind = TELEPORT;}
  else if (percent <= 50) {obj->which_kind = SLEEP;}
  else if (percent <= 55) {obj->which_kind = SCARE_MONSTER;}
  else if (percent <= 64) {obj->which_kind = REMOVE_CURSE;}
  else if (percent <= 69) {obj->which_kind = ENCH_ARMOR;}
  else if (percent <= 74) {obj->which_kind = ENCH_WEAPON;}
  else if (percent <= 80) {obj->which_kind = AGGRAVATE_MONSTER;}
  else if (percent <= 86) {obj->which_kind = CON_MON;}
  else {obj->which_kind = MAGIC_MAPPING;}
}



void gr_potion(object *obj)
{
  short percent;

  percent = get_rand(1, 118);

  obj->what_is = POTION;

  if (percent <= 5) {obj->which_kind = RAISE_LEVEL;}
  else if (percent <= 15) {obj->which_kind = DETECT_OBJECTS;}
  else if (percent <= 25) {obj->which_kind = DETECT_MONSTER;}
  else if (percent <= 35) {obj->which_kind = INCREASE_STRENGTH;}
  else if (percent <= 45) {obj->which_kind = RESTORE_STRENGTH;}
  else if (percent <= 55) {obj->which_kind = HEALING;}
  else if (percent <= 65) {obj->which_kind = EXTRA_HEALING;}
  else if (percent <= 75) {obj->which_kind = BLINDNESS;}
  else if (percent <= 85) {obj->which_kind = HALLUCINATION;}
  else if (percent <= 95) {obj->which_kind = CONFUSION;}
  else if (percent <= 105) {obj->which_kind = POISON;}
  else if (percent <= 110) {obj->which_kind = LEVITATION;}
  else if (percent <= 114) {obj->which_kind = HASTE_SELF;}
  else {obj->which_kind = SEE_INVISIBLE;}
}



void gr_weapon(object *obj, int assign_wk)
{
  short percent;
  short i;
  short blessing, increment;

  obj->what_is = WEAPON;
  if (assign_wk) {obj->which_kind = get_rand(0, (WEAPONS - 1));}
  if ((obj->which_kind == ARROW) || (obj->which_kind == DAGGER) || (obj->which_kind == SHURIKEN) | (obj->which_kind == DART))
  {
    obj->quantity = get_rand(3, 15);
    obj->quiver = get_rand(0, 126);
  }
  else {obj->quantity = 1;}
  obj->hit_enchant = obj->d_enchant = 0;

  percent = get_rand(1, 96);
  blessing = get_rand(1, 3);

  if (percent <= 32)
  {
    if (percent <= 16) {increment = 1;}
    else
    {
      increment = -1;
      obj->is_cursed = 1;
    }
    for (i = 0; i < blessing; i++)
    {
      if (coin_toss()) {obj->hit_enchant += increment;}
      else {obj->d_enchant += increment;}
    }
  }
  switch(obj->which_kind)
  {
    case BOW: case DART: obj->damage = "1d1"; break;
    case ARROW: obj->damage = "1d2"; break;
    case DAGGER: obj->damage = "1d3"; break;
    case SHURIKEN: obj->damage = "1d4"; break;
    case MACE: obj->damage = "2d3"; break;
    case LONG_SWORD: obj->damage = "3d4"; break;
    case TWO_HANDED_SWORD: obj->damage = "4d5"; break;
  }
}



void gr_armor(object *obj)
{
  short percent;
  short blessing;

  obj->what_is = ARMOR;
  obj->which_kind = get_rand(0, (ARMORS - 1));
  obj->class = obj->which_kind + 2;
  if ((obj->which_kind == PLATE) || (obj->which_kind == SPLINT)) {obj->class--;}
  obj->is_protected = 0;
  obj->d_enchant = 0;

  percent = get_rand(1, 100);
  blessing = get_rand(1, 3);

  if (percent <= 16)
  {
    obj->is_cursed = 1;
    obj->d_enchant -= blessing;
  }
  else if (percent <= 33) {obj->d_enchant += blessing;}
}



void gr_wand(object *obj)
{
  obj->what_is = WAND;
  obj->which_kind = get_rand(0, (WANDS - 1));
  obj->class = get_rand(3, 7);
}



void get_food(object *obj, boolean force_ration)
{
  obj->what_is = FOOD;

  if (force_ration || rand_percent(80)) {obj->which_kind = RATION;}
  else {obj->which_kind = FRUIT;}
}



void put_stairs(void)
{
  short row, col;

  gr_row_col(&row, &col, (FLOOR | TUNNEL));
  dungeon[row][col] |= STAIRS;
}



int get_armor_class(const object *obj)
{
  if (obj) {return(obj->class + obj->d_enchant);}
  return(0);
}



void make_party(void)
{
  short n;

  party_room = gr_room();

  n = rand_percent(99) ? party_objects(party_room) : 11;
  if (rand_percent(99)) {party_monsters(party_room, n);}
}



void show_objects(void)
{
  object *obj;
  short mc, rc, row, col;
  object *monster;

  obj = level_objects.next_object;

  while (obj)
  {
    row = obj->row;
    col = obj->col;

    rc = get_mask_char(obj->what_is);

    if (dungeon[row][col] & MONSTER)
    {
      if ((monster = object_at(&level_monsters, row, col)) != NULL) {monster->trail_char = rc;}
    }
    mc = mvinch(row, col);
    if (((mc < 'A') || (mc > 'Z')) && ((row != rogue.row) || (col != rogue.col))) {mvaddch(row, col, rc);}
    obj = obj->next_object;
  }

  monster = level_monsters.next_object;

  while (monster)
  {
    if (monster->m_flags & IMITATES) {mvaddch(monster->row, monster->col, (int) monster->disguise);}
    monster = monster->next_monster;
  }
}



void put_amulet(void)
{
  object *obj;

  obj = alloc_object();
  obj->what_is = AMULET;
  rand_place(obj);
}



void rand_place(object *obj)
{
  short row, col;

  gr_row_col(&row, &col, (FLOOR | TUNNEL));
  place_at(obj, row, col);
}



int r_index(const char *str, int ch, boolean last)
{
  int i = 0;

  if (last)
  {
    for (i = strlen(str) - 1; i >= 0; i--)
    {
      if (str[i] == ch) {return(i);}
    }
  }
  else
  {
    for (i = 0; str[i]; i++)
    {
      if (str[i] == ch) {return(i);}
    }
  }
  return(-1);
}



void c_object_for_wizard(void)
{
  short ch, max;
  object *obj;
  char buf[128];

  if (pack_count((object *)0)>=MAX_PACK_COUNT) {message("pack full"); return;}

  message("object type?");
  message(":food !potion )weapon ]armor ?scroll =ring /wand ,amulet");

  while (r_index("!?:)]=/,\033", (ch = rgetchar()), 0)==-1) sound_bell();
  if (ch=='\033') return;



  obj = alloc_object();
  max = 0;

  switch (ch)
  {
    case '!':
      message("a) potion of increase strength");
      message("b) potion of restore strength");
      message("c) potion of healing");
      message("d) potion of extra healing");
      message("e) potion of poison");
      message("f) potion of raise level");
      message("g) potion of blindness");
      message("h) potion of hallucination");
      message("i) potion of detect monster");
      message("j) potion of detect things");
      message("k) potion of confusion");
      message("l) potion of levitation");
      message("m) potion of haste self");
      message("n) potion of see invisible");

      obj->what_is = POTION; max = POTIONS-1;
    break;

    case '?':
      message("a) scroll of protect armor");
      message("b) scroll of hold monster");
      message("c) scroll of enchant weapon");
      message("d) scroll of enchant armor");
      message("e) scroll of identify");
      message("f) scroll of teleportation");
      message("g) scroll of sleep");
      message("h) scroll of scare monster");
      message("i) scroll of remove curse");
      message("j) scroll of create monster");
      message("k) scroll of aggravate monster");
      message("l) scroll of magic mapping");
      message("m) scroll of confuse monster");

      obj->what_is = SCROL; max = SCROLS-1;
    break;

    case ',': obj->what_is = AMULET; break;

    case ':': get_food(obj, 0); break;

    case ')':
      message("a) short bow");
      message("b) darts");
      message("c) arrows");
      message("d) daggers");
      message("e) shurikens");
      message("f) mace");
      message("g) long sword");
      message("h) two-handed sword");

      gr_weapon(obj, 0); max = WEAPONS-1;
    break;

    case ']':
      message("a) leather armor");
      message("b) ring mail");
      message("c) scale mail");
      message("d) chain mail");
      message("e) banded mail");
      message("f) splint mail");
      message("g) plate mail");

      gr_armor(obj); max = ARMORS-1;
    break;

    case '/':
      message("a) wand of teleport away");
      message("b) wand of slow monster");
      message("c) wand of invisibility");
      message("d) wand of polymorph");
      message("e) wand of haste monster");
      message("f) wand of magic missile");
      message("g) wand of cancellation");
      message("h) wand of do nothing");
      message("i) wand of drain life");
      message("j) wand of cold");
      message("k) wand of fire");

      gr_wand(obj); max = WANDS-1;
    break;

    case '=':
      message("a) ring of stealth");
      message("b) ring of teleportation");
      message("c) ring of regeneration");
      message("d) ring of slow digestion");
      message("e) ring of add strength");
      message("f) ring of sustain strength");
      message("g) ring of dexterity");
      message("h) ring of adornment");
      message("i) ring of see invisible");
      message("j) ring of maintain armor");
      message("k) ring of searching");

      obj->what_is = RING; max = RINGS-1;
    break;
  }



  if (ch!=',' && ch!=':')
  {
    while (1)
    {
      ch = rgetchar();
      if (ch=='\033') {free_object(obj); return;}
      if (ch>='a' && ch<='a'+max) break;
      sound_bell();
    }

    obj->which_kind = (unsigned short)(ch-'a');
    if (obj->what_is==RING) gr_ring(obj, 0);
  }



  get_desc(obj, buf);
  message(buf);

  (void) add_to_pack(obj, &rogue.pack, 1);
}
//****************************************************************************



//****************************************************************************
//pack.c

object *add_to_pack(object *obj, object *pack, int condense)
{
  object *op;

  if (condense)
  {
    if ((op = check_duplicate(obj, pack)) != NULL)
    {
      free_object(obj);
      return(op);
    }
    else {obj->ichar = next_avail_ichar();}
  }
  if (pack->next_object == 0) {pack->next_object = obj;}
  else
  {
    op = pack->next_object;

    while (op->next_object) {op = op->next_object;}
    op->next_object = obj;
  }
  obj->next_object = 0;
  return(obj);
}



void take_from_pack(object *obj, object *pack)
{
  while (pack->next_object != obj) {pack = pack->next_object;}
  pack->next_object = pack->next_object->next_object;
}



//Note: *status is set to 0 if the rogue attempts to pick up a scroll
//of scare-monster and it turns to dust.  *status is otherwise set to 1.

object *pick_up(int row, int col, short *status)
{
  object *obj;

  *status = 1;

  if (levitate)
  {
    message("you're floating in the air!");
    return((object *) 0);
  }
  obj = object_at(&level_objects, row, col);
  if (!obj)
  {
    message("pick_up(): inconsistent");
    interrupted = 1;
    return(obj);
  }
  if ((obj->what_is == SCROL) && (obj->which_kind == SCARE_MONSTER) && obj->picked_up)
  {
    message("the scroll turns to dust as you pick it up");
    dungeon[row][col] &= (~OBJECT);
    vanish(obj, 0, &level_objects);
    *status = 0;
    if (id_scrolls[SCARE_MONSTER].id_status == UNIDENTIFIED) {id_scrolls[SCARE_MONSTER].id_status = IDENTIFIED;}
    return((object *) 0);
  }
  if (obj->what_is == GOLD)
  {
    PlayAudio("GoldSound");

    rogue.gold += obj->quantity;
    if (rogue.gold>MAX_GOLD) rogue.gold = MAX_GOLD;

    dungeon[row][col] &= ~(OBJECT);
    take_from_pack(obj, &level_objects);
    return(obj); //obj will be free_object()ed in caller
  }
  if (pack_count(obj) >= MAX_PACK_COUNT)
  {
    message("pack too full");
    interrupted = 1;
    return((object *) 0);
  }
  dungeon[row][col] &= ~(OBJECT);
  take_from_pack(obj, &level_objects);
  obj = add_to_pack(obj, &rogue.pack, 1);
  obj->picked_up = 1;
  return(obj);
}



void drop(void)
{
  object *obj, *new;
  short ch;
  char desc[DCOLS];

  if (dungeon[rogue.row][rogue.col] & (OBJECT | STAIRS | TRAP))
  {
    message("there's already something there");
    return;
  }
  if (!rogue.pack.next_object)
  {
    message("you have nothing to drop");
    return;
  }
  if ((ch = pack_letter("drop what?", ALL_OBJECTS)) == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (obj->in_use_flags & BEING_WIELDED)
  {
    if (obj->is_cursed)
    {
      message(curse_message);
      return;
    }
    unwield(rogue.weapon);
  }
  else if (obj->in_use_flags & BEING_WORN)
  {
    if (obj->is_cursed)
    {
      message(curse_message);
      return;
    }
    mv_aquatars();

    PlayAudio("ArmorSound");

    unwear(rogue.armor);
  }
  else if (obj->in_use_flags & ON_EITHER_HAND)
  {
    if (obj->is_cursed)
    {
      message(curse_message);
      return;
    }
    un_put_on(obj);
  }
  obj->row = rogue.row;
  obj->col = rogue.col;

  if ((obj->quantity > 1) && (obj->what_is != WEAPON))
  {
    obj->quantity--;
    new = alloc_object();
    *new = *obj;
    new->quantity = 1;
    obj = new;
  }
  else
  {
    obj->ichar = 'L';
    take_from_pack(obj, &rogue.pack);
  }
  place_at(obj, rogue.row, rogue.col);
  (void) strcpy(desc, "dropped ");
  get_desc(obj, desc+8);
  message(desc);
  (void) reg_move();
}



object *check_duplicate(object *obj, object *pack)
{
  object *op;

  if (!(obj->what_is & (WEAPON | FOOD | SCROL | POTION))) {return(0);}
  if ((obj->what_is == FOOD) && (obj->which_kind == FRUIT)) {return(0);}
  op = pack->next_object;

  while (op)
  {
    if ((op->what_is == obj->what_is) && (op->which_kind == obj->which_kind))
    {
      if ((obj->what_is != WEAPON) || ((obj->what_is == WEAPON) && ((obj->which_kind == ARROW) || (obj->which_kind == DAGGER) || (obj->which_kind == DART) || (obj->which_kind == SHURIKEN)) && (obj->quiver == op->quiver)))
      {
        op->quantity += obj->quantity;
        return(op);
      }
    }
    op = op->next_object;
  }
  return(0);
}



short next_avail_ichar(void)
{
  object *obj;
  int i;
  boolean ichars[26];

  for (i = 0; i < 26; i++) {ichars[i] = 0;}
  obj = rogue.pack.next_object;
  while (obj)
  {
    ichars[(obj->ichar - 'a')] = 1;
    obj = obj->next_object;
  }
  for (i = 0; i < 26; i++)
  {
    if (!ichars[i]) {return(i + 'a');}
  }
  return('?');
}



short pack_letter(const char *prompt, unsigned short mask)
{
  short ch;

  if (!mask_pack(&rogue.pack, mask)) {message("nothing appropriate"); return CANCEL;}

again:
  message(prompt);
  inventory(&rogue.pack, mask);

  for (;;)
  {
    ch = rgetchar();

    if (ch=='*' && mask!=ALL_OBJECTS) {mask = ALL_OBJECTS; goto again;}

    if ((ch>='a' && ch<='z') || ch==CANCEL) break; else sound_bell();
  }

  if (ch==CANCEL) message("cancelled");

  return ch;
}



void take_off(void)
{
  char desc[DCOLS];
  object *obj;

  if (rogue.armor)
  {
    if (rogue.armor->is_cursed) {message(curse_message);}
    else
    {
      mv_aquatars();

      PlayAudio("ArmorSound");

      obj = rogue.armor;
      unwear(rogue.armor);
      (void) strcpy(desc, "was wearing ");
      get_desc(obj, desc+12);
      message(desc);
      (void) reg_move();
    }
  }
  else {message("not wearing any");}
}



void wear(void)
{
  short ch;
  object *obj;
  char desc[DCOLS];

  if (rogue.armor)
  {
    message("you're already wearing some");
    return;
  }
  ch = pack_letter("wear what?", ARMOR);

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (obj->what_is != ARMOR)
  {
    message("you can't wear that");
    return;
  }

  PlayAudio("ArmorSound");

  obj->identified = 1;
  (void) strcpy(desc, "wearing ");
  get_desc(obj, desc + 8);
  message(desc);
  do_wear(obj);
  (void) reg_move();
}



void unwear(object *obj)
{
  if (obj) {obj->in_use_flags &= (~BEING_WORN);}
  rogue.armor = (object *) 0;
}



void do_wear(object *obj)
{
  rogue.armor = obj;
  obj->in_use_flags |= BEING_WORN;
  obj->identified = 1;
}



void wield(void)
{
  short ch;
  object *obj;
  char desc[DCOLS];

  if (rogue.weapon && rogue.weapon->is_cursed)
  {
    message(curse_message);
    return;
  }
  ch = pack_letter("wield what?", WEAPON);

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("No such item.");
    return;
  }
  if (obj->what_is & (ARMOR | RING))
  {
    sprintf(desc, "you can't wield %s", ((obj->what_is == ARMOR) ? "armor" : "rings"));
    message(desc);
    return;
  }
  if (obj->in_use_flags & BEING_WIELDED) {message("in use");}
  else
  {
    unwield(rogue.weapon);
    (void) strcpy(desc, "wielding ");
    get_desc(obj, desc + 9);
    message(desc);
    do_wield(obj);
    (void) reg_move();
  }
}



void do_wield(object *obj)
{
  rogue.weapon = obj;
  obj->in_use_flags |= BEING_WIELDED;
}



void unwield(object *obj)
{
  if (obj) {obj->in_use_flags &= (~BEING_WIELDED);}
  rogue.weapon = (object *) 0;
}



void call_it(void)
{
  short ch;
  object *obj;
  struct id *id_table;
  char buf[MAX_TITLE_LENGTH+2];

  ch = pack_letter("call what?", (SCROL | POTION | WAND | RING));

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (!(obj->what_is & (SCROL | POTION | WAND | RING)))
  {
    message("surely you already know what that's called");
    return;
  }
  id_table = get_id_table(obj);

  if (get_input_line("call it:","",buf,id_table[obj->which_kind].title,1,1))
  {
    id_table[obj->which_kind].id_status = CALLED;
    (void) strcpy(id_table[obj->which_kind].title, buf);
  }
}



short pack_count(const object *new_obj)
{
  object *obj;
  short count = 0;

  obj = rogue.pack.next_object;

  while (obj)
  {
    if (obj->what_is != WEAPON) {count += obj->quantity;}
    else if (!new_obj) {count++;}
    else if ((new_obj->what_is != WEAPON) || ((obj->which_kind != ARROW) && (obj->which_kind != DAGGER) && (obj->which_kind != DART) && (obj->which_kind != SHURIKEN)) || (new_obj->which_kind != obj->which_kind) || (obj->quiver != new_obj->quiver)) {count++;}
    obj = obj->next_object;
  }
  return(count);
}



boolean mask_pack(const object *pack, unsigned short mask)
{
  while (pack->next_object)
  {
    pack = pack->next_object;
    if (pack->what_is & mask) {return(1);}
  }
  return(0);
}



boolean has_amulet(void)
{
  return(mask_pack(&rogue.pack, AMULET));
}



void kick_into_pack(void)
{
  object *obj;
  char desc[DCOLS];
  short n, stat;

  if (!(dungeon[rogue.row][rogue.col] & OBJECT)) {message("nothing here");}
  else
  {
    if ((obj = pick_up(rogue.row, rogue.col, &stat)) != NULL)
    {
      get_desc(obj, desc);
      if (obj->what_is == GOLD)
      {
        message(desc);
        free_object(obj);
      }
      else
      {
        n = strlen(desc);
        desc[n] = '(';
        desc[n+1] = obj->ichar;
        desc[n+2] = ')';
        desc[n+3] = 0;
        message(desc);
      }
    }
    if (obj || (!stat)) {(void) reg_move();}
  }
}
//****************************************************************************



//****************************************************************************
//play.c

boolean is_digit(short ch)
{
  return((ch >= '0') && (ch <= '9'));
}



void play_level(void)
{
  short ch;

  for (;;)
  {
    interrupted = 0;

    if (hit_message[0])
    {
      message(hit_message);
      interrupted = 1;
      hit_message[0] = 0;
    }

    if (trap_door)
    {
      trap_door = 0;
      return;
    }



    PrefixCount = 0;
    ch = rgetchar();

CH:
    switch (ch)
    {
      case '0': case '1': case '2': case '3': case '4': case '5': case '6': case '7': case '8': case '9':
        do
        {
          if (PrefixCount<100) PrefixCount = (10*PrefixCount)+(ch-'0');
          ch = rgetchar();
        } while (is_digit(ch));

        if (ch!=CANCEL) goto CH; else PrefixCount = 0;
      break;



      case ' ': break;
      case ',': kick_into_pack(); break;
      case '.': rest((PrefixCount > 0) ? PrefixCount : 1); break;
      case '=': inv_rings(); break;
      case '^': id_trap(); break;
      case '/': id_type(); break;
      case '?': print_help(); break;
      case 'c': call_it(); break;
      case 'd': drop(); break;
      case 'e': eat(); break;
      case 'f': fight(0); break;
      case 'F': fight(1); break;
      case 'i': inventory(&rogue.pack, ALL_OBJECTS); break;
      case 'm': move_onto(); break;
      case 'P': put_on_ring(); break;
      case 'q': quaff(); break;
      case 'Q': quit(); break;
      case 'r': read_scroll(); break;
      case 'R': remove_ring(); break;
      case 's': search(((PrefixCount > 0) ? PrefixCount : 1), 0); break;
      case 'S': save_game(); break;
      case 't': throw(); break;
      case 'T': take_off(); break;
      case 'w': wield(); break;
      case 'W': wear(); break;
      case 'z': zapp(); break;



      case ')':
        if (rogue.weapon) single_inv(rogue.weapon->ichar); else message("not wielding anything");
      break;

      case ']':
        if (rogue.armor) single_inv(rogue.armor->ichar); else message("not wearing anything");
      break;

      case 'h': case 'j': case 'k': case 'l': case 'y': case 'u': case 'n': case 'b':
        (void) one_move_rogue(ch, 1);
      break;

      case 'H': case 'J': case 'K': case 'L': case 'B': case 'Y': case 'U': case 'N':
      case '\010': case '\012': case '\013': case '\014': case '\031': case '\025': case '\016': case '\002':
        multiple_move_rogue(ch);
      break;

      case '>':
        if (drop_check())
        {
          PlayAudio("StairsSound");

          return;
        }
      break;

      case '<':
        if (check_up())
        {
          PlayAudio("StairsSound");

          return;
        }
      break;

      case 'v':
        message("TileRogue 1.21");
        message("Derived from Timothy C. Stoehr's Rogue Clone version III");
      break;

      case 1+('a'-'a'): show_average_hp(); break;

      case 1+('s'-'a'):
        message(ToggleSoundEnabled()?"sound effects on":"sound effects off");
      break;



      case 1+('c'-'a'): if (wizard) c_object_for_wizard();                  else message(unknown_command); break;
      case 1+('i'-'a'): if (wizard) inventory(&level_objects, ALL_OBJECTS); else message(unknown_command); break;
      case 1+('m'-'a'): if (wizard) show_monsters();                        else message(unknown_command); break;
      case 1+('o'-'a'): if (wizard) show_objects();                         else message(unknown_command); break;
      case 1+('r'-'a'): if (wizard) draw_magic_map();                       else message(unknown_command); break;
      case 1+('t'-'a'): if (wizard) show_traps();                           else message(unknown_command); break;
      case 1+('w'-'a'): wizardize(); break;



      default: message(unknown_command); break;
    }
  }
}
//****************************************************************************



//****************************************************************************
//ring.c

void put_on_ring(void)
{
  short ch;
  char desc[DCOLS];
  object *ring;

  if (r_rings == 2)
  {
    message("wearing two rings already");
    return;
  }
  if ((ch = pack_letter("put on what?", RING)) == CANCEL) {return;}
  if (!(ring = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (!(ring->what_is & RING))
  {
    message("that's not a ring");
    return;
  }
  if (ring->in_use_flags & (ON_LEFT_HAND | ON_RIGHT_HAND))
  {
    message("that ring is already being worn");
    return;
  }
  if (r_rings == 1) {ch = (rogue.left_ring ? 'r' : 'l');}
  else
  {
    message(left_or_right);
    do {ch = rgetchar();} while ((ch != CANCEL) && (ch != 'l') && (ch != 'r') && (ch != '\n') && (ch != '\r'));
  }
  if ((ch != 'l') && (ch != 'r')) {return;}
  if (((ch == 'l') && rogue.left_ring)||((ch == 'r') && rogue.right_ring))
  {
    message("there's already a ring on that hand");
    return;
  }
  if (ch == 'l') {do_put_on(ring, 1);}
  else {do_put_on(ring, 0);}
  ring_stats(1);
  get_desc(ring, desc);
  message(desc);
  (void) reg_move();
}



//Do not call ring_stats() from within do_put_on().  It will cause
//serious problems when do_put_on() is called from read_pack() in restore_game().

void do_put_on(object *ring, boolean on_left)
{
  if (on_left)
  {
    ring->in_use_flags |= ON_LEFT_HAND;
    rogue.left_ring = ring;
  }
  else
  {
    ring->in_use_flags |= ON_RIGHT_HAND;
    rogue.right_ring = ring;
  }
}



void remove_ring(void)
{
  boolean left = 0, right = 0;
  short ch;
  char buf[DCOLS];
  object *ring;

  ring = NULL;
  if (r_rings == 0) {inv_rings();}
  else if (rogue.left_ring && !rogue.right_ring) {left = 1;}
  else if (!rogue.left_ring && rogue.right_ring) {right = 1;}
  else
  {
    message(left_or_right);
    do {ch = rgetchar();} while ((ch != CANCEL) && (ch != 'l') && (ch != 'r') && (ch != '\n') && (ch != '\r'));
    left = (ch == 'l');
    right = (ch == 'r');
  }
  if (left || right)
  {
    if (left)
    {
      if (rogue.left_ring) {ring = rogue.left_ring;}
      else {message(no_ring);}
    }
    else
    {
      if (rogue.right_ring) {ring = rogue.right_ring;}
      else {message(no_ring);}
    }
    if (ring->is_cursed) {message(curse_message);}
    else
    {
      un_put_on(ring);
      (void) strcpy(buf, "removed ");
      get_desc(ring, buf + 8);
      message(buf);
      (void) reg_move();
    }
  }
}



void un_put_on(object *ring)
{
  if (ring && (ring->in_use_flags & ON_LEFT_HAND))
  {
    ring->in_use_flags &= (~ON_LEFT_HAND);
    rogue.left_ring = 0;
  }
  else if (ring && (ring->in_use_flags & ON_RIGHT_HAND))
  {
    ring->in_use_flags &= (~ON_RIGHT_HAND);
    rogue.right_ring = 0;
  }
  ring_stats(1);
}



void gr_ring(object *ring, boolean assign_wk)
{
  ring->what_is = RING;
  if (assign_wk) {ring->which_kind = get_rand(0, (RINGS - 1));}
  ring->class = 0;

  switch(ring->which_kind)
  {
    case R_TELEPORT:
      ring->is_cursed = 1;
    break;
    case ADD_STRENGTH:
    case DEXTERITY:
      while ((ring->class = (get_rand(0, 4) - 2)) == 0) ;
      ring->is_cursed = (ring->class < 0);
    break;
    case ADORNMENT:
      ring->is_cursed = coin_toss();
    break;
  }
}



void inv_rings(void)
{
  char buf[DCOLS];

  if (r_rings == 0) {message("not wearing any rings");}
  else
  {
    if (rogue.left_ring)
    {
      get_desc(rogue.left_ring, buf);
      message(buf);
    }
    if (rogue.right_ring)
    {
      get_desc(rogue.right_ring, buf);
      message(buf);
    }
  }
  if (wizard)
  {
    sprintf(buf, "ste %d, r_r %d, e_r %d, r_t %d, s_s %d, a_s %d, reg %d, r_e %d, s_i %d, m_a %d, aus %d", stealthy, r_rings, e_rings, r_teleport, sustain_strength, add_strength, regeneration, ring_exp, r_see_invisible, maintain_armor, auto_search);
    message(buf);
  }
}



void ring_stats(boolean pr)
{
  short i;
  object *ring;

  stealthy = 0;
  r_rings = 0;
  e_rings = 0;
  r_teleport = 0;
  sustain_strength = 0;
  add_strength = 0;
  regeneration = 0;
  ring_exp = 0;
  r_see_invisible = 0;
  maintain_armor = 0;
  auto_search = 0;

  for (i = 0; i < 2; i++)
  {
    if (!(ring = ((i == 0) ? rogue.left_ring : rogue.right_ring))) {continue;}
    r_rings++;
    e_rings++;
    switch(ring->which_kind)
    {
      case STEALTH: stealthy++; break;
      case R_TELEPORT: r_teleport = 1; break;
      case REGENERATION: regeneration++; break;
      case SLOW_DIGEST: e_rings -= 2; break;
      case ADD_STRENGTH: add_strength += ring->class; break;
      case SUSTAIN_STRENGTH: sustain_strength = 1; break;
      case DEXTERITY: ring_exp += ring->class; break;
      case ADORNMENT: break;
      case R_SEE_INVISIBLE: r_see_invisible = 1; break;
      case MAINTAIN_ARMOR: maintain_armor = 1; break;
      case SEARCHING: auto_search += 2; break;
    }
  }
  if (pr)
  {
    relight();
  }
}
//****************************************************************************



//****************************************************************************
//room.c

void light_up_room(int rn)
{
  short i, j;

  if (!blind)
  {
    for (i = rooms[rn].top_row; i <= rooms[rn].bottom_row; i++)
    {
      for (j = rooms[rn].left_col; j <= rooms[rn].right_col; j++)
      {
        if (dungeon[i][j] & MONSTER)
        {
          object *monster;

          if ((monster = object_at(&level_monsters, i, j)) != NULL)
          {
            dungeon[monster->row][monster->col] &= (~MONSTER);
            monster->trail_char = get_dungeon_char(monster->row, monster->col);
            dungeon[monster->row][monster->col] |= MONSTER;
          }
        }
        mvaddch(i, j, get_dungeon_char(i, j));
      }
    }
    mvaddch(rogue.row, rogue.col, rogue.fchar);
  }
}



void light_passage(int row, int col)
{
  short i, j, i_end, j_end;

  if (blind) {return;}
  i_end = (row < (DROWS-2)) ? 1 : 0;
  j_end = (col < (DCOLS-1)) ? 1 : 0;

  for (i = ((row > MIN_ROW) ? -1 : 0); i <= i_end; i++)
  {
    for (j = ((col > 0) ? -1 : 0); j <= j_end; j++)
    {
      if (can_move(row, col, row+i, col+j)) {mvaddch(row+i, col+j, get_dungeon_char(row+i, col+j));}
    }
  }
}



void darken_room(short rn)
{
  short i, j;

  for (i = rooms[rn].top_row + 1; i < rooms[rn].bottom_row; i++)
  {
    for (j = rooms[rn].left_col + 1; j < rooms[rn].right_col; j++)
    {
      if (blind) {mvaddch(i, j, ' ');}
      else
      {
        if (!(dungeon[i][j] & (OBJECT | STAIRS)) && !(detect_monster && (dungeon[i][j] & MONSTER)))
        {
          if (!imitating(i, j)) {mvaddch(i, j, ' ');}
          if ((dungeon[i][j] & TRAP) && (!(dungeon[i][j] & HIDDEN))) {mvaddch(i, j, '^');}
        }
      }
    }
  }
}



char get_dungeon_char(short row, short col)
{
  unsigned short mask = dungeon[row][col];

  if (mask & MONSTER) {return(gmc_row_col(row, col));}
  if (mask & OBJECT)
  {
    object *obj;

    obj = object_at(&level_objects, row, col);
    return(get_mask_char(obj->what_is));
  }
  if (mask & (TUNNEL | STAIRS | HORWALL | VERTWALL | FLOOR | DOOR))
  {
    if ((mask & (TUNNEL| STAIRS)) && (!(mask & HIDDEN))) {return(((mask & STAIRS) ? '%' : '#'));}
    if (mask & HORWALL) {return('-');}
    if (mask & VERTWALL) {return('|');}
    if (mask & FLOOR)
    {
      if (mask & TRAP)
      {
        if (!(dungeon[row][col] & HIDDEN)) {return('^');}
      }
      return('.');
    }
    if (mask & DOOR)
    {
      if (mask & HIDDEN)
      {
        if (((col > 0) && (dungeon[row][col-1] & HORWALL)) || ((col < (DCOLS-1)) && (dungeon[row][col+1] & HORWALL))) {return('-');}
        else {return('|');}
      }
      else {return('+');}
    }
  }
  return(' ');
}



char get_mask_char(unsigned short mask)
{
  switch(mask)
  {
    case SCROL: return('?');
    case POTION: return('!');
    case GOLD: return('*');
    case FOOD: return(':');
    case WAND: return('/');
    case ARMOR: return(']');
    case WEAPON: return(')');
    case RING: return('=');
    case AMULET: return(',');
    default: return('~'); //unknown, something is wrong
  }
}



void gr_row_col(short *row, short *col, unsigned short mask)
{
  short rn;
  short r, c;

  do
  {
    r = get_rand(MIN_ROW, DROWS-2);
    c = get_rand(0, DCOLS-1);
    rn = get_room_number(r, c);
  } while ((rn == NO_ROOM) || (!(dungeon[r][c] & mask)) || (dungeon[r][c] & (~mask)) || (!(rooms[rn].is_room & (R_ROOM | R_MAZE))) || ((r == rogue.row) && (c == rogue.col)));

  *row = r;
  *col = c;
}



short gr_room(void)
{
  short i;

  do {i = get_rand(0, MAXROOMS-1);} while (!(rooms[i].is_room & (R_ROOM | R_MAZE)));

  return(i);
}



short party_objects(int rn)
{
  short i, j, nf = 0;
  object *obj;
  short n, N, row, col;
  boolean found;

  row = col = 0;
  N = ((rooms[rn].bottom_row - rooms[rn].top_row) - 1) * ((rooms[rn].right_col - rooms[rn].left_col) - 1);
  n =  get_rand(5, 10);
  if (n > N) {n = N - 2;}
  for (i = 0; i < n; i++)
  {
    for (j = found = 0; ((!found) && (j < 250)); j++)
    {
      row = get_rand(rooms[rn].top_row+1, rooms[rn].bottom_row-1);
      col = get_rand(rooms[rn].left_col+1, rooms[rn].right_col-1);
      if ((dungeon[row][col] == FLOOR) || (dungeon[row][col] == TUNNEL)) {found = 1;}
    }
    if (found)
    {
      obj = gr_object();
      place_at(obj, row, col);
      nf++;
    }
  }
  return(nf);
}



short get_room_number(int row, int col)
{
  short i;

  for (i = 0; i < MAXROOMS; i++)
  {
    if ((row >= rooms[i].top_row) && (row <= rooms[i].bottom_row) && (col >= rooms[i].left_col) && (col <= rooms[i].right_col)) {return(i);}
  }
  return(NO_ROOM);
}



boolean is_all_connected(void)
{
  short i, starting_room;

  starting_room = 0;
  for (i = 0; i < MAXROOMS; i++)
  {
    rooms_visited[i] = 0;
    if (rooms[i].is_room & (R_ROOM | R_MAZE)) {starting_room = i;}
  }

  visit_rooms(starting_room);

  for (i = 0; i < MAXROOMS; i++)
  {
    if ((rooms[i].is_room & (R_ROOM | R_MAZE)) && (!rooms_visited[i])) {return(0);}
  }
  return(1);
}



void visit_rooms(int rn)
{
  short i;
  short oth_rn;

  rooms_visited[rn] = 1;

  for (i = 0; i < 4; i++)
  {
    oth_rn = rooms[rn].doors[i].oth_room;
    if ((oth_rn >= 0) && (!rooms_visited[oth_rn])) {visit_rooms(oth_rn);}
  }
}



void draw_magic_map(void)
{
  short i, j, ch, och;
  unsigned short mask = (HORWALL | VERTWALL | DOOR | TUNNEL | TRAP | STAIRS | MONSTER);
  unsigned short s;

  for (i = 0; i < DROWS; i++)
  {
    for (j = 0; j < DCOLS; j++)
    {
      s = dungeon[i][j];
      if (s & mask)
      {
        if (((ch = mvinch(i, j)) == ' ') || ((ch >= 'A') && (ch <= 'Z')) || (s & (TRAP | HIDDEN)))
        {
          och = ch;
          dungeon[i][j] &= (~HIDDEN);
          if (s & HORWALL) {ch = '-';}
          else if (s & VERTWALL) {ch = '|';}
          else if (s & DOOR) {ch = '+';}
          else if (s & TRAP) {ch = '^';}
          else if (s & STAIRS) {ch = '%';}
          else if (s & TUNNEL) {ch = '#';}
          else {continue;}
          if ((!(s & MONSTER)) || (och == ' ')) {mvaddch(i, j, ch);}
          if (s & MONSTER)
          {
            object *monster;

            if ((monster = object_at(&level_monsters, i, j)) != NULL) {monster->trail_char = ch;}
          }
        }
      }
    }
  }
}



void dr_course(object *monster, boolean entering, short row, short col)
{
  short i, j, k, rn;
  short r, rr;

  monster->row = row;
  monster->col = col;

  if (mon_sees(monster, rogue.row, rogue.col))
  {
    monster->trow = NO_ROOM;
    return;
  }
  rn = get_room_number(row, col);

  if (entering) //entering room
  {
    //look for door to some other room
    r = get_rand(0, MAXROOMS-1);
    for (i = 0; i < MAXROOMS; i++)
    {
      rr = (r + i) % MAXROOMS;
      if ((!(rooms[rr].is_room & (R_ROOM | R_MAZE))) || (rr == rn)) {continue;}
      for (k = 0; k < 4; k++)
      {
        if (rooms[rr].doors[k].oth_room == rn)
        {
          monster->trow = rooms[rr].doors[k].oth_row;
          monster->tcol = rooms[rr].doors[k].oth_col;
          if ((monster->trow == row) && (monster->tcol == col)) {continue;}
          return;
        }
      }
    }
    //look for door to dead end
    for (i = rooms[rn].top_row; i <= rooms[rn].bottom_row; i++)
    {
      for (j = rooms[rn].left_col; j <= rooms[rn].right_col; j++)
      {
        if ((i != monster->row) && (j != monster->col) && (dungeon[i][j] & DOOR))
        {
          monster->trow = i;
          monster->tcol = j;
          return;
        }
      }
    }
    //return monster to room that he came from
    for (i = 0; i < MAXROOMS; i++)
    {
      for (j = 0; j < 4; j++)
      {
        if (rooms[i].doors[j].oth_room == rn)
        {
          for (k = 0; k < 4; k++)
          {
            if (rooms[rn].doors[k].oth_room == i)
            {
              monster->trow = rooms[rn].doors[k].oth_row;
              monster->tcol = rooms[rn].doors[k].oth_col;
              return;
            }
          }
        }
      }
    }
    //no place to send monster
    monster->trow = NO_ROOM;
  }
  else
  {
    //exiting room
    if (!get_oth_room(rn, &row, &col)) {monster->trow = NO_ROOM;}
    else
    {
      monster->trow = row;
      monster->tcol = col;
    }
  }
}



boolean get_oth_room(short rn, short *row, short *col)
{
  short d = -1;

  if (*row == rooms[rn].top_row) {d = UPWARD/2;}
  else if (*row == rooms[rn].bottom_row) {d = DOWN/2;}
  else if (*col == rooms[rn].left_col) {d = LEFT/2;}
  else if (*col == rooms[rn].right_col) {d = RIGHT/2;}
  if ((d != -1) && (rooms[rn].doors[d].oth_room >= 0))
  {
    *row = rooms[rn].doors[d].oth_row;
    *col = rooms[rn].doors[d].oth_col;
    return(1);
  }
  return(0);
}
//****************************************************************************



//****************************************************************************
//save.c

long pseudorandom_seq(boolean init)
{
  long r;

  static long f, s;

  if (init) {f = 37; s = 7; return 0;}

  r = (f*s+9337)%8887; f = s; s = r;
  return r;
}



void save_game(void)
{
  FILE *fp;

  fp = fopen(save_file, "wb"); if (fp==0) {message("problem accessing save file"); return;}
  write_failed = 0;

  pseudorandom_seq(1); //init

  r_write(fp, (char *) &detect_monster, sizeof(detect_monster));
  r_write(fp, (char *) &cur_level, sizeof(cur_level));
  r_write(fp, (char *) &max_level, sizeof(max_level));
  write_string(hunger_str, fp);
  r_write(fp, (char *) &party_room, sizeof(party_room));
  write_pack(&level_monsters, fp);
  write_pack(&level_objects, fp);
  rw_dungeon(fp, 1);
  r_write(fp, (char *) &foods, sizeof(foods));
  r_write(fp, (char *) &rogue, sizeof(fighter));
  write_pack(&rogue.pack, fp);
  rw_id(id_potions, fp, POTIONS, 1);
  rw_id(id_scrolls, fp, SCROLS, 1);
  rw_id(id_wands, fp, WANDS, 1);
  rw_id(id_rings, fp, RINGS, 1);
  r_write(fp, (char *) traps, (MAX_TRAPS * sizeof(trap)));
  r_write(fp, (char *) is_wood, (WANDS * sizeof(boolean)));
  r_write(fp, (char *) &cur_room, sizeof(cur_room));
  rw_rooms(fp, 1);
  r_write(fp, (char *) &being_held, sizeof(being_held));
  r_write(fp, (char *) &bear_trap, sizeof(bear_trap));
  r_write(fp, (char *) &halluc, sizeof(halluc));
  r_write(fp, (char *) &blind, sizeof(blind));
  r_write(fp, (char *) &confused, sizeof(confused));
  r_write(fp, (char *) &levitate, sizeof(levitate));
  r_write(fp, (char *) &haste_self, sizeof(haste_self));
  r_write(fp, (char *) &see_invisible, sizeof(see_invisible));
  r_write(fp, (char *) &detect_monster, sizeof(detect_monster));
  r_write(fp, (char *) &wizard, sizeof(wizard));
  r_write(fp, (char *) &m_moves, sizeof(m_moves));

  fclose(fp);

  clean_up(write_failed?"Error: saved game file write failure":"Your game was saved successfully");
}



int restore_game(void)
{
  FILE *fp;

  fp = fopen(save_file, "rb"); if (fp==0) return 0;

  pseudorandom_seq(1); //init

  r_read(fp, (char *) &detect_monster, sizeof(detect_monster));
  r_read(fp, (char *) &cur_level, sizeof(cur_level));
  r_read(fp, (char *) &max_level, sizeof(max_level));
  read_string(hunger_str, fp, sizeof(hunger_str));
  r_read(fp, (char *) &party_room, sizeof(party_room));
  read_pack(&level_monsters, fp, 0);
  read_pack(&level_objects, fp, 0);
  rw_dungeon(fp, 0);
  r_read(fp, (char *) &foods, sizeof(foods));
  r_read(fp, (char *) &rogue, sizeof(fighter));
  read_pack(&rogue.pack, fp, 1);
  rw_id(id_potions, fp, POTIONS, 0);
  rw_id(id_scrolls, fp, SCROLS, 0);
  rw_id(id_wands, fp, WANDS, 0);
  rw_id(id_rings, fp, RINGS, 0);
  r_read(fp, (char *) traps, (MAX_TRAPS * sizeof(trap)));
  r_read(fp, (char *) is_wood, (WANDS * sizeof(boolean)));
  r_read(fp, (char *) &cur_room, sizeof(cur_room));
  rw_rooms(fp, 0);
  r_read(fp, (char *) &being_held, sizeof(being_held));
  r_read(fp, (char *) &bear_trap, sizeof(bear_trap));
  r_read(fp, (char *) &halluc, sizeof(halluc));
  r_read(fp, (char *) &blind, sizeof(blind));
  r_read(fp, (char *) &confused, sizeof(confused));
  r_read(fp, (char *) &levitate, sizeof(levitate));
  r_read(fp, (char *) &haste_self, sizeof(haste_self));
  r_read(fp, (char *) &see_invisible, sizeof(see_invisible));
  r_read(fp, (char *) &detect_monster, sizeof(detect_monster));
  r_read(fp, (char *) &wizard, sizeof(wizard));
  r_read(fp, (char *) &m_moves, sizeof(m_moves));

  ring_stats(0);
  fclose(fp);
  remove(save_file);
  return 1;
}



void write_pack(const object *pack, FILE *fp)
{
  object t;

  while ((pack = pack->next_object) != NULL) {r_write(fp, (const char *) pack, sizeof(object));}
  t.ichar = t.what_is = 0;
  r_write(fp, (const char *) &t, sizeof(object));
}



void read_pack(object *pack, FILE *fp, boolean is_rogue)
{
  object read_obj, *new_obj;

  for (;;)
  {
    r_read(fp, (char *) &read_obj, sizeof(object));
    if (read_obj.ichar == 0)
    {
      pack->next_object = (object *) 0;
      break;
    }
    new_obj = alloc_object();
    *new_obj = read_obj;
    if (is_rogue)
    {
      if (new_obj->in_use_flags & BEING_WORN) {do_wear(new_obj);}
      else if (new_obj->in_use_flags & BEING_WIELDED) {do_wield(new_obj);}
      else if (new_obj->in_use_flags & (ON_EITHER_HAND)) {do_put_on(new_obj, ((new_obj->in_use_flags & ON_LEFT_HAND) ? 1 : 0));}
    }
    pack->next_object = new_obj;
    pack = new_obj;
  }
}



void rw_dungeon(FILE *fp, boolean rw)
{
  short i, j;
  char buf[DCOLS];

  for (i = 0; i < DROWS; i++)
  {
    if (rw)
    {
      r_write(fp, (char *) dungeon[i], (DCOLS * sizeof(dungeon[0][0])));
      for (j = 0; j < DCOLS; j++) {buf[j] = mvinch(i, j);}
      r_write(fp, buf, DCOLS);
    }
    else
    {
      r_read(fp, (char *) dungeon[i], (DCOLS * sizeof(dungeon[0][0])));
      r_read(fp, buf, DCOLS);
      for (j = 0; j < DCOLS; j++) {mvaddch(i, j, buf[j]);}
    }
  }
}



void rw_id(struct id id_table[], FILE *fp, int n, boolean wr)
{
  short i;

  for (i = 0; i < n; i++)
  {
    if (wr)
    {
      r_write(fp, (const char *) &(id_table[i].value), sizeof(short));
      r_write(fp, (const char *) &(id_table[i].id_status), sizeof(unsigned short));
      write_string(id_table[i].title, fp);
    }
    else
    {
      r_read(fp, (char *) &(id_table[i].value), sizeof(short));
      r_read(fp, (char *) &(id_table[i].id_status), sizeof(unsigned short));
      read_string(id_table[i].title, fp, MAX_ID_TITLE_LEN);
    }
  }
}



void write_string(char *s, FILE *fp)
{
  short n, i;

  static char buffer[256];

  n = strlen(s)+1;

  memcpy(buffer, s, n);
  for (i=0; i<n; i++) buffer[i] ^= (unsigned char)pseudorandom_seq(0);

  r_write(fp, (char *)&n, sizeof(short));
  r_write(fp, buffer, n);
}



void read_string(char *s, FILE *fp, size_t len)
{
  short n, i;

  r_read(fp, (char *)&n, sizeof(short)); if (n>len) clean_up("Error: corrupt saved game file in read_string()");
  r_read(fp, s, n);

  for (i=0; i<n; i++) s[i] ^= (unsigned char)pseudorandom_seq(0);
}



void rw_rooms(FILE *fp, boolean rw)
{
  short i;

  for (i = 0; i < MAXROOMS; i++) {rw ? r_write(fp, (char *) (rooms + i), sizeof(room)) : r_read(fp, (char *) (rooms + i), sizeof(room));}
}



void r_read(FILE *fp, char *buf, int n)
{
  if (fread(buf, sizeof(char), n, fp) != (size_t)n) clean_up("Error: failed to read saved game file in r_read()");
}



void r_write(FILE *fp, const char *buf, int n)
{
  if (!write_failed) if (fwrite(buf, sizeof(char), n, fp) != (size_t)n) write_failed = 1;
}
//****************************************************************************



//****************************************************************************
//spec_hit.c

void special_hit(object *monster)
{
  if ((monster->m_flags & CONFUSED) && rand_percent(66)) {return;}
  if (monster->m_flags & RUSTS) {rust(monster);}
  if ((monster->m_flags & HOLDS) && !levitate) {being_held = 1;}
  if (monster->m_flags & FREEZES) {freeze(monster);}
  if (monster->m_flags & STINGS) {sting(monster);}
  if (monster->m_flags & DRAINS_LIFE) {drain_life();}
  if (monster->m_flags & DROPS_LEVEL) {drop_level();}
  if (monster->m_flags & STEALS_GOLD) {steal_gold(monster);}
  else if (monster->m_flags & STEALS_ITEM) {steal_item(monster);}
}



void rust(object *monster)
{
  if ((!rogue.armor) || (get_armor_class(rogue.armor) <= 1) || (rogue.armor->which_kind == LEATHER)) {return;}
  if ((rogue.armor->is_protected) || maintain_armor)
  {
    if (monster && (!(monster->m_flags & RUST_VANISHED)))
    {
      message("the rust vanishes instantly");
      monster->m_flags |= RUST_VANISHED;
    }
  }
  else
  {
    rogue.armor->d_enchant--;
    message("your armor weakens");
  }
}



void freeze(object *monster)
{
  short freeze_percent = 99;
  short i, n;

  if (rand_percent(12)) {return;}
  freeze_percent -= (rogue.str_current+(rogue.str_current / 2));
  freeze_percent -= ((rogue.exp + ring_exp) * 4);
  freeze_percent -= (get_armor_class(rogue.armor) * 5);
  freeze_percent -= (rogue.hp_max / 3);

  if (freeze_percent > 10)
  {
    PlayAudio("IceSound");

    monster->m_flags |= FREEZING_ROGUE;

    message("you are frozen");
    interrupted = 1;

    n = get_rand(4, 8);
    for (i = 0; i < n; i++) {mv_mons(); tick_pause();}

    if (rand_percent(freeze_percent))
    {
      for (i = 0; i < 50; i++) {mv_mons(); tick_pause();}

      killed_by((object *)0, HYPOTHERMIA);
    }

    message(you_can_move_again);
    interrupted = 1;

    monster->m_flags &= (~FREEZING_ROGUE);
  }
}



void steal_gold(object *monster)
{
  int amount;

  if ((rogue.gold <= 0) || rand_percent(10)) {return;}

  amount = get_rand((cur_level * 10), (cur_level * 30));

  if (amount > rogue.gold) {amount = rogue.gold;}
  rogue.gold -= amount;
  message("your purse feels lighter");
  disappear(monster);

  PlayAudio("GoldSound");
}



void steal_item(object *monster)
{
  object *obj;
  short i, n, t = 0;
  char desc[80];
  boolean has_something = 0;

  if (rand_percent(15)) {return;}
  obj = rogue.pack.next_object;

  if (!obj) {goto DSPR;}
  while (obj)
  {
    if (!(obj->in_use_flags & BEING_USED))
    {
      has_something = 1;
      break;
    }
    obj = obj->next_object;
  }
  if (!has_something) {goto DSPR;}
  n = get_rand(0, MAX_PACK_COUNT);
  obj = rogue.pack.next_object;

  for (i = 0; i <= n; i++)
  {
    obj = obj->next_object;
    while ((!obj) || (obj->in_use_flags & BEING_USED))
    {
      if (!obj) {obj = rogue.pack.next_object;}
      else {obj = obj->next_object;}
    }
  }
  (void) strcpy(desc, "she stole ");
  if (obj->what_is != WEAPON)
  {
    t = obj->quantity;
    obj->quantity = 1;
  }
  get_desc(obj, desc+10);
  message(desc);

  obj->quantity = ((obj->what_is != WEAPON) ? t : 1);

  vanish(obj, 0, &rogue.pack);
DSPR:
  disappear(monster);
}



void disappear(object *monster)
{
  short row, col;

  row = monster->row;
  col = monster->col;

  dungeon[row][col] &= ~MONSTER;
  if (rogue_can_see(row, col)) {mvaddch(row, col, get_dungeon_char(row, col));}
  take_from_pack(monster, &level_monsters);
  free_object(monster);
  mon_disappeared = 1;
}



void cough_up(object *monster)
{
  object *obj;
  short row, col, i, n;

  if (cur_level < max_level) {return;}

  if (monster->m_flags & STEALS_GOLD)
  {
    obj = alloc_object();
    obj->what_is = GOLD;
    obj->quantity = get_rand((cur_level * 15), (cur_level * 30));
  }
  else
  {
    if (!rand_percent((int) monster->drop_percent)) {return;}
    obj = gr_object();
  }
  row = monster->row;
  col = monster->col;

  for (n = 0; n <= 5; n++)
  {
    for (i = -n; i <= n; i++)
    {
      if (try_to_cough(row+n, col+i, obj)) {return;}
      if (try_to_cough(row-n, col+i, obj)) {return;}
    }
    for (i = -n; i <= n; i++)
    {
      if (try_to_cough(row+i, col-n, obj)) {return;}
      if (try_to_cough(row+i, col+n, obj)) {return;}
    }
  }
  free_object(obj);
}



boolean try_to_cough(short row, short col, object *obj)
{
  if ((row < MIN_ROW) || (row > (DROWS-2)) || (col < 0) || (col>(DCOLS-1))) {return(0);}
  if ((!(dungeon[row][col] & (OBJECT | STAIRS | TRAP))) && (dungeon[row][col] & (TUNNEL | FLOOR | DOOR)))
  {
    place_at(obj, row, col);
    if (((row != rogue.row) || (col != rogue.col)) && (!(dungeon[row][col] & MONSTER))) {mvaddch(row, col, get_dungeon_char(row, col));}
    return(1);
  }
  return(0);
}



boolean seek_gold(object *monster)
{
  short i, j, rn, s;

  if ((rn = get_room_number(monster->row, monster->col)) < 0) {return(0);}
  for (i = rooms[rn].top_row+1; i < rooms[rn].bottom_row; i++)
  {
    for (j = rooms[rn].left_col+1; j < rooms[rn].right_col; j++)
    {
      if ((gold_at(i, j)) && !(dungeon[i][j] & MONSTER))
      {
        monster->m_flags |= CAN_FLIT;
        s = mon_can_go(monster, i, j);
        monster->m_flags &= (~CAN_FLIT);
        if (s)
        {
          move_mon_to(monster, i, j);
          monster->m_flags |= ASLEEP;
          monster->m_flags &= (~(WAKENS | SEEKS_GOLD));
          return(1);
        }
        monster->m_flags &= (~SEEKS_GOLD);
        monster->m_flags |= CAN_FLIT;
        mv_1_monster(monster, i, j);
        monster->m_flags &= (~CAN_FLIT);
        monster->m_flags |= SEEKS_GOLD;
        return(1);
      }
    }
  }
  return(0);
}



boolean gold_at(short row, short col)
{
  if (dungeon[row][col] & OBJECT)
  {
    object *obj;

    if ((obj = object_at(&level_objects, row, col)) && (obj->what_is == GOLD)) {return(1);}
  }
  return(0);
}



void check_gold_seeker(object *monster)
{
  monster->m_flags &= (~SEEKS_GOLD);
}



boolean check_imitator(object *monster)
{
  char msg[80];

  if (monster->m_flags & IMITATES)
  {
    wake_up(monster);
    if (!blind)
    {
      mvaddch(monster->row, monster->col, get_dungeon_char(monster->row, monster->col));
      sprintf(msg, "wait, that's a %s!", mon_name(monster));
      message(msg);
      interrupted = 1;
    }
    return(1);
  }
  return(0);
}



boolean imitating(short row, short col)
{
  if (dungeon[row][col] & MONSTER)
  {
    object *monster;

    if ((monster = object_at(&level_monsters, row, col)) != NULL)
    {
      if (monster->m_flags & IMITATES) {return(1);}
    }
  }
  return(0);
}



void sting(object *monster)
{
  short sting_chance = 35;
  char msg[80];

  if ((rogue.str_current <= 3) || sustain_strength) {return;}
  sting_chance += (6 * (6 - get_armor_class(rogue.armor)));

  if ((rogue.exp + ring_exp) > 8) {sting_chance -= (6 * ((rogue.exp + ring_exp) - 8));}
  if (rand_percent(sting_chance))
  {
    sprintf(msg, "the %s's bite has weakened you", mon_name(monster));
    message(msg);
    rogue.str_current--;
  }
}



void drop_level(void)
{
  int hp;

  if (rand_percent(80) || (rogue.exp <= 5)) {return;}
  rogue.exp_points = level_points[rogue.exp-2] - get_rand(9, 29);
  rogue.exp -= 2;
  hp = hp_raise();
  if ((rogue.hp_current -= hp) <= 0) {rogue.hp_current = 1;}
  if ((rogue.hp_max -= hp) <= 0) {rogue.hp_max = 1;}
  add_exp(1, 0);
}



void drain_life(void)
{
  short n;

  if (rand_percent(60) || (rogue.hp_max <= 30) || (rogue.hp_current < 10)) {return;}
  n = get_rand(1, 3); //1 Hp, 2 Str, 3 both

  if ((n != 2) || (!sustain_strength)) {message("you feel weaker");}
  if (n != 2)
  {
    rogue.hp_max--;
    rogue.hp_current--;
    less_hp++;
  }
  if (n != 1)
  {
    if ((rogue.str_current > 3) && (!sustain_strength))
    {
      rogue.str_current--;
      if (coin_toss()) {rogue.str_max--;}
    }
  }
}



boolean m_confuse(object *monster)
{
  char msg[80];

  if (!rogue_can_see(monster->row, monster->col)) {return(0);}
  if (rand_percent(45))
  {
    monster->m_flags &= (~CONFUSES); //will not confuse the rogue
    return(0);
  }
  if (rand_percent(55))
  {
    PlayAudio("ConfusionSound");

    monster->m_flags &= (~CONFUSES);
    sprintf(msg, "the gaze of the %s has confused you", mon_name(monster));
    message(msg);
    interrupted = 1;
    cnfs();
    return(1);
  }
  return(0);
}



boolean flame_broil(object *monster)
{
  short row, col, dir;

  if ((!mon_sees(monster, rogue.row, rogue.col)) || coin_toss()) {return(0);}

  row = rogue.row - monster->row;
  col = rogue.col - monster->col;
  if (row < 0) {row = -row;}
  if (col < 0) {col = -col;}
  if (((row != 0) && (col != 0) && (row != col)) || ((row > 7) || (col > 7))) {return(0);}

  PlayAudio("FireSound");

  dir = get_dir(monster->row, monster->col, row, col);
  bounce(FIRE, dir, monster->row, monster->col, 0);

  return(1);
}



int get_dir(short srow, short scol, short drow, short dcol)
{
  if (srow == drow)
  {
    if (scol < dcol) {return(RIGHT);}
    else {return(LEFT);}
  }
  if (scol == dcol)
  {
    if (srow < drow) {return(DOWN);}
    else {return(UPWARD);}
  }
  if ((srow > drow) && (scol > dcol)) {return(UPLEFT);}
  if ((srow < drow) && (scol < dcol)) {return(DOWNRIGHT);}
  if ((srow < drow) && (scol > dcol)) {return(DOWNLEFT);}
  return(UPRIGHT);
}
//****************************************************************************



//****************************************************************************
//throw.c

void throw(void)
{
  short wch, d;
  object *weapon;
  short dir, row, col;
  object *monster;



  message("direction?");
  SetDirArrow(8);
  while (!is_direction(dir = rgetchar(), &d)) sound_bell();
  if (dir==CANCEL) {SetDirArrow(-1); return;}
  SetDirArrow(d);
  wch = pack_letter("throw what?", WEAPON);
  SetDirArrow(-1);
  if (wch==CANCEL) return;



  if (!(weapon = get_letter_object(wch))) {message("no such item."); return;}
  if ((weapon->in_use_flags & BEING_USED) && weapon->is_cursed) {message(curse_message); return;}

  row = rogue.row; col = rogue.col;

  if ((weapon->in_use_flags & BEING_WIELDED) && (weapon->quantity <= 1)) {unwield(rogue.weapon);}
  else if (weapon->in_use_flags & BEING_WORN)
  {
    mv_aquatars();

    PlayAudio("ArmorSound");

    unwear(rogue.armor);
  }
  else if (weapon->in_use_flags & ON_EITHER_HAND) {un_put_on(weapon);}
  monster = get_thrown_at_monster(weapon, d, &row, &col);
  mvaddch(rogue.row, rogue.col, rogue.fchar);

  if (rogue_can_see(row, col) && ((row != rogue.row) || (col != rogue.col))) {mvaddch(row, col, get_dungeon_char(row, col));}
  if (monster)
  {
    wake_up(monster);
    check_gold_seeker(monster);

    if (!throw_at_monster(monster, weapon)) {flop_weapon(weapon, row, col);}
  }
  else {flop_weapon(weapon, row, col);}
  vanish(weapon, 1, &rogue.pack);
}



boolean throw_at_monster(object *monster, object *weapon)
{
  short damage, hit_chance;
  short t;

  hit_chance = get_hit_chance(weapon);
  damage = get_weapon_damage(weapon);
  if ((weapon->which_kind == ARROW) && (rogue.weapon && (rogue.weapon->which_kind == BOW)))
  {
    damage += get_weapon_damage(rogue.weapon);
    damage = ((damage * 2) / 3);
    hit_chance += (hit_chance / 3);
  }
  else if ((weapon->in_use_flags & BEING_WIELDED) && ((weapon->which_kind == DAGGER) || (weapon->which_kind == SHURIKEN) || (weapon->which_kind == DART)))
  {
    damage = ((damage * 3) / 2);
    hit_chance += (hit_chance / 3);
  }
  t = weapon->quantity;
  weapon->quantity = 1;
  sprintf(hit_message, "the %s", name_of(weapon));
  weapon->quantity = t;

  if (!rand_percent(hit_chance))
  {
    PlayAudio("RogueMissSound");

    (void) strcat(hit_message, "misses  ");
    return(0);
  }

  s_con_mon(monster);
  (void) strcat(hit_message, "hit  ");
  (void) mon_damage(monster, damage);
  return(1);
}



object *get_thrown_at_monster(object *obj, short dir, short *row, short *col)
{
  short orow, ocol, i, ch;

  orow = *row; ocol = *col;

  ch = get_mask_char(obj->what_is);

  for (i=0; i<24; i++)
  {
    get_dir_rc(dir, row, col, 0);
    if ((((*col <= 0) || (*col >= DCOLS-1)) || (dungeon[*row][*col] == NOTHING)) || ((dungeon[*row][*col] & (HORWALL | VERTWALL | HIDDEN)) && (!(dungeon[*row][*col] & TRAP)))) {*row = orow; *col = ocol; return 0;}

    if ((i != 0) && rogue_can_see(orow, ocol)) mvaddch(orow, ocol, get_dungeon_char(orow, ocol));
    if (rogue_can_see(*row, *col)) if (!(dungeon[*row][*col] & MONSTER)) mvaddch(*row, *col, ch);

    orow = *row; ocol = *col;



    MovingObj_row = *row; MovingObj_col = *col; MovingObj_which_kind = obj->which_kind;
    tick_pause();
    MovingObj_row = -1; MovingObj_col = -1; MovingObj_which_kind = 65535;



    if (dungeon[*row][*col] & MONSTER) if (!imitating(*row, *col)) return object_at(&level_monsters, *row, *col);

    if (dungeon[*row][*col] & TUNNEL) i += 2;
  }

  return 0;
}



void flop_weapon(object *weapon, short row, short col)
{
  object *new_weapon, *monster;
  short i = 0;
  char msg[80];
  boolean found = 0;
  short mch, dch;
  unsigned short mon;

  while ((i < 9) && dungeon[row][col] & ~(FLOOR | TUNNEL | DOOR | MONSTER))
  {
    rand_around(i++, &row, &col);
    if ((row > (DROWS-2)) || (row < MIN_ROW) || (col > (DCOLS-1)) || (col < 0) || (!dungeon[row][col]) || (dungeon[row][col] & ~(FLOOR | TUNNEL | DOOR | MONSTER))) {continue;}
    found = 1;
    break;
  }

  if (found || (i == 0))
  {
    new_weapon = alloc_object();
    *new_weapon = *weapon;
    new_weapon->in_use_flags = NOT_USED;
    new_weapon->quantity = 1;
    new_weapon->ichar = 'L';
    place_at(new_weapon, row, col);
    if (rogue_can_see(row, col) && ((row != rogue.row) || (col != rogue.col)))
    {
      mon = dungeon[row][col] & MONSTER;
      dungeon[row][col] &= (~MONSTER);
      dch = get_dungeon_char(row, col);
      if (mon)
      {
        mch = mvinch(row, col);
        if ((monster = object_at(&level_monsters, row, col)) != NULL) {monster->trail_char = dch;}
        if ((mch < 'A') || (mch > 'Z')) {mvaddch(row, col, dch);}
      }
      else {mvaddch(row, col, dch);}
      dungeon[row][col] |= mon;
    }
  }
  else
  {
    short t;

    t = weapon->quantity;
    weapon->quantity = 1;
    sprintf(msg, "the %svanishes as it hits the ground", name_of(weapon));
    weapon->quantity = t;
    message(msg);
  }
}



void rand_around(short i, short *r, short *c)
{
  static char pos[] = "\010\007\001\003\004\005\002\006\0";
  static short row, col;
  short j;

  if (i == 0)
  {
    short x, y, o, t;

    row = *r;
    col = *c;

    o = get_rand(1, 8);

    for (j = 0; j < 5; j++)
    {
      x = get_rand(0, 8);
      y = (x + o) % 9;
      t = pos[x];
      pos[x] = pos[y];
      pos[y] = t;
    }
  }
  switch((short)pos[i])
  {
    case 0: *r = row + 1; *c = col + 1; break;
    case 1: *r = row + 1; *c = col - 1; break;
    case 2: *r = row - 1; *c = col + 1; break;
    case 3: *r = row - 1; *c = col - 1; break;
    case 4: *r = row; *c = col + 1; break;
    case 5: *r = row + 1; *c = col; break;
    case 6: *r = row; *c = col; break;
    case 7: *r = row - 1; *c = col; break;
    case 8: *r = row; *c = col - 1; break;
  }
}
//****************************************************************************



//****************************************************************************
//trap.c

short trap_at(int row, int col)
{
  short i;

  for (i = 0; ((i < MAX_TRAPS) && (traps[i].trap_type != NO_TRAP)); i++)
  {
    if ((traps[i].trap_row == row) && (traps[i].trap_col == col)) {return(traps[i].trap_type);}
  }
  return(NO_TRAP);
}



void trap_player(short row, short col)
{
  short t;

  if ((t = trap_at(row, col)) == NO_TRAP) {return;}
  dungeon[row][col] &= (~HIDDEN);
  if (rand_percent(rogue.exp + ring_exp))
  {
    message("the trap failed");
    interrupted = 1;
    return;
  }

  PlayAudio("TrapSound");

  switch(t)
  {
    case TRAP_DOOR:
      trap_door = 1;
      new_level_message = trap_strings[(t*2)+1];
    break;
    case BEAR_TRAP:
      message(trap_strings[(t*2)+1]);
      interrupted = 1;
      bear_trap = get_rand(4, 7);
    break;
    case TELE_TRAP:
      mvaddch(rogue.row, rogue.col, '^');
      tele();
    break;
    case DART_TRAP:
      message(trap_strings[(t*2)+1]);
      interrupted = 1;
      rogue.hp_current -= get_damage("1d6", 1);
      if (rogue.hp_current <= 0) {rogue.hp_current = 0;}
      if ((!sustain_strength) && rand_percent(40) && (rogue.str_current >= 3)) {rogue.str_current--;}
      if (rogue.hp_current <= 0) {killed_by((object *) 0, POISON_DART);}
    break;
    case SLEEPING_GAS_TRAP:
      message(trap_strings[(t*2)+1]);
      interrupted = 1;
      take_a_nap();
    break;
    case RUST_TRAP:
      message(trap_strings[(t*2)+1]);
      interrupted = 1;
      rust((object *) 0);
    break;
  }
}



void add_traps(void)
{
  short i, n, tries = 0;
  short row, col;

  if (cur_level <= 2) {n = 0;}
  else if (cur_level <= 7) {n = get_rand(0, 2);}
  else if (cur_level <= 11) {n = get_rand(1, 2);}
  else if (cur_level <= 16) {n = get_rand(2, 3);}
  else if (cur_level <= 21) {n = get_rand(2, 4);}
  else if (cur_level <= (AMULET_LEVEL + 2)) {n = get_rand(3, 5);}
  else {n = get_rand(5, MAX_TRAPS);}
  for (i = 0; i < n; i++)
  {
    traps[i].trap_type = get_rand(0, (TRAPS - 1));

    if ((i == 0) && (party_room != NO_ROOM))
    {
      do
      {
        row = get_rand((rooms[party_room].top_row+1), (rooms[party_room].bottom_row-1));
        col = get_rand((rooms[party_room].left_col+1), (rooms[party_room].right_col-1));
        tries++;
      } while (((dungeon[row][col] & (OBJECT|STAIRS|TRAP|TUNNEL)) || (dungeon[row][col] == NOTHING)) && (tries < 15));
      if (tries >= 15) {gr_row_col(&row, &col, (FLOOR | MONSTER));}
    }
    else {gr_row_col(&row, &col, (FLOOR | MONSTER));}
    traps[i].trap_row = row;
    traps[i].trap_col = col;
    dungeon[row][col] |= (TRAP | HIDDEN);
  }
}



void id_trap(void)
{
  short dir, row, col, d, t;



  message("direction?");
  SetDirArrow(8);
  while (!is_direction(dir = rgetchar(), &d)) sound_bell();
  SetDirArrow(-1);
  if (dir==CANCEL) return;



  row = rogue.row; col = rogue.col;

  get_dir_rc(d, &row, &col, 0);

  if ((dungeon[row][col] & TRAP) && (!(dungeon[row][col] & HIDDEN)))
  {
    t = trap_at(row, col);
    message(trap_strings[t*2]);
  }
  else {message("no trap there");}
}



void show_traps(void)
{
  short i, j;

  for (i = 0; i < DROWS; i++)
  {
    for (j = 0; j < DCOLS; j++)
    {
      if (dungeon[i][j] & TRAP) {mvaddch(i, j, '^');}
    }
  }
}



void search(short n, boolean is_auto)
{
  short s, i, j, row, col, t;
  short shown = 0, found = 0;
  static boolean reg_search;

  for (i = -1; i <= 1; i++)
  {
    for (j = -1; j <= 1; j++)
    {
      row = rogue.row + i;
      col = rogue.col + j;
      if ((row < MIN_ROW) || (row >= (DROWS-1)) || (col < 0) || (col >= DCOLS)) {continue;}
      if (dungeon[row][col] & HIDDEN) {found++;}
    }
  }

  for (s = 0; s < n; s++)
  {
    for (i = -1; i <= 1; i++)
    {
      for (j = -1; j <= 1; j++)
      {
        row = rogue.row + i;
        col = rogue.col + j ;
        if ((row < MIN_ROW) || (row >= (DROWS-1)) || (col < 0) || (col >= DCOLS)) {continue;}
        if (dungeon[row][col] & HIDDEN)
        {
          if (rand_percent(17 + (rogue.exp + ring_exp)))
          {
            dungeon[row][col] &= (~HIDDEN);
            if ((!blind) && ((row != rogue.row) || (col != rogue.col))) {mvaddch(row, col, get_dungeon_char(row, col));}
            shown++;
            if (dungeon[row][col] & TRAP)
            {
              t = trap_at(row, col);
              message(trap_strings[t*2]);
              interrupted = 1;
            }
          }
        }
        if (((shown == found) && (found > 0)) || interrupted) {return;}
      }
    }
    if ((!is_auto) && (reg_search = !reg_search)) {(void) reg_move();}



    if (!is_auto)
    {
      if (PrefixCount>0) PrefixCount--;
      if (n>1) if (tick_pause()) break;
    }
  }
}
//****************************************************************************



//****************************************************************************
//use.c

void quaff(void)
{
  short ch;
  char buf[80];
  object *obj;

  ch = pack_letter("quaff what?", POTION);

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (obj->what_is != POTION)
  {
    message("you can't drink that");
    return;
  }

  PlayAudio("EatSound");

  switch(obj->which_kind)
  {
    case INCREASE_STRENGTH:
      message("you feel stronger now, what bulging muscles!");

      rogue.str_current++;
      if (rogue.str_current>MAX_STRENGTH) rogue.str_current = MAX_STRENGTH;

      if (rogue.str_current > rogue.str_max) {rogue.str_max = rogue.str_current;}
    break;
    case RESTORE_STRENGTH:
      rogue.str_current = rogue.str_max;
      message("this tastes great, you feel warm all over");
    break;
    case HEALING:
      message("you begin to feel better");
      potion_heal(0);
    break;
    case EXTRA_HEALING:
      message("you begin to feel much better");
      potion_heal(1);
    break;
    case POISON:
      if (!sustain_strength)
      {
        rogue.str_current -= get_rand(1, 3);
        if (rogue.str_current < 1) {rogue.str_current = 1;}
      }
      message("you feel very sick now");
      if (halluc) {unhallucinate();}
    break;
    case RAISE_LEVEL:
      rogue.exp_points = level_points[rogue.exp - 1];
      message("you suddenly feel much more skillful");
      add_exp(1, 1);
    break;
    case BLINDNESS:
      go_blind();
    break;
    case HALLUCINATION:
      message("oh wow, everything seems so cosmic");
      halluc += get_rand(500, 800);
    break;
    case DETECT_MONSTER:
      show_monsters();
      if (!(level_monsters.next_monster)) {message(strange_feeling);}
    break;
    case DETECT_OBJECTS:
      if (level_objects.next_object)
      {
        if (!blind) {show_objects();}
      }
      else {message(strange_feeling);}
    break;
    case CONFUSION:
      message((halluc ? "what a trippy feeling" : "you feel confused"));
      cnfs();
    break;
    case LEVITATION:
      message("you start to float in the air");
      levitate += get_rand(15, 30);
      being_held = bear_trap = 0;
    break;
    case HASTE_SELF:
      message("you feel yourself moving much faster");
      haste_self += get_rand(11, 21);
      if (!(haste_self % 2)) {haste_self++;}
    break;
    case SEE_INVISIBLE:
      sprintf(buf, "hmm, this potion tastes like %sjuice", fruit);
      message(buf);
      if (blind) {unblind();}
      see_invisible = 1;
      relight();
    break;
  }
  if (id_potions[obj->which_kind].id_status != CALLED) {id_potions[obj->which_kind].id_status = IDENTIFIED;}
  vanish(obj, 1, &rogue.pack);
}



void read_scroll(void)
{
  short ch;
  object *obj;
  char msg[DCOLS];

  ch = pack_letter("read what?", SCROL);

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (obj->what_is != SCROL)
  {
    message("you can't read that");
    return;
  }
  switch(obj->which_kind)
  {
    case SCARE_MONSTER:
      message("you hear a maniacal laughter in the distance");
    break;
    case HOLD_MONSTER:
      hold_monster();
    break;
    case ENCH_WEAPON:
      if (rogue.weapon)
      {
        if (rogue.weapon->what_is == WEAPON)
        {
          sprintf(msg, "your %sglow%s %sfor a moment", name_of(rogue.weapon), ((rogue.weapon->quantity <= 1) ? "s" : ""), get_ench_color());
          message(msg);
          if (coin_toss()) {rogue.weapon->hit_enchant++;}
          else {rogue.weapon->d_enchant++;}
        }
        rogue.weapon->is_cursed = 0;
      }
      else {message("your hands tingle");}
    break;
    case ENCH_ARMOR:
      if (rogue.armor)
      {
        sprintf(msg, "your armor glows %sfor a moment", get_ench_color());
        message(msg);

        rogue.armor->d_enchant++;
        if (rogue.armor->d_enchant>MAX_ARMOR) rogue.armor->d_enchant = MAX_ARMOR;

        rogue.armor->is_cursed = 0;
      }
      else {message("your skin crawls");}
    break;
    case IDENTIFY:
      message("this is a scroll of identify");
      obj->identified = 1;
      id_scrolls[obj->which_kind].id_status = IDENTIFIED;
      idntfy();
    break;
    case TELEPORT:
      tele();
    break;
    case SLEEP:
      message("you fall asleep");
      take_a_nap();
    break;
    case PROTECT_ARMOR:
      if (rogue.armor)
      {
        message("your armor is covered by a shimmering gold shield");
        rogue.armor->is_protected = 1;
        rogue.armor->is_cursed = 0;
      }
      else {message("your acne seems to have disappeared");}
    break;
    case REMOVE_CURSE:
      message((!halluc) ? "you feel as though someone is watching over you" : "you feel in touch with the universal oneness");
      uncurse_all();
    break;
    case CREATE_MONSTER:
      create_monster();
    break;
    case AGGRAVATE_MONSTER:
      aggravate();
    break;
    case MAGIC_MAPPING:
      message("this scroll seems to have a map on it");
      draw_magic_map();
    break;
    case CON_MON:
      con_mon = 1;
      sprintf(msg, "your hands glow %sfor a moment", get_ench_color());
      message(msg);
    break;
  }
  if (id_scrolls[obj->which_kind].id_status != CALLED) {id_scrolls[obj->which_kind].id_status = IDENTIFIED;}
  vanish(obj, (obj->which_kind != SLEEP), &rogue.pack);
}



//vanish() does NOT handle a quiver of weapons with more than one
//arrow (or whatever) in the quiver.  It will only decrement the count.

void vanish(object *obj, short rm, object *pack)
{
  if (obj->quantity > 1) {obj->quantity--;}
  else
  {
    if (obj->in_use_flags & BEING_WIELDED) {unwield(obj);}
    else if (obj->in_use_flags & BEING_WORN) {unwear(obj);}
    else if (obj->in_use_flags & ON_EITHER_HAND) {un_put_on(obj);}
    take_from_pack(obj, pack);
    free_object(obj);
  }
  if (rm) {(void) reg_move();}
}



void potion_heal(int extra)
{
  float ratio;
  short add;

  rogue.hp_current += rogue.exp;

  ratio = ((float)rogue.hp_current) / rogue.hp_max;

  if (ratio >= 1.00)
  {
    rogue.hp_max += (extra ? 2 : 1);
    if (rogue.hp_max>MAX_HP) rogue.hp_max = MAX_HP;

    extra_hp += (extra ? 2 : 1);
    rogue.hp_current = rogue.hp_max;
  }
  else if (ratio >= 0.90)
  {
    rogue.hp_max += (extra ? 1 : 0);
    if (rogue.hp_max>MAX_HP) rogue.hp_max = MAX_HP;

    extra_hp += (extra ? 1 : 0);
    rogue.hp_current = rogue.hp_max;
  }
  else
  {
    if (ratio < 0.33) {ratio = (float)0.33;}
    if (extra) {ratio += ratio;}
    add = (short)(ratio * ((float)rogue.hp_max - rogue.hp_current));
    rogue.hp_current += add;
    if (rogue.hp_current > rogue.hp_max) {rogue.hp_current = rogue.hp_max;}
  }
  if (blind) {unblind();}
  if (confused && extra) {unconfuse();}
  else if (confused) {confused = (confused / 2) + 1;}
  if (halluc && extra) {unhallucinate();}
  else if (halluc) {halluc = (halluc / 2) + 1;}
}



void idntfy(void)
{
  short ch;
  object *obj;
  struct id *id_table;
  char desc[DCOLS];

AGAIN:
  ch = pack_letter("what would you like to identify?", ALL_OBJECTS);

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item, try again");
    message("");
    goto AGAIN;
  }
  obj->identified = 1;
  if (obj->what_is & (SCROL | POTION | WEAPON | ARMOR | WAND | RING))
  {
    id_table = get_id_table(obj);
    id_table[obj->which_kind].id_status = IDENTIFIED;
  }
  get_desc(obj, desc);
  message(desc);
}



void eat(void)
{
  short ch;
  short moves;
  object *obj;
  char buf[70];

  ch = pack_letter("eat what?", FOOD);

  if (ch == CANCEL) {return;}
  if (!(obj = get_letter_object(ch)))
  {
    message("no such item.");
    return;
  }
  if (obj->what_is != FOOD)
  {
    message("you can't eat that");
    return;
  }

  PlayAudio("EatSound");

  if ((obj->which_kind == FRUIT) || rand_percent(60))
  {
    moves = get_rand(950, 1150);
    if (obj->which_kind == RATION) {message("yum, that tasted good");}
    else
    {
      sprintf(buf, "my, that was a yummy %s", fruit);
      message(buf);
    }
  }
  else
  {
    moves = get_rand(750, 950);
    message("yuk, that food tasted awful");
    add_exp(2, 1);
  }
  rogue.moves_left /= 3;
  rogue.moves_left += moves;
  hunger_str[0] = 0;

  vanish(obj, 1, &rogue.pack);
}



void hold_monster(void)
{
  short i, j;
  short mcount = 0;
  object *monster;
  short row, col;

  for (i = -2; i <= 2; i++)
  {
    for (j = -2; j <= 2; j++)
    {
      row = rogue.row + i;
      col = rogue.col + j;
      if ((row < MIN_ROW) || (row > (DROWS-2)) || (col < 0) || (col > (DCOLS-1))) {continue;}
      if (dungeon[row][col] & MONSTER)
      {
        monster = object_at(&level_monsters, row, col);
        monster->m_flags |= ASLEEP;
        monster->m_flags &= (~WAKENS);
        mcount++;
      }
    }
  }
  if (mcount == 0) {message("you feel a strange sense of loss");}
  else if (mcount == 1) {message("the monster freezes");}
  else {message("the monsters around you freeze");}
}



void tele(void)
{
  PlayAudio("TeleportSound");

  mvaddch(rogue.row, rogue.col, get_dungeon_char(rogue.row, rogue.col));

  if (cur_room >= 0) {darken_room(cur_room);}
  put_player(get_room_number(rogue.row, rogue.col));
  being_held = 0;
  bear_trap = 0;
}



void hallucinate(void)
{
  object *obj, *monster;
  short ch;

  if (blind) return;

  obj = level_objects.next_object;

  while (obj)
  {
    ch = mvinch(obj->row, obj->col);
    if (((ch < 'A') || (ch > 'Z')) && ((obj->row != rogue.row) || (obj->col != rogue.col)))
      if ((ch != ' ') && (ch != '.') && (ch != '#') && (ch != '+')) {mvaddch(obj->row, obj->col, gr_obj_char());}
    obj = obj->next_object;
  }
  monster = level_monsters.next_monster;

  while (monster)
  {
    ch = mvinch(monster->row, monster->col);
    if ((ch >= 'A') && (ch <= 'Z')) {mvaddch(monster->row, monster->col, get_rand('A', 'Z'));}
    monster = monster->next_monster;
  }
}



void unhallucinate(void)
{
  halluc = 0;
  relight();
  message("everything looks SO boring now");
  interrupted = 1;
}



void unblind(void)
{
  blind = 0;
  message("the veil of darkness lifts");
  interrupted = 1;
  relight();
  if (halluc) {hallucinate();}
  if (detect_monster) {show_monsters();}
}



void relight(void)
{
  if (cur_room == PASSAGE) {light_passage(rogue.row, rogue.col);}
  else {light_up_room(cur_room);}
  mvaddch(rogue.row, rogue.col, rogue.fchar);
}



void take_a_nap(void)
{
  short i;

  i = get_rand(2, 5);

  while (i--) {mv_mons();}

  message(you_can_move_again);
}



void go_blind(void)
{
  short i, j;

  if (!blind) {message("a cloak of darkness falls around you");}
  blind += get_rand(500, 800);

  if (detect_monster)
  {
    object *monster;

    monster = level_monsters.next_monster;

    while (monster)
    {
      mvaddch(monster->row, monster->col, monster->trail_char);
      monster = monster->next_monster;
    }
  }
  if (cur_room >= 0)
  {
    for (i = rooms[cur_room].top_row + 1; i < rooms[cur_room].bottom_row; i++)
    {
      for (j = rooms[cur_room].left_col + 1; j < rooms[cur_room].right_col; j++) {mvaddch(i, j, ' ');}
    }
  }
  mvaddch(rogue.row, rogue.col, rogue.fchar);
}



const char *get_ench_color(void)
{
  if (halluc) {return(id_potions[get_rand(0, POTIONS-1)].title);}
  else if (con_mon) {return("red ");}
  return("blue ");
}



void cnfs(void)
{
  confused += get_rand(12, 22);
}



void unconfuse(void)
{
  char msg[80];

  confused = 0;
  sprintf(msg, "you feel less %s now", (halluc ? "trippy" : "confused"));
  message(msg);
  interrupted = 1;
}



void uncurse_all(void)
{
  object *obj;

  obj = rogue.pack.next_object;

  while (obj)
  {
    obj->is_cursed = 0;
    obj = obj->next_object;
  }
}
//****************************************************************************



//****************************************************************************
//zap.c

void zapp(void)
{
  short wch;
  object *wand;
  short dir, d, row, col;
  object *monster;



  message("direction?");
  SetDirArrow(8);
  while (!is_direction(dir = rgetchar(), &d)) sound_bell();
  if (dir==CANCEL) {SetDirArrow(-1); return;}
  SetDirArrow(d);
  wch = pack_letter("zap with what?", WAND);
  SetDirArrow(-1);
  if (wch==CANCEL) return;



  if (!(wand = get_letter_object(wch))) {message("no such item."); return;}
  if (wand->what_is != WAND) {message("you can't zap with that"); return;}
  if (wand->class <= 0) {message("nothing happens");}
  else
  {
    PlayAudio("ZapSound");

    wand->class--;
    row = rogue.row; col = rogue.col;
    if ((wand->which_kind == COLD) || (wand->which_kind == FIRE))
    {
      if (wand->which_kind == COLD) PlayAudio("IceSound"); else PlayAudio("FireSound");

      bounce((short) wand->which_kind, d, row, col, 0);
    }
    else
    {
      monster = get_zapped_monster(d, &row, &col);
      if (wand->which_kind == DRAIN_LIFE) {wdrain_life(monster);}
      else if (monster)
      {
        wake_up(monster);
        s_con_mon(monster);
        zap_monster(monster, wand->which_kind);
        relight();
      }
    }
  }
  (void) reg_move();
}



object *get_zapped_monster(short dir, short *row, short *col)
{
  short orow, ocol;

  for (;;)
  {
    orow = *row; ocol = *col;
    get_dir_rc(dir, row, col, 0);
    if (((*row == orow) && (*col == ocol)) || (dungeon[*row][*col] & (HORWALL | VERTWALL)) || (dungeon[*row][*col] == NOTHING)) {return(0);}
    if (dungeon[*row][*col] & MONSTER)
    {
      if (!imitating(*row, *col)) {return(object_at(&level_monsters, *row, *col));}
    }
  }
}



void zap_monster(object *monster, unsigned short kind)
{
  short row, col;
  object *nm;
  short tc;

  row = monster->row;
  col = monster->col;

  switch(kind)
  {
    case SLOW_MONSTER:
      if (monster->m_flags & HASTED) {monster->m_flags &= (~HASTED);}
      else
      {
        monster->slowed_toggle = 0;
        monster->m_flags |= SLOWED;
      }
    break;
    case HASTE_MONSTER:
      if (monster->m_flags & SLOWED) {monster->m_flags &= (~SLOWED);}
      else {monster->m_flags |= HASTED;}
    break;
    case TELE_AWAY:
      tele_away(monster);
    break;
    case INVISIBILITY:
      monster->m_flags |= INVISIBLE;
    break;
    case POLYMORPH:
      if (monster->m_flags & HOLDS) {being_held = 0;}
      nm = monster->next_monster;
      tc = monster->trail_char;
      (void) gr_monster(monster, get_rand(0, MONSTERS-1));
      monster->row = row;
      monster->col = col;
      monster->next_monster = nm;
      monster->trail_char = tc;
      if (!(monster->m_flags & IMITATES)) {wake_up(monster);}
    break;
    case MAGIC_MISSILE:
      rogue_hit(monster, 1);
    break;
    case CANCELLATION:
      if (monster->m_flags & HOLDS) {being_held = 0;}
      if (monster->m_flags & STEALS_ITEM) {monster->drop_percent = 0;}
      monster->m_flags &= (~(FLIES | FLITS | SPECIAL_HIT | INVISIBLE | FLAMES | IMITATES | CONFUSES | SEEKS_GOLD | HOLDS));
    break;
    case DO_NOTHING:
      message("nothing happens");
    break;
  }
}



void tele_away(object *monster)
{
  short row, col;

  PlayAudio("TeleportSound");

  if (monster->m_flags & HOLDS) {being_held = 0;}
  gr_row_col(&row, &col, (FLOOR | TUNNEL | STAIRS | OBJECT));
  mvaddch(monster->row, monster->col, monster->trail_char);
  dungeon[monster->row][monster->col] &= ~MONSTER;
  monster->row = row; monster->col = col;
  dungeon[row][col] |= MONSTER;
  monster->trail_char = mvinch(row, col);
  if (detect_monster || rogue_can_see(row, col)) {mvaddch(row, col, gmc(monster));}
}



void wizardize(void)
{
  char buf[100];

  if (wizard) {wizard = 0; message("not wizard anymore");}
  else
  {
    if (get_input_line("wizard's password:", "", buf, "", 0, 0))
    {
      if (!strncmp(buf, "wizard", 6)) {wizard = 1; message("Welcome, mighty wizard!");}
      else message("sorry");
    }
  }
}



void wdrain_life(object *monster)
{
  short hp;
  object *lmon, *nm;

  hp = rogue.hp_current / 3;
  rogue.hp_current = (rogue.hp_current + 1) / 2;

  if (cur_room >= 0)
  {
    lmon = level_monsters.next_monster;
    while (lmon)
    {
      nm = lmon->next_monster;
      if (get_room_number(lmon->row, lmon->col) == cur_room)
      {
        wake_up(lmon);
        (void) mon_damage(lmon, hp);
      }
      lmon = nm;
    }
  }
  else
  {
    if (monster)
    {
      wake_up(monster);
      (void) mon_damage(monster, hp);
    }
  }
  relight();
}



void bounce(short ball, short dir, short row, short col, short r)
{
  short orow, ocol;
  char buf[DCOLS];
  const char *s;
  short i, ch, new_dir = -1, damage;

  static short btime;

  if (++r==1) btime = get_rand(3, 6); else if (r>btime) return;

  if (ball==FIRE) s = "fire"; else s = "ice";

  if (r>1) {sprintf(buf, "the %s bounces", s); message(buf);}



  do
  {
    ch = mvinch(row, col);
    mvaddch(row, col, ball==FIRE?'0':'1'); //'0' and '1' chars represent fire and ice tiles, respectively
    tick_pause();
    mvaddch(row, col, ch);



    orow = row; ocol = col; get_dir_rc(dir, &row, &col, 1);
  } while (!( (col <= 0) || (col >= DCOLS-1) || (dungeon[row][col] == NOTHING) || (dungeon[row][col] & MONSTER) || (dungeon[row][col] & (HORWALL | VERTWALL)) || ((row == rogue.row) && (col == rogue.col))));



  if (dungeon[row][col] & MONSTER)
  {
    object *monster;

    monster = object_at(&level_monsters, row, col);

    wake_up(monster);

    if (rand_percent(33))
    {
      sprintf(buf, "the %s misses the %s", s, mon_name(monster));
      message(buf);
      goto ND;
    }

    if (ball == FIRE)
    {
      if (!(monster->m_flags & RUSTS))
      {
        if (monster->m_flags & FREEZES) {damage = monster->hp_to_kill;}
        else if (monster->m_flags & FLAMES) {damage = (monster->hp_to_kill / 10) + 1;}
        else {damage = get_rand((rogue.hp_current / 3), rogue.hp_max);}
      }
      else {damage = (monster->hp_to_kill / 2) + 1;}

      sprintf(buf, "the %s hits the %s", s, mon_name(monster));
      message(buf);

      (void) mon_damage(monster, damage);
    }
    else
    {
      damage = -1;

      if (!(monster->m_flags & FREEZES))
      {
        if (rand_percent(33))
        {
          PlayAudio("IceSound");

          message("the monster is frozen");

          monster->m_flags |= (ASLEEP | NAPPING);
          monster->nap_length = get_rand(3, 6);
        }
        else {damage = rogue.hp_current / 4;}
      }
      else {damage = -2;}

      if (damage != -1)
      {
        sprintf(buf, "the %s hits the %s", s, mon_name(monster));
        message(buf);

        (void) mon_damage(monster, damage);
      }
    }
  }
  else if ((row == rogue.row) && (col == rogue.col))
  {
    if (rand_percent(10 + (3 * get_armor_class(rogue.armor))))
    {
      sprintf(buf, "the %s misses", s);
      message(buf);

      goto ND;
    }
    else
    {
      PlayAudio("MonsterHitSound");

      damage = get_rand(3, (3 * rogue.exp));

      if (ball == FIRE)
      {
        damage = (damage * 3) / 2;
        damage -= get_armor_class(rogue.armor);
      }

      sprintf(buf, "the %s hits", s);

      rogue_damage(damage, (object *) 0, ((ball == FIRE) ? KFIRE : HYPOTHERMIA));

      message(buf);
    }
  }
  else
  {
    short nrow, ncol;

ND:
    for (i = 0; i < 10; i++)
    {
      dir = get_rand(0, DIRS-1);

      nrow = orow;
      ncol = ocol;

      get_dir_rc(dir, &nrow, &ncol, 1);

      if (((ncol >= 0) && (ncol <= DCOLS-1)) && (dungeon[nrow][ncol] != NOTHING) && (!(dungeon[nrow][ncol] & (VERTWALL | HORWALL))))
      {
        new_dir = dir;
        break;
      }
    }

    if (new_dir != -1) {bounce(ball, new_dir, orow, ocol, r);}
  }
}
//****************************************************************************



//***************************************************************************
#define OBJHEAP_SIZE  1000



object objheap[OBJHEAP_SIZE];
char objheap_flags[OBJHEAP_SIZE];



object *alloc_object(void)
{
  int i;
  object *obj;

  static int init = 0;
  if (init==0) {init = 1; memset(objheap_flags, 0, OBJHEAP_SIZE);}

  for (i=0; i<OBJHEAP_SIZE; i++) if (objheap_flags[i]==0) break;
  if (i==OBJHEAP_SIZE) clean_up("Error: alloc_object() failed");
  objheap_flags[i] = 1; obj = objheap+i;

  //init object
  obj->quantity = 1;
  obj->ichar = 'L';
  obj->picked_up = obj->is_cursed = 0;
  obj->in_use_flags = NOT_USED;
  obj->identified = UNIDENTIFIED;
  obj->damage = "1d1";

  return obj;
}



void free_object(object *obj)
{
  int i;

  for (i=0; i<OBJHEAP_SIZE; i++) if (obj==objheap+i) break;
  if (i==OBJHEAP_SIZE) clean_up("Error: free_object() failed");
  objheap_flags[i] = 0;
}
//***************************************************************************



//****************************************************************************
//score.c

void win(void)
{
  WarningOnClose = 2;



  unwield(rogue.weapon); //disarm and relax
  unwear(rogue.armor);
  un_put_on(rogue.left_ring);
  un_put_on(rogue.right_ring);

  id_all();
  sell_pack();



  PlayAudio("WinSound");

  draw_win();

  put_scores((object *) 0, WIN);
}



void quit(void)
{
  message("really quit?");

  interrupted = 1;

  if (rgetchar() != 'y') {return;}

  killed_by((object *) 0, QUIT);
}



boolean is_vowel(short ch)
{
  return((ch == 'a') || (ch == 'e') || (ch == 'i') || (ch == 'o') || (ch == 'u'));
}



void sell_pack(void)
{
  object *obj;
  short val;
  char buf[DCOLS];

  message("Value      Item");

  obj = rogue.pack.next_object; while (obj)
  {
    if (obj->what_is != FOOD)
    {
      obj->identified = 1;
      val = get_value(obj);

      rogue.gold += val;
      if (rogue.gold>MAX_GOLD) rogue.gold = MAX_GOLD;

      sprintf(buf, "%5d      ", val);
      get_desc(obj, buf+11);
      message(buf);
    }

    obj = obj->next_object;
  }
}



int get_value(const object *obj)
{
  short wc;
  int val;

  val = 0;
  wc = obj->which_kind;

  switch(obj->what_is)
  {
    case WEAPON:
      val = id_weapons[wc].value;
      if ((wc == ARROW) || (wc == DAGGER) || (wc == SHURIKEN) || (wc == DART)) {val *= obj->quantity;}
      val += (obj->d_enchant * 85);
      val += (obj->hit_enchant * 85);
    break;
    case ARMOR:
      val = id_armors[wc].value;
      val += (obj->d_enchant * 75);
      if (obj->is_protected) {val += 200;}
    break;
    case WAND:
      val = id_wands[wc].value * (obj->class + 1);
    break;
    case SCROL:
      val = id_scrolls[wc].value * obj->quantity;
    break;
    case POTION:
      val = id_potions[wc].value * obj->quantity;
    break;
    case AMULET:
      val = 5000;
    break;
    case RING:
      val = id_rings[wc].value * (obj->class + 1);
    break;
  }
  if (val <= 0) {val = 10;}
  return(val);
}



void id_all(void)
{
  short i;

  for (i = 0; i < SCROLS; i++) {id_scrolls[i].id_status = IDENTIFIED;}
  for (i = 0; i < WEAPONS; i++) {id_weapons[i].id_status = IDENTIFIED;}
  for (i = 0; i < ARMORS; i++) {id_armors[i].id_status = IDENTIFIED;}
  for (i = 0; i < WANDS; i++) {id_wands[i].id_status = IDENTIFIED;}
  for (i = 0; i < POTIONS; i++) {id_potions[i].id_status = IDENTIFIED;}
}
//****************************************************************************



//***************************************************************************
char buffer[DCOLS*DROWS];



void clear(void)
{
  memset(buffer, 32, DCOLS*DROWS);
}



void mvaddch(int row, int col, int ch)
{
  if (col<0 || col>=DCOLS) return;
  if (row<0 || row>=DROWS) return;

  buffer[row*DCOLS+col] = ch;
}



int mvinch(int row, int col)
{
  if (col<0 || col>=DCOLS) return 32;
  if (row<0 || row>=DROWS) return 32;

  return (buffer[row*DCOLS+col]);
}
//***************************************************************************



//****************************************************************************
//function used by DisplayContextMenu()



char *get_player_inv_for_context_menu(int init, int *ch)
{
  static object *obj;
  static char buf[128];

  obj = init?rogue.pack.next_object:obj->next_object;

  if (obj)
  {
    *ch = obj->ichar;

    buf[0] = obj->ichar;
    buf[1] = ((obj->what_is&ARMOR) && obj->is_protected)?'}':')';
    buf[2] = ' ';
    get_desc(obj, buf+3);

    return buf;
  }

  return 0;
}
//****************************************************************************
